/* 2010-08-25: File added by Sony Corporation */
/*
 *  File Name       : linux/arch/arm/mach-mp200/cache.c
 *  Function        : Level2 cache
 *  Release Version : Ver 1.00
 *  Release Date    : 2006/12/11
 *
 *  Copyright (C) NEC Electronics Corporation 2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/types.h>
#include <linux/module.h>

#include <asm/cacheflush.h>

void dmac_l2_inv_range(unsigned long start, unsigned long end)
{
	outer_inv_range(start, end);
}

void dmac_l2_clean_range(unsigned long start, unsigned long end)
{
	outer_clean_range(start, end);
}

void dmac_l2_flush_range(unsigned long start, unsigned long end)
{
	outer_flush_range(start, end);
}

void l2_flush_all(void)
{
	outer_flush_all();
}

void flush_cache_all_l2(void)
{
	flush_cache_all();
	outer_flush_all();
}

EXPORT_SYMBOL(dmac_l2_inv_range);
EXPORT_SYMBOL(dmac_l2_clean_range);
EXPORT_SYMBOL(dmac_l2_flush_range);
EXPORT_SYMBOL(l2_flush_all);
EXPORT_SYMBOL(flush_cache_all_l2);
