/* 2010-08-25: File added and changed by Sony Corporation */
/*
 *  File Name	    : linux/arch/arm/mach-mp200/pmu.h
 *  Function	    : pmu
 *  Release Version : Ver 0.10
 *  Release Date    : 2006/12/13
 *
 *  Copyright (C) NEC Electronics Corporation 2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __ARCH_ARM_MACH_MP200_PM_PMU_H
#define __ARCH_ARM_MACH_MP200_PM_PMU_H

#include <asm/arch/smu.h>
#include <asm/arch/gpio.h>
/*
 * Interrupt mask and unmask
 *
 */

/* INTC registers */
#define INTC_IT0_IEN0		   (VA_INTC + MP200_INTC_IT0_IEN0)
#define INTC_IT0_IEN1		   (VA_INTC + MP200_INTC_IT0_IEN1)
#define INTC_IT0_IEN2		   (VA_INTC + MP200_INTC_IT0_IEN2)
#define INTC_IT0_IDS0		   (VA_INTC + MP200_INTC_IT0_IDS0)
#define INTC_IT0_IDS1		   (VA_INTC + MP200_INTC_IT0_IDS1)
#define INTC_IT0_IDS2		   (VA_INTC + MP200_INTC_IT0_IDS2)
#define INTC_IT0_IMN0		   (VA_INTC + MP200_INTC_IT0_IMN0)
#define INTC_IT0_IMN1		   (VA_INTC + MP200_INTC_IT0_IMN1)
#define INTC_IT0_IMN2		   (VA_INTC + MP200_INTC_IT0_IMN2)
#define INTC_IT0_RAW0		   (VA_INTC + MP200_INTC_IT0_RAW0)
#define INTC_IT0_RAW1		   (VA_INTC + MP200_INTC_IT0_RAW1)
#define INTC_IT0_RAW2		   (VA_INTC + MP200_INTC_IT0_RAW2)
#define INTC_IT0_MST0		   (VA_INTC + MP200_INTC_IT0_MST0)
#define INTC_IT0_MST1		   (VA_INTC + MP200_INTC_IT0_MST1)
#define INTC_IT0_MST2		   (VA_INTC + MP200_INTC_IT0_MST2)

/* INTC parameters */
#define MASK_INTC_ALL		   0xffffffff
#define U70_INT			   (1 << (9 - 0))
#define PM0_INT			   (1 << (13 - 0))
#define PDMA_INT		   (1 << (19 - 0))
#define GIO7_INT		   (1 << (26 - 0))
#define GIO6_INT		   (1 << (27 - 0))
#define TG0_INT 		   (1 << (34 - 32))
#define TG1_INT 		   (1 << (35 - 32))
#define USB_SUSPEND_WAKEUP_INT	   (1 << (43 - 32))
#define TG3_INT 		   (1 << (44 - 32))
#define GIO0_INT		   (1 << (50 - 32))
#define GIO1_INT		   (1 << (51 - 32))
#define GIO2_INT		   (1 << (52 - 32))
#define GIO3_INT		   (1 << (53 - 32))
#define TI0_INT 		   (1 << (54 - 32))
#define TI1_INT 		   (1 << (55 - 32))
#define TI2_INT 		   (1 << (56 - 32))
#define TW1_INT 		   (1 << (59 - 32))
#define PMU_INT 		   (1 << (65 - 64))
#define STI_INT 		   (1 << (71 - 64))
#define AXL1_ERR_INT		   (1 << (88 - 64))
#define MEMC_ERR_INT		   (1 << (89 - 64))
#define AB0_ERR_INT		   (1 << (90 - 64))
#define PB1_ERR_INT		   (1 << (91 - 64))
#define SRC_ERR_INT		   (1 << (92 - 64))
#define AXL0_ERR_INT		   (1 << (93 - 64))
#define GIO4_INT		   (1 << (79 - 64))
#define GIO5_INT		   (1 << (80 - 64))

#define SEC_ERR_INT		   (PMU_INT | AXL1_ERR_INT | MEMC_ERR_INT | AB0_ERR_INT | \
				    PB1_ERR_INT | SRC_ERR_INT | AXL0_ERR_INT)

#define RESUME_INTC_1		   GIO0_INT

#define RESUME_INTC_2		   (STI_INT | SEC_ERR_INT)

/* GPIO registers */
/* GPIO 0-31 */
#define GPIO_GP_IENL		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_IENL)
#define GPIO_GP_RAWL		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_RAWL)
#define GPIO_GP_IDSL		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_IDSL)
#define GPIO_GP_IIML		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_IIML)
#define GPIO_GP_MSTL		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_MSTL)
/* GPIO 32-63 */
#define GPIO_GP_IENH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_IENH)
#define GPIO_GP_RAWH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_RAWH)
#define GPIO_GP_IDSH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_IDSH)
#define GPIO_GP_IIMH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_IIMH)
#define GPIO_GP_MSTH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_MSTH)
/* GPIO 64-95 */
#define GPIO_GP_IENHH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_IENHH)
#define GPIO_GP_RAWHH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_RAWHH)
#define GPIO_GP_IDSHH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_IDSHH)
#define GPIO_GP_IIMHH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_IIMHH)
#define GPIO_GP_MSTHH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_MSTHH)
/* GPIO 96-127 */
#define GPIO_GP_IENHHH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_IENHHH)
#define GPIO_GP_RAWHHH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_RAWHHH)
#define GPIO_GP_IDSHHH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_IDSHHH)
#define GPIO_GP_IIMHHH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_IIMHHH)
#define GPIO_GP_MSTHHH		   (IO_ADDRESS(MP200_GPIO_BASE) + GP_MSTHHH)

/* GPIO parameters */
#define MASK_GPIO_ALL		   0xFFFFFFFF
#define GPIO_INT_PWRIC		   (1 << 0)  /* P00 */

/* PowerIC GPIO parameters */
#define PWC_KEYDATA_0	0x01
#define PWC_KEYDATA_1	0x02
#define PWC_KEYDATA_2	0x04
#define PWC_KEYDATA_3	0x08
#define PWC_KEYSCAN_1	0x20
#define PWC_KEYSCAN_2	0x10

#define MASK_GPIO_KEYSCAN		(PWC_KEYSCAN_1 | PWC_KEYSCAN_2)

#define MASK_GPIO_KEYDATA		(PWC_KEYDATA_0 | PWC_KEYDATA_1 \
					 | PWC_KEYDATA_2 | PWC_KEYDATA_3)

#define MASK_GPIO_RESUME_KEY		(PWC_KEYSCAN_1 | PWC_KEYSCAN_2)
#define MASK_USBWAKINT				0x10
#define MASK_DETMODE3H_USBWKM		0x03
#define DETMODE3H_USBWKM_RISE		0x01

/* MEMC registers*/
#define MEMC_DDR_CONFIGR2	(IO_ADDRESS(MP200_MEMC_BASE) + 0x2018)
#define MEMC_DDR_CONFIGR3	(IO_ADDRESS(MP200_MEMC_BASE) + 0x201c)

/* WAKECONT */
#define WAKECONT_WAKEWAIT_DISABLE	0x01
#define MASK_WAKECONT_WAKEWAIT		0x01

#define GPIO_INT_MA7DIRQB	   (1 << 2)  /* P02 */
#define GPIO_INT_ACCELINT	   (1 << 3)  /* P03 */
#define GPIO_INT_FINGINT	   (1 << 4)  /* P04 */
#define GPIO_INT_SCROLLINT	   (1 << 5)  /* P05 */
#define GPIO_INT_CHGINT 	   (1 << 8)  /* P08 */
#define GPIO_INT_KEYINT 	   (1 << 9)  /* P09 */
#define GPIO_INT_DTVINT 	   (1 << 12) /* P12 */
#define GPIO_INT_DDRTEMP1	   (1 << 21) /* P21 */
#define GPIO_INT_SIDE_CLR	   (1 << 24) /* P24 */
#define GPIO_INT_SIDE_SET	   (1 << 25) /* P25 */
#define GPIO_INT_ADINT		   (1 << 26) /* P26 */
#define GPIO_INT_LUPINUS	   (1 << 31) /* P31 */

#define GPIO_INT_SPINTB 	   (1 << 15) /* P47 */
#define GPIO_INT_C_RXEND	   (1 << 17) /* P49 */
#define GPIO_INT_A_WAKEUP	   (1 << 20) /* P52 */
#define GPIO_INT_FRINT		   (1 << 22) /* P54 */
#define GPIO_INT_C_RSTOB	   (1 << 23) /* P55 */
#define GPIO_INT_MUSICCCINT	   (1 << 24) /* P56 */
#define GPIO_INT_WLANINT	   (1 << 25) /* P57 */
#define GPIO_INT_ETHERINT	   (1 << 31) /* P63 */

/* eMMC/SD power control */
#define PWC_REGGP3             0x02
#define PWC_POWER_OFF	       0x00
#define PWC_POWER_ON           0x02

#define CHG_PIN_G80_SD0SD2     0x0FFF0000
#define CHG_PIN_G112_GIO       0x00000000

#define GPIO_OUTPUT_LOW        0

#define PWC_SD_DETECT          0x40
#define DETECT_OFF	           0x00

/*
 * Registers sotore and restore
 *
 */
#define SMU_ENA_ALL		    0xFFFFFFFF
#define SMU_ENA_CLEAR		    0x00000000

/*
 * PMU boot setting
 *
 */

/* PMU registers */
#define PMU_PC			    (IO_ADDRESS(MP200_PMU_BASE) + 0x0004)
#define PMU_START		    (IO_ADDRESS(MP200_PMU_BASE) + 0x0008)
#define PMU_POWER_ON_PC 	    (IO_ADDRESS(MP200_PMU_BASE) + 0x0030)
#define PMU_WDT_COUNT_EN	    (IO_ADDRESS(MP200_PMU_BASE) + 0x0060)
#define PMU_WDT_COUNT_LMT	    (IO_ADDRESS(MP200_PMU_BASE) + 0x0064)
#define PMU_CMD_BUF_RAM 	    (IO_ADDRESS(MP200_PMU_BASE) + 0x1000)
#define PMU_CMD_BUF_FF		    (IO_ADDRESS(MP200_PMU_BASE) + 0x2000)

/* PMU, ASMU parameters */
#define PMU_WDT_ENABLE		    0x00000001
#define PMU_WDT_DISABLE 	    0x00000000
#define PMU_WDT_MAX_COUNT	    0x0003FFFF
#define PMU_START_SET		    0x00000001
#define PMU_CMD_BUF_RAM_BOOT	    0x504D5520
#define PMU_CMD_BUF_RAM_STOP	    0x00000000

#define SMU_CLKCTRL_SP0SCLKLP	    0x00000004 /* CLKCTRL: bit 2 */
#define SMU_CLKCTRL_SP1SCLKLP	    0x00000008 /* CLKCTRL: bit 3 */
#define SMU_CLKCTRL_SP2SCLKLP	    0x00000010 /* CLKCTRL: bit 4 */

#define SMU_QR_ENA_PMU_BOOT	    0x00530101
#define SMU_QR_ENA_PMU_NOTBOOT	    0x00530103

/*
 * Flags
 *
 */
#define MP200_PMU_CLK_MASK	    0x000f0000
#define MP200_PMU_CLK_FULLSPEED     0x00010000
#define MP200_PMU_CLK_POWERDOWN     0x00020000
#define MP200_PMU_CLK_SLEEP	    0x00040000
#define MP200_PMU_CLK_POWEROFF	    0x00080000

#define MP200_PMU_BOOT		    0
#define MP200_PMU_NOTBOOT	    1

#define PMU_INTC_MASK_SAVE_AND_MASK 1
#define PMU_INTC_MASK_RESTORE	    2
#define PMU_INTC_ALLMASK			3

#define PM_SLEEP_MODE_NONE		0

#define PMU_EMMC_POWER_OFF			0
#define PMU_EMMC_POWER_ON			1

/*
 * Structures
 *
 */

/* PWC*/
struct pwc_state {
	unsigned char ioout1;
	unsigned char fmask1;
	unsigned char bmask1;
	unsigned char fmask2;
	unsigned char bmask2;
	unsigned char fmask3;
	unsigned char clrfact1;
	unsigned char bmask3;
	unsigned char detmod3;
};
/* ASMU */
struct smu_state {
  unsigned int resetreq0;	    /* C011_0004H */
  unsigned int resetreq1;	    /* C011_000CH */
  unsigned int resetreq2;	    /* C011_0018H */
  unsigned int resetreq3;	    /* C011_083CH */
  unsigned int clkctrl; 	    /* C011_01B0H */
  unsigned int clkctrl1; 	    /* C011_088CH */
  unsigned int gclkctrl0;	    /* C011_01B4H */
  unsigned int gclkctrl1;	    /* C011_01BCH */
  unsigned int gclkctrl2;	    /* C011_01C4H */
  unsigned int gclkctrl3;	    /* C011_01CCH */
  unsigned int gclkctrl4;	    /* C011_084CH */
  unsigned int auto_frq_change;     /* C011_01DCH */
};
/* AINT */
struct intc_state {
  unsigned int it0_ien0;	    /* C002_0000H */
  unsigned int it0_ien1;	    /* C002_0004H */
  unsigned int it0_ien2;	    /* C002_0100H */
};
/* GPIO */
struct gpio_state {
  unsigned int ien0;		    /* GPIO_GP_IDSL */
  unsigned int ien1;		    /* GPIO_GP_IDSH */
  unsigned int ien2;		    /* GPIO_GP_IDSHH */
  unsigned int ien3;		    /* GPIO_GP_IDSHHH */
};
struct memc_state{
  unsigned int configr2;
};
/* CHG */
struct chg_state {
  unsigned int pinsel_g80;	    /* C014_0214H */
  unsigned int pinsel_g112;	    /* C014_021CH */
};
typedef struct {
  struct pwc_state   pwc;
  struct smu_state   smu;
  struct intc_state  intc;
  struct gpio_state  gpio;
  struct memc_state  memc;
  struct chg_state   chg;
} register_state_t;

/* Async Bus */
struct async_bus_state {
	unsigned int base_addr;
	unsigned int bitcomp;
	unsigned int waitctrl;
	unsigned int waitctrl_w;
	unsigned int readctrl;
	unsigned int control;
};

/*
 * Functions
 *
 */
extern void mp200_cpu_do_idle(unsigned int pmu_boot);
extern int mp200_pmu_sleep(unsigned int sleep_flag);
extern int mp200_pm_do_poweroff(void);

/*
 * PMU Command Sequence
 *
 */
#define PMU_BASE		    IO_ADDRESS(0xc0100000)
#define PMU_VIRADDR_TO_PC(addr)     (addr - PMU_BASE)
#define PMU_PC_TO_VIRADDR(pc)	    (pc + PMU_BASE)

/* for Command Sequence SMU Register Adr */
#define SMU_CMD_POWERSW_ENA		0x0240
#define SMU_CMD_QR_ENA			0x0220
#define SMU_CMD_RESETREQ0		0x0004
#define SMU_CMD_POWERSW_ACTRL_EN	0x025c
#define SMU_CMD_L1_POWERSW	0x0244
#define SMU_CMD_L2_POWERSW	0x0500
#define SMU_CMD_LOG2SW_ACTRLEN	0x0504
#define SMU_CMD_RESETREQ2ENA	0x001c
#define SMU_CMD_RESETREQ2		0x0018
#define SMU_CMD_LOG1SW_ACTRL	0x0260
#define SMU_CMD_CLK_MODE_SEL	0x0080
#define SMU_CMD_AUTO_MODE_EN	0x007c
#define SMU_CMD_ASMU_BGCTRL		0x0208
#define SMU_CMD_RESETREQ0ENA	0x0008
#define SMU_CMD_RESETREQ1ENA	0x0010
#define SMU_CMD_POWERSW_STATUS	0x023c
#define SMU_CMD_L1_BUZ		0x0268
#define SMU_CMD_L1_BUZ2		0x026c
#define SMU_CMD_GCLKCTRL0ENA	0x01b8
#define SMU_CMD_GCLKCTRL0		0x01b4
#define SMU_CMD_GCLKCTRL1ENA	0x01c0
#define SMU_CMD_GCLKCTRL1		0x01bc
#define SMU_CMD_GCLKCTRL2ENA	0x01c8
#define SMU_CMD_GCLKCTRL2		0x01c4
#define SMU_CMD_GCLKCTRL3ENA	0x01d0
#define SMU_CMD_GCLKCTRL3		0x01cc
#define SMU_CMD_GCLKCTRL4ENA	0x0850
#define SMU_CMD_GCLKCTRL4	0x084c
#define SMU_CMD_RESETREQ3		0x083c
#define SMU_CMD_RESETREQ3ENA		0x0840
#define SMU_CMD_RESETREQ1		0x000c
#define SMU_CMD_PLL1CTRL1		0x0088
#define SMU_CMD_PLL3CTRL1		0x0098
#define SMU_CMD_DIVSP0SCLK		0x0118
#define SMU_CMD_IO_L0_LM_BUZ	0x0814
#define SMU_CMD_MEMC_HAND_SHAKE_FAKE	0x08a0
#define SMU_CMD_AHBCLKCTRL0		0x01a0
#define SMU_CMD_AHBCLKCTRL1		0x01a4
#define SMU_CMD_APBCLKCTRL0		0x01a8
#define SMU_CMD_APBCLKCTRL1		0x01ac

/* for Command Sequence CHG Resister Adr */
#define CHG_CMD_CHG_L1_HOLD	0x0004

/* for Command Sequence MEMC Register Adr */
#define MEMC_CMD_MEMC_DDR_STATE8	0x202c
#define MEMC_CMD_MEMC_CACHE_MODE	0x0000
#define MEMC_CMD_MEMC_DEGFUN		0x0008
#define MEMC_CMD_MEMC_REQSCH		0x1000
#define MEMC_CMD_MEMC_DDR_CONFIGF	0x2000
#define MEMC_CMD_MEMC_DDR_CONFIGA1	0x2004
#define MEMC_CMD_MEMC_DDR_CONFIGA2	0x2008
#define MEMC_CMD_MEMC_DDR_CONFIGR1	0x2014
#define MEMC_CMD_MEMC_DDR_CONFIGR2	0x2018
#define MEMC_CMD_MEMC_DDR_CONFIGR3	0x201c
#define MEMC_CMD_MEMC_DDR_CONFIGT1	0x2020
#define MEMC_CMD_MEMC_DDR_CONFIGT2	0x2024
#define MEMC_CMD_MEMC_DDR_CONFIGC1	0x200c
#define MEMC_CMD_MEMC_DDR_CONFIGC2	0x2010

/* for Command Sequence SPI Register Adr */
#define SPI_CMD_SPx_TX_DATA		0x0010
#define SPI_CMD_SPx_CONTROL		0x0008
#define SPI_CMD_SPx_FFCLR		0x0028
#define SPI_CMD_SPx_ENSET		0x0020
#define SPI_CMD_SPx_MODE		0x0000
#define SPI_CMD_SPx_POL 		0x0004

/* PMU PC */
#define PMU_PC_MAIN		    0x1000
#define PMU_PC_MEMC_DEEP_POWERDOWN  0x1110
#define PMU_PC_SLEEP		    0x1200
#define PMU_PC_POWERDOWN	    0x1300
#define PMU_PC_POWEROFF 	    0x1400
#define PMU_PC_SPI_ENABLE	    0x1450
#define PMU_PC_SPI_DISABLE	    0x14a0
#define PMU_PC_POWER_ON_SEQUENCE    0x1500
#define PMU_PC_POWER_ON_PC	    0x1700
#define PMU_PC_L2POWEROFF	    0x1800
#define PMU_PC_L2POWERON	    0x1880
#define PMU_PC_MEMC1		    0x1900
#define PMU_PC_MEMC2		    0x1a00
#define PMU_PC_L1POWEROFF	    0x1b00
#define PMU_PC_L1POWERON	    0x1ba0

#define PMU_PC_USE_MEMC		    0x1f00

/* APB Macro Parameter */
#define ATIM_MACRO		    (0x00 << 16)
#define AINT_MACRO		    (0x01 << 16)
#define LCD_MACRO		    (0x02 << 16)
#define GPIO_MACRO		    (0x03 << 16)
#define SI1_MACRO		    (0x04 << 16)
#define MEMC_MACRO		    (0x05 << 16)
#define PWM_MACRO		    (0x06 << 16)

#define PMU_MACRO		    (0x09 << 16)
#define ASMU_MACRO		    (0x0A << 16)
#define SPI0_MACRO		    (0x0B << 16)
#define SPI1_MACRO		    (0x0C << 16)
#define CHG_MACRO		    (0x0D << 16)
#define SI0_MACRO		    (0x0E << 16)
#define AXL0_MACRO		    (0x0F << 16)
#define ASMU_S2_MACRO		    (0x11 << 16)
#define AINT_S2_MACRO		    (0x12 << 16)
#define MEMC_S2_MACRO		    (0x13 << 16)

/* Command Parameter */
#define CMD_REG_WRITE		    (0x00 << 25)
#define CMD_SP0_WRITE		    (0x01 << 25)
#define CMD_REG_READ		    (0x02 << 25)
#define CMD_RWM 		    (0x03 << 25)
#define CMD_MOVE		    (0x04 << 25)
#define CMD_AND 		    (0x05 << 25)
#define CMD_EXOR		    (0x06 << 25)
#define CMD_CMP1		    (0x07 << 25)
#define CMD_CMP2		    (0x08 << 25)
#define CMD_REG_WRITE2		    (0x09 << 25)
#define CMD_BRANCH		    (0x10 << 25)
#define CMD_JUMP		    (0x11 << 25)
#define CMD_AJUMP		    (0x12 << 25)
#define CMD_SUBROUTINE_START	    (0x13 << 25)
#define CMD_RFS 		    (0x14 << 25)
#define CMD_TIMERWAIT		    (0x20 << 25)
#define CMD_INTWAIT		    (0x21 << 25)
#define CMD_CCPU_STAT_WAIT	    (0x22 << 25)
#define CMD_SMU_READY_WAIT	    (0x23 << 25)
#define CMD_TRIG_WAIT		    (0x24 << 25)
#define CMD_QR_WAIT		    (0x25 << 25)
#define CMD_CYCLE_WAIT		    (0x26 << 25)
#define CMD_LCD_MODE_WAIT	    (0x27 << 25)
#define CMD_INT_MASK		    (0x30 << 25)
#define CMD_ARMINT_MASK 	    (0x31 << 25)
#define CMD_WDT_CLEAR		    (0x32 << 25)
#define CMD_WDT_STOP		    (0x33 << 25)
#define CMD_WDT_RESTART 	    (0x34 << 25)
#define CMD_PMU_END		    (0x35 << 25)
#define CMD_NOP 		    (0x36 << 25)

/* Other Parameters */
#define PMU_REGA		    (0 << 24)
#define PMU_REGB		    (1 << 24)
#define PMU_BEQ 		    (0 << 24)
#define PMU_BNE 		    (1 << 24)
#define PMU_WAIT_INT_END	    (0 << 24)
#define PMU_WAIT_INT_CONTINUE	    (1 << 24)
#define PMU_LOW_LEVEL		    (0 << 24)
#define PMU_HIGH_LEVEL		    (1 << 24)
#define PMU_TRIG_TIMER		    (1 << 19)
#define PMU_TRIG_CCPU_ACCESS_LOW    (1 << 20)
#define PMU_TRIG_CCPU_ACCESS_HIGH   (1 << 21)
#define PMU_TRIG_CCPU_LOWPWR_LOW    (1 << 22)
#define PMU_TRIG_CCPU_LOWPWR_HIGH   (1 << 23)
#define PMU_TRIG_INT		    (1 << 24)
#define PMU_QR_WAIT_BACKUP	    (0 << 24)
#define PMU_QR_WAIT_RESTORE	    (1 << 24)
#define PMU_INT_UNMASK		    (0 << 24)
#define PMU_INT_MASK		    (1 << 24)

/* Commands */
#define PMU_CMD_REG_WRITE(macro, addr, data, idx) {    \
    outl((CMD_REG_WRITE | macro | addr), idx++);       \
    outl(data, idx++);				       \
}
#define PMU_CMD_SP0_WRITE(addr, data, idx) {	       \
    outl((CMD_SP0_WRITE | addr), idx++);	       \
    outl(data, idx++);				       \
}
#define PMU_CMD_REG_READ(macro, addr, aorb, idx) {     \
    outl((CMD_REG_READ | aorb | macro | addr), idx++); \
}
#define PMU_CMD_RWM(macro, addr, data, data_en, idx) { \
    outl((CMD_RWM | macro | addr), idx++);	       \
    outl(data, idx++);				       \
    outl(data_en, idx++);			       \
}
#define PMU_CMD_MOVE(data, aorb, idx) { 	       \
    outl((CMD_MOVE | aorb), idx++);		       \
    outl(data, idx++);				       \
}
#define PMU_CMD_AND(data, aorb, idx) {		       \
    outl((CMD_AND | aorb), idx++);		       \
    outl(data, idx++);				       \
}
#define PMU_CMD_EXOR(data, aorb, idx) { 	       \
    outl((CMD_EXOR | aorb), idx++);		       \
    outl(data, idx++);				       \
}
#define PMU_CMD_CMP1(idx) {			       \
    outl(CMD_CMP1, idx++);			       \
}
#define PMU_CMD_CMP2(data, aorb, idx) { 	       \
    outl((CMD_CMP2 | aorb), idx++);		       \
    outl(data, idx++);				       \
}
#define PMU_CMD_REG_WRITE2(macro, addr, aorb, idx) {   \
    outl((CMD_REG_WRITE2 | aorb | macro | addr),idx++);\
}
#define PMU_CMD_BRANCH(jump, op, idx) { 	       \
    outl((CMD_BRANCH | op | jump), idx++);	       \
}
#define PMU_CMD_JUMP(jump, idx) {		       \
    outl((CMD_JUMP | jump), idx++);		       \
}
#define PMU_CMD_AJUMP(jump, idx) {		       \
    outl((CMD_AJUMP | jump), idx++);		       \
}
#define PMU_CMD_SUBROUTINE_START(jump, idx) {	       \
    outl((CMD_SUBROUTINE_START | jump), idx++);        \
}
#define PMU_CMD_RFS(idx) {			       \
    outl(CMD_RFS, idx++);			       \
}
#define PMU_CMD_TIMERWAIT(count, int, idx) {	       \
    outl((CMD_TIMERWAIT | int | count), idx++);        \
}
#define PMU_CMD_INTWAIT(idx) {			       \
    outl(CMD_INTWAIT, idx++);			       \
}
#define PMU_CMD_CCPU_STAT_WAIT(level, idx) {	       \
    outl((CMD_CCPU_STAT_WAIT | level), idx++);	       \
}
#define PMU_CMD_SMU_READY_WAIT(level, idx) {	       \
    outl((CMD_SMU_READY_WAIT | level), idx++);	       \
}
#define PMU_CMD_TRIG_WAIT(count, trig, idx) {	       \
    outl((CMD_TRIG_WAIT | trig | count), idx++);       \
}
#define PMU_CMD_QR_WAIT(borr, idx) {		       \
    outl((CMD_QR_WAIT | borr), idx++);		       \
}
#define PMU_CMD_CYCLE_WAIT(count, int, idx) {	       \
    outl((CMD_CYCLE_WAIT | int | count), idx++);       \
}
#define PMU_CMD_LCD_MODE_WAIT(idx) {		       \
    outl(CMD_LCD_MODE_WAIT, idx++);		       \
}
#define PMU_CMD_INT_MASK(mask, idx) {		       \
    outl((CMD_INT_MASK | mask), idx++); 	       \
}
#define PMU_CMD_ARMINT_MASK(mask, idx) {	       \
    outl((CMD_ARMINT_MASK | mask), idx++);	       \
}
#define PMU_CMD_WDT_CLEAR(idx) {		       \
    outl(CMD_WDT_CLEAR, idx++); 		       \
}
#define PMU_CMD_WDT_STOP(idx) { 		       \
    outl(CMD_WDT_STOP, idx++);			       \
}
#define PMU_CMD_WDT_RESTART(idx) {		       \
    outl(CMD_WDT_RESTART, idx++);		       \
}
#define PMU_CMD_PMU_END(idx) {			       \
    outl(CMD_PMU_END, idx++);			       \
}
#define PMU_CMD_NOP(idx) {			       \
    outl(CMD_NOP, idx++);			       \
}


#endif /* __ARCH_ARM_MACH_MP200_PM_PMU_H */
