/* 2010-08-25: File added and changed by Sony Corporation */
/*
 *  File Name	    : linux/arch/arm/mach-mp200/time.h
 *  Function	    : time
 *  Release Version : Ver 1.03
 *  Release Date    : 2007/08/08
 *
 *  Copyright (C) NEC Electronics Corporation 2007
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __ARCH_ARM_MACH_MP200_TIME_H
#define __ARCH_ARM_MACH_MP200_TIME_H

/*
 * General Timer
 */
#define TM_EN			0x00000001
#define TSTART			0x00000002
#define TO_EN			0x00000004
#define TCR_CLR			0x00000002
#define TSTOP			0x00000000

/*
 * Timer clock condition
 */
#define TIMER_SUSPEND           0
#define TIMER_RESUME            1
#define TIMER_FULLSPEED         2
#define TIMER_ECONOMY           3
#define TIMER_INIT              4
#define TIMER_SUSPEND_PDMA      5
#define TIMER_RESUME_PDMA       6


#define TIMER_WDT		TIMER_TW0

/* DAC HANG UP*/
#define TIMER_TG4		4
#define TIMER_TG5		5

#define TIMER_MIN		TIMER_TG0
#define TIMER_MAX		TIMER_TG3

#define TIMER_SYSTEM		TIMER_TI0
#define TIMER_DSP		TIMER_TI3

#if defined(CONFIG_SNSC_SCHED_CLOCK_TIMER_TG0)
#define TIMER_SCHED_CLOCK	TIMER_TG0

#elif defined(CONFIG_SNSC_SCHED_CLOCK_TIMER_TG1)
#define TIMER_SCHED_CLOCK	TIMER_TG1

#elif defined(CONFIG_SNSC_SCHED_CLOCK_TIMER_TG2)
#define TIMER_SCHED_CLOCK	TIMER_TG2

#elif defined(CONFIG_SNSC_SCHED_CLOCK_TIMER_TG3)
#define TIMER_SCHED_CLOCK	TIMER_TG3

#endif

#ifdef CONFIG_PLL3_238MHZ
#define TIMER_INTERVAL_PLL3     (59392 - 1)
#else
#define TIMER_INTERVAL_PLL3     (57344 - 1)
#endif

#define TIMER_INTERVAL_32K      (320 - 1)
#define TIMER_INTERVAL_DSP      (32 - 1)

#define COUNTER_MAXVAL          TIMER_INTERVAL_PLL3

#define TIMER_DELAY(x)		((40000000 / x )/10 + 1)	/* x:clock source value	*/

struct tm_param_t {
	unsigned int usecs;
	unsigned int tm_op;
};

struct tm_reg_t {
	unsigned int irq;
	unsigned int tm_op;
	unsigned int tm_clr;
	unsigned int tm_set;
	unsigned int rcr;
	unsigned int tm_sclr;
	unsigned int clkdev;
	unsigned int rstdev;
	unsigned int tin_sel;
};


extern struct sys_timer mp200_timer;

extern void timer_set_clock_parm(unsigned int mode);
extern void timer_set_clock(unsigned int mode);

#endif
