/* 2010-08-25: File added by Sony Corporation */
#ifndef __avc_info_h__
#define __avc_info_h__

#include <asm/arch/avc_common_info.h>
#include "avc_regs.h"

enum avc_state_t {
    state_initial,
    state_idle,
    state_encoding,
    state_encode_suspended,
    state_decoding,
    state_decode_suspended,
};

struct avc_info_t {
    enum avc_state_t state;
    struct avc_regs_t *regs;
    struct avc_interrupt_t interrupt;
    unsigned int int_a;
    unsigned int int_c;
    struct avc_common_info_t *common_info;
#if 1
    dma_addr_t pa_common_info;
#endif
    struct seq_parameter_set_rbsp_t last_sps; // for SH,SEI
    struct pic_parameter_set_rbsp_t last_pps; // for SH,SEI
    unsigned int encbuf_order_changed;
    void *streambuf_virt;        // for reverse
    unsigned int streambuf_size; // for reverse
    struct avc_driver_version_t version;
};

extern struct avc_info_t *avc_info;

#endif //__avc_info_h__
