/* 2010-08-25: File added by Sony Corporation */
#ifndef __avc_lib_h__
#define __avc_lib_h__

#include <asm/io.h>  // readw, writew
#include "avc_debug.h"

#define  bits(_v,_m,_l) ( (_v>>_l) & ( (1<<(_m-_l+1)) -1 ) )
#define wbits(_v,_m,_l) ( (_v & ( (1<<(_m-_l+1)) -1 )) <<_l )

#define maximum(_x,_y) ((_x>_y) ? _x : _y)
#define minimum(_x,_y) ((_x<_y) ? _x : _y)


#ifdef __KERNEL__

#define avc_writew(_v, _a) \
{ \
    debug2("writew: %s %p = 0x%X %u", #_a, _a, _v, _v); \
    writew(_v, _a); \
}

#define avc_writel(_v, _a) \
{ \
    debug2("writel: %s %p = 0x%X %u", #_a, _a, _v, _v); \
    writel(_v, _a); \
}

#else // __KERNEL__

#define writew(v,a) *(volatile unsigned short *)(a) = (unsigned short)(v)
#define writel(v,a) *(volatile unsigned int *)(a) = (unsigned int)(v)
#define readw(a) *(volatile unsigned short *)(a)
#define readl(a) *(volatile unsigned int *)(a)
#define avc_writew(_v, _a) \
    debug2("writew: %s %p = 0x%X %u", #_a, _a, _v, _v);
#define avc_writel(_v, _a) \
    debug2("writel: %s %p = 0x%X %u", #_a, _a, _v, _v);

#endif // __KERNEL__


#endif // __avc_lib_h__
