/* 2010-08-25: File added by Sony Corporation */
/*
 *  File Name       : linux/drivers/input/keyboard/mp200_btn.h
 *  Function        : button Interface
 *  Release Version : Ver 1.00
 *  Release Date    : 2008/07/07
 *
 *  Copyright (C) NEC Electronics Corporation 2005-2008
 *
 *
 *  This program is free software;you can redistribute it and/or modify itunder the terms of
 *  the GNU General Public License as published by Free Softwere Foundation;either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __DRIVERS_INPUT_KEYBOARD_MP200_BTN_H__
#define __DRIVERS_INPUT_KEYBOARD_MP200_BTN_H__

#include <asm/arch/irqs.h>
#include <asm/arch/pwc.h>

/* key scan default parameter */
#define BTN_CHAT_GUARDTIME	20	/* 20ms */
#define BTN_SCAN_INTERVAL	30	/* 30ms */

/* KEYSCAN */
#define BTN_SCAN1		(0x1 << PWC_INT_B5)
#define BTN_SCAN2		(0x1 << PWC_INT_B4)
#define BTN_SCAN		(BTN_SCAN1 | BTN_SCAN2)
#define BTN_SCAN_MASK	(BTN_SCAN1 | BTN_SCAN2)

#define BTN_DATA_MASK		0x3f

#define MP200_BTN_NAME		"mp200_button"

#define INT_KEY_DATA_BASE INT_PWC_GPIO_KEY_DATA0
#define INT_KEY_DATA_LAST INT_PWC_GPIO_KEY_DATA3

struct mp200_btn_table {
	unsigned int scancode;	/* keycode */
	unsigned char btn_id_bit;	/* button id bit */
};

#endif				/* __DRIVERS_INPUT_KEYBOARD_MP200_BTN_H__ */
