/* 2010-08-25: File added and changed by Sony Corporation */
/*
 * File Name       : drivers/media/video/mp200/mp200_v4l2_time.h
 * Function        : Video for Linux driver for EM1 driver core
 * Release Version :
 * Release Date    :
 *
 * Copyright (C) NEC Electronics Corporation 2006
 *
 *
 * This program is free software;you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by Free Softwere
 * Foundation; either version 2 of License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warrnty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; If not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef MP200_V4L2_TIME__H
#define MP200_V4L2_TIME__H


struct mp200_v4l2_time;


/*===============================================================*/
/* make option definetion                                        */
/*===============================================================*/
#define CALC_ADJUST          0  /* 1: adjust(LCD-IMC process) enable
                                   0: adjust(LCD-IMC process) disable */
#define ENABLE_DELAY         0  /* 1: delay enable
                                 * 0: delay disable */

#define ROUNDUP_ADJUST_LCD  16
#define ROUNDUP_ADJUST_NTSC 32
#define ROUNDUP_ADJUST_PAL  39
#define DEFAULT_ADJUST_LCD   0 /* adjust(LCD-IMC process)  time [msec] */
#define DEFAULT_ADJUST_NTSC 17 /* adjust(NTSC-IMG process) time [msec] */


/*===============================================================*/
/* rotate data structure                                         */
/*===============================================================*/
struct mp200_v4l2_time {
	struct timer_list       wait_timer;
	struct timeval		now_time;
	struct timeval		do_time;
	struct timeval		comp_time;
	long			wait_time;
	long			adjust_time_lcd;
	long			adjust_time_ntsc;
	void * 			vb;
};


#endif /* MP200_V4L2_TIME__H */
