/* 2009-08-24: File added by Sony Corporation */
/*                                                                                                                                  
 *  Copyright 2009 Sony Corporation.                                                                                                
 *                                                                                                                                  
 *  This program is free software; you can redistribute  it and/or modify it                                                        
 *  under  the terms of  the GNU General  Public License as published by the                                                        
 *  Free Software Foundation;  version 2 of the  License.                                                                           
 *                                                                                                                                  
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED                                                          
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF                                                        
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN                                                        
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,                                                         
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT                                                        
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF                                                        
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON                                                        
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT                                                        
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF                                                        
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                                               
 *                                                                                                                                  
 *  You should have received a copy of the  GNU General Public License along                                                        
 *  with this program; if not, write  to the Free Software Foundation, Inc.,                                                        
 *  675 Mass Ave, Cambridge, MA 02139, USA.                                                                                         
 *                                                                                                                                  
 */

#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/kthread.h>
#include <linux/sched.h>
#include <linux/delay.h> 
#include <linux/input.h>
#include <asm/arch/pwc.h>
#include <asm/arch/pgpf/ax/pm.h>

#include "get_adkey.h"
#include "chrdv.h"

static int adkey_thread(void *arg);

static struct task_struct *adkey_task;

static int adkey_thread(void *arg)
{
	unsigned int val[2];

	while(1){

        pwc_write(PWC_ADMODE, PWC_ADMODE_ADRQ_AUTOAD1, 0xFF );
        msleep( 3 );

        pwc_read(PWC_ADDATA3, &val[0]);
        pwc_read(PWC_ADDATA3, &val[1]);

		if(0xff != val[0] || 0xff != val[1]){
			complete_wait_irq(AX_PM_IRQ_HW_KEY);
		}

        msleep(POLL_INTERVAL);
    }

	return 0;
}

ax_pm_status_t __init adkey_init(void)
{
	adkey_task = kthread_create(adkey_thread, NULL, "adkey_thread");
    if(IS_ERR(adkey_task)){
        return AX_PM_ERR_THREAD;
    }                  
    wake_up_process(adkey_task);

	return AX_PM_SUCCESS;
}
