/* 2009-08-24: File added by Sony Corporation */


/*
 *  Copyright 2009 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __NAVU2_PM_INTERNAL_H__
#define __NAVU2_PM_INTERNAL_H__

#define APRINT(args...) printk(KERN_ALERT args)

#ifdef CONFIG_PGPF_NAVU2_PM_DEBUG
#define DPRINT(args...) printk(KERN_ERR  args)
#else  
#define DPRINT(args...) 
#endif

#define TRUE  1
#define FALSE 0

#include <linux/platform_device.h>

extern int pgpf_get_production_level(void);
extern int mp200_fb_suspend(struct platform_device *dev, pm_message_t state);
extern int mp200_fb_resume(struct platform_device *dev);
extern int mp200_fb_set_brightness(int brightness);      
extern int mp200_fb_get_brightness(void);  
extern int mp200_fb_set_tpled(int tpled_mode);

#endif /* __NAVU2_PM_INTERNAL_H__ */
