/* 2009-08-24: File added by Sony Corporation */
/*
 *  Copyright 2009 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __NAVU2_PM_NAVU2PM_IRQ_H__
#define __NAVU2_PM_NAVU2PM_IRQ_H__

#include <linux/irq.h>

typedef enum {
	NAVU2PM_IRQ_CB_DC_DET = 0,
	NAVU2PM_IRQ_CB_USB_DET,
	NAVU2PM_IRQ_CB_POWER_KEY,
	NAVU2PM_IRQ_CB_HIGH_TEMP,
	NAVU2PM_IRQ_CB_RTC_DET,
	NAVU2PM_IRQ_CB_DC_USB_OUT_DET,
	NAVU2PM_IRQ_CB_NUM_MAX,
} navu2pm_irq_cb_t;

typedef struct {
	unsigned int  irq;
	irqreturn_t   (*handler)(int, void *);
	unsigned long flags;
	unsigned char *dev_name;
	void          *dev_id;
	unsigned char trigger_type;
	int           gpio_flag;
} navu2pm_irq_info_t;

typedef struct {
	navu2pm_irq_cb_t irq;
	void             (*func)(void *);
	void             *arg;
} navu2pm_callback_t;

int  navu2pm_register_irq(void);
void navu2pm_register_callback(navu2pm_irq_cb_t irq, void (func)(void *), void *arg);

#endif /* __NAVU2_PM_NAVU2PM_IRQ_H__ */
