/* 2009-08-24: File added by Sony Corporation */
/*
 * msgchdev.h - the head file with ioctl definitions of mass storage
 *
 * Author: RichardZhou@SonySTC
 * Date : 2006/2/28
 * Copyright (C) 2006, Sony Corporation
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer,
 *    without modification.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The names of the above-listed copyright holders may not be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * ALTERNATIVELY, this software may be distributed under the terms of the
 * GNU General Public License ("GPL") as published by the Free Software
 * Foundation, either version 2 of that License or (at your option) any
 * later version.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef MSCHDEV_H
#define MSCHDEV_H

#include <linux/ioctl.h>

#define MAJOR_NUM      	248

#define IOCTL_MS_WAITEVENT          _IOR(MAJOR_NUM, 0, char*)
#define IOCTL_MS_SENDRESPONSE       _IOR(MAJOR_NUM, 1, char*)
#define IOCTL_MS_GET_CONNECTION     _IOR(MAJOR_NUM, 10, long *)
#define IOCTL_MS_SET_MOUNT          _IOR(MAJOR_NUM, 11, long)

#define DEVICE_MS_NAME            "usb-client"

typedef struct {
	unsigned long*	buf_len;
	unsigned char*  buffer;
	unsigned long*  cmd_len;
	unsigned char*  cmd_buf;
}vendor_wait_event_t;

typedef struct {
	unsigned long        sen_code;
	unsigned long        data_dir;
	unsigned long        buf_len;
	unsigned char*       buffer;
}vendor_send_response_t;

#endif /* MSCHDEV_H */
