/* 2010-08-25: File added and changed by Sony Corporation */
/*
 *  File Name	    : linux/drivers/usb/gadget/usbclass_common.h
 *  Function	    : USB Function Class Driver Interface
 *  Release Version : Ver 1.01
 *  Release Date    : 2009/04/16
 *
 *  Copyright (C) NEC Electronics Corporation 2009
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef _USBCLASS_COMMON_H_
#define _USBCLASS_COMMON_H_

//=============================================================================
//	headers

#include <linux/usb/ch9.h>
#include <linux/usb/gadget.h>


typedef long			BOOL;

#ifndef NULL
 #define NULL 0
#endif

#ifndef TRUE
 #define TRUE 1
#endif
#ifndef FALSE
 #define FALSE 0
#endif


//=============================================================================
// Class Type
//   NWM Driver regist type
enum USB_CLASS_TYPE {
	USB_START_TYPE=0,
	USB_MSC_TYPE,
	USB_MTP_TYPE,
	USB_END_TYPE
};


//=============================================================================
// structure
typedef struct usb_class_driver {

	struct usb_gadget_driver *pDriver;	// gadget driver pointer
	struct usb_gadget	*gadget;	// gadget pointer
	struct usb_gadget	*org_gadget;	// original gadget pointer
	__u32	ClassType;			// USB_CLASS_TYPE
	__u32	running;

	void	(*pMainLoop)(struct usb_class_driver *);	// pointer for MainLoop function 
	void	(*pMainLoopInit)(struct usb_class_driver *);	// pointer for MainLoop initialize function
	void	*pContext;					// gadget context

	struct usb_ep		*ep0;		// Handy copy of gadget->ep0
	struct usb_request	*ep0req;	// For control responses
	void	(*ep0_complete)(struct usb_ep *, struct usb_request *);
	void	(*ep0_send_status_stage)(void);

	struct usb_ep		*bulk_in;
	struct usb_ep		*bulk_out;
	struct usb_ep		*intr_in;

	struct usb_request	*bulk_in_req;
	struct usb_request	*bulk_out_req;
	struct usb_request	*intr_in_req;

	struct usb_endpoint_descriptor *bulk_in_desc;		//
	struct usb_endpoint_descriptor *bulk_out_desc;		//
	struct usb_endpoint_descriptor *intr_in_desc;		//

} T_USB_CLASS_DRIVER, *PT_USB_CLASS_DRIVER;


extern int fc_nwm_register_driver(struct usb_class_driver *driver);
extern int fc_nwm_unregister_driver(struct usb_class_driver *driver);


#endif // _USBCLASS_COMMON_H_

