/* 2010-08-25: File added and changed by Sony Corporation */
/*
 * ehci-mp200.h -- for MP200 High speed USB Host controller.
 *
 *  Copyright (C) NEC Electronics Corporation 2009
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*-------------------------------------------------------------------------*/
#ifndef __EHCI_MP200_H
#define __EHCI_MP200_H


/*-------------------------------------------------------------------------*/
/* Default DEFINE */

/*-------------------------------------------------------------------------*/
/* Default UNDEF */
#undef  USE_DUMP_REGISTER
#undef  USE_PHY_TYPE

/*-------------------------------------------------------------------------*/
/*  BITs */
#define BIT00		0x00000001
#define BIT01		0x00000002
#define BIT02		0x00000004
#define BIT03		0x00000008
#define BIT04		0x00000010
#define BIT05		0x00000020
#define BIT06		0x00000040
#define BIT07		0x00000080
#define BIT08		0x00000100
#define BIT09		0x00000200
#define BIT10		0x00000400
#define BIT11		0x00000800
#define BIT12		0x00001000
#define BIT13		0x00002000
#define BIT14		0x00004000
#define BIT15		0x00008000
#define BIT16		0x00010000
#define BIT17		0x00020000
#define BIT18		0x00040000
#define BIT19		0x00080000
#define BIT20		0x00100000
#define BIT21		0x00200000
#define BIT22		0x00400000
#define BIT23		0x00800000
#define BIT24		0x01000000
#define BIT25		0x02000000
#define BIT26		0x04000000
#define BIT27		0x08000000
#define BIT28		0x10000000
#define BIT29		0x20000000
#define BIT30		0x40000000
#define BIT31		0x80000000

#define BIT31_28	0xF0000000
#define BIT27_24	0x0F000000
#define BIT23_20	0x00F00000
#define BIT19_16	0x000F0000
#define BIT15_12	0x0000F000
#define BIT11_08	0x00000F00
#define BIT07_04	0x000000F0
#define BIT03_00	0x0000000F

#define BIT31_24	0xFF000000
#define BIT23_16	0x00FF0000
#define BIT15_08	0x0000FF00
#define BIT07_00	0x000000FF

#define BIT31_16	0xFFFF0000
#define BIT15_00	0x0000FFFF

#define BIT31_00	0xFFFFFFFF

#define BIT31_30	(BIT31|BIT30)
#define BIT30_29	(BIT30|BIT29)
#define BIT29_28	(BIT29|BIT28)
#define BIT28_27	(BIT28|BIT27)
#define BIT27_26	(BIT27|BIT26)
#define BIT19_18	(BIT19|BIT18)
#define BIT15_14	(BIT15|BIT14)
#define BIT12_11	(BIT12|BIT11)
#define BIT11_10	(BIT11|BIT10)
#define BIT03_02	(BIT03|BIT02)
#define BIT01_00	(BIT01|BIT00)

#define BIT31_25	0xFE000000
#define BIT31_17	0xFFFE0000
#define BIT31_12	0xFFFFF000
#define BIT31_11	0xFFFFE000
#define BIT31_05	0xFFFFFFE0
#define BIT30_24	0x7F000000
#define BIT30_16	0x7FFF0000
#define BIT26_24	0x07000000
#define BIT26_16	0x07FF0000
#define BIT23_17	0x00FE0000
#define BIT23_00	0x00FFFFFF
#define BIT21_16	0x003F0000
#define BIT15_01	0x0000FFFE
#define BIT13_08	0x00003F00
#define BIT13_00	0x00003FFF
#define BIT12_08	0x00001F00
#define BIT11_00	0x00000FFF
#define BIT10_00	0x000007FF
#define BIT07_01	0x000000FE
#define BIT05_00	0x0000003F
#define BIT05_01	0x0000003E
#define BIT04_00	0x0000001F
#define BIT03_01	0x0000000E

#define UDC_LE16_GET_L(wValue)		((u8)(((le16_to_cpu(wValue))&(BIT07_00))>>0))
#define UDC_LE16_GET_H(wValue)		((u8)(((le16_to_cpu(wValue))&(BIT15_08))>>8))

/*-------------------------------------------------------------------------*/
#define UDC_CHG_PINSEL_USB		CHG_PINSEL_USB
#define UDC_CHG_PINSEL_USB_HZ		0x00000000
#define UDC_CHG_PINSEL_USB_USB		0x00000001

#define	UDC_USB_INT				INT_USB
#define	UDC_VBUS_INT			INT_PWC_DETUSBINT
#define UDC_USB_WAKEUP_INT		INT_PWC_USBWAKINT

#define UDC_PHY_CS				GPIO_USB_CSN

//-----------------------------------------------------------------------------
#define PWC_PSW_VBUS				BIT05

#define PWC_CLRFACT3_VBUS			BIT07
#define PWC_BMASK3_VBUS				BIT07

#define PWC_CLRFACT3_WAKEUP			BIT04
#define PWC_BMASK3_WAKEUP			BIT04

#define PWC_VBUS_FALLING_EDGE		BIT07
#define PWC_VBUS_RISING_EDGE		BIT06
#define PWC_DETMOD3H_VBUS_MASK		(PWC_VBUS_FALLING_EDGE|PWC_VBUS_RISING_EDGE)

#define PWC_WAKEUP_FALLING_EDGE		BIT01
#define PWC_WAKEUP_RISING_EDGE		BIT00
#define PWC_DETMOD3H_WAKEUP_MASK	(PWC_WAKEUP_FALLING_EDGE|PWC_WAKEUP_RISING_EDGE)

#define PWC_MODESET1_VUSBPS			BIT03

#define PHY_POWER_BIT				BIT03

#define POWER_SAVE_MODE_WAIT_TIME	150	// usec

#define VBUS_CHATTERING_MDELAY			1		// ms
#define VBUS_CHATTERING_RETRY_MDELAY	20		// ms
#define VBUS_POWER_SAVE_MODE_UDELAY		150		// us

#define UDC_PHY_CS_MDELAY				1		// ms
#define UDC_LINK_UNRESET_UDELAY			150		// us


/*-------------------------------------------------------------------------*/
/* -------- (0x000) Identification Register */
/*  Read Only */
#define ID_REVISION			BIT23_16
#define ID_NID				BIT13_08
#define ID_ID				BIT05_00

/*  ------- (0x004) General Hardware Parameters */
/*  Read Only */
#define HWGENERAL_SM			(BIT09)
#define HWGENERAL_PHYM			(BIT08 | BIT07)
#define HWGENERAL_PHYW			(BIT06 | BIT05)
#define HWGENERAL_BWT			(BIT04 | BIT03)
#define HWGENERAL_CLKC			(BIT02 | BIT01)
#define HWGENERAL_RT			(BIT00)

/*  ------- (0x008) Host Hardware Parameters */
/*  Read Only */
#define HWHOST_TTPER			BIT31_24
#define HWHOST_TTASY			BIT23_16
#define HWHOST_NPORT			BIT03_01
#define HWHOST_HC				BIT00

/*  ------- (0x00C) Device Hardware Parameters */
/*  Read Only */
#define HWDEVICE_DEVEP			BIT05_01
#define HWDEVICE_DC				BIT00

/*  ------- (0x010) TX Buffer Hadware Parameters */
/*  Read Only */
#define HWTXBUF_TXLCR			BIT31
#define HWTXBUF_TXCHANADD		BIT23_16
#define HWTXBUF_TXADD			BIT15_08
#define HWTXBUF_TXBURST			BIT07_00

/*  ------- (0x014) RX Buffer Hadware Parameters */
/*  Read Only */
#define HWRXBUF_RXADD			BIT15_08
#define HWRXBUF_RXBURST			BIT07_00

/*  ------- (0x100) Capability Register Length & Host Interface Version Number */
/*  Read Only */
#define CH_CAPLENGTH			BIT07_00
#define CH_HCIVERSION			BIT31_16

/*  ------- (0x104) Host Control Structural Parameters */
/*  Read Only */
#define HCSPARAMS_N_TT			BIT27_24
#define HCSPARAMS_N_PTT			BIT23_20
#define HCSPARAMS_PI			BIT16
#define HCSPARAMS_N_CC			BIT15_12
#define HCSPARAMS_N_PCC			BIT11_08
#define HCSPARAMS_PPC			BIT04
#define HCSPARAMS_N_PORTS		BIT03_00

/*  ------- (0x108) Host Control Capability Parameters */
/*  Read Only */
#define HCCPARAMS_EECP			BIT15_08	/*  EHCI Extended Capabilities Pointer */
#define HCCPARAMS_IST			BIT07_04	/*  Isochronous Scheduling Threshold */
#define HCCPARAMS_ASP			BIT02		/*  Asynchronous Schedule Park Capability */
#define HCCPARAMS_PFL			BIT01		/*  Programmable Frame List Flag */
#define HCCPARAMS_ADC			BIT00		/*  64-bit Addressing Capability */

/*  ------- (0x080) General Purpose Timer 0 Load Register */
/*  Read/Write */
#define GPTIMER0LD_GPTLD		BIT23_00

/*  ------- (0x084) General Purpose Timer 0 Control Register */
/*  Read Only, Write Only, Read/Write */
#define GPTIMER0CTRL_GPTRUN		BIT31		/*  General Purpose Timer Run */
#define GPTIMER0CTRL_GPTRST		BIT30		/*  General Purpose Timer Reset */
#define GPTIMER0CTRL_GPTMODE	BIT24		/*  General Purpose Timer Mode */
#define GPTIMER0CTRL_GPTCNT		BIT23_00	/*  General Purpose Timer Counter */

/*  ------- (0x088) General Purpose Timer 1 Load Register */
/*  Read/Write */
#define GPTIMER1LD_GPTLD		BIT23_00

#define TIMER_COUNT_1_SEC	(1000*1000-1)
#define TIMER_COUNT_2_SEC	(1000*2000-1)

enum TIMER_MODE {
	TIMER_MODE_INIT=0,
	TIMER_MODE_SUSPEND,
	TIMER_MODE_RESUME,
	TIMER_MODE_END
};

/*  ------- (0x08C) General Purpose Timer 1 Control Register */
/*  Read Only, Write Only, Read/Write */
#define GPTIMER1CTRL_GPTRUN		BIT31			/*  General Purpose Timer Run */
#define GPTIMER1CTRL_GPTRST		BIT30			/*  General Purpose Timer Reset */
#define GPTIMER1CTRL_GPTMODE	BIT24			/*  General Purpose Timer Mode */
#define GPTIMER1CTRL_GPTCNT		BIT23_00		/*  General Purpose Timer Counter */

/*  ------- (0x120) Device Interface Version Number */
/*  Read Only */
#define DCIVERSION_DCIVERSION		BIT15_00

/*  ------- (0x124) Device Control Capability Parameters */
/*  Read Only */
#define DCCPARAMS_HC			BIT08			/*  Host Capable */
#define DCCPARAMS_DC			BIT07			/*  Device Capable */
#define DCCPARAMS_DEN			BIT03_00		/*  Device Endpoint Number */

/*  ------- (0x140) USB Command Register */
/*  Read Only, Write Only, Read/Write */
#define USBCMD_ITC			BIT23_16		/*  Inerrupt Threshold Control */
#define USBCMD_FS2			BIT15			/*  Frame List Size */
#define USBCMD_SUTW			BIT13			/*  Setup Trip Wire */
#define USBCMD_ATDTW		BIT12			/*  Add dTD TripWire */
#define USBCMD_ASPE			BIT11			/*  Asynchronous Schedule Park Mode Enable */
#define USBCMD_ASP			BIT09_08		/*  Asynchronous Schedule Park Mode Count */
#define USBCMD_LR			BIT07			/*  Light Host/Device Controller Reset */
#define USBCMD_IAA			BIT06			/*  Interrupt on Async Advanse Doorbell */
#define USBCMD_ASE			BIT05			/*  Asynchronous Schedule Enable */
#define USBCMD_PSE			BIT04			/*  Periodic Schedule Enable */
#define USBCMD_FS			BIT03_02		/*  Frame List Size */
#define USBCMD_RST			BIT01			/*  Controller Reset */
#define USBCMD_RS			BIT00			/*  Run/Stop */

#define USBCMD_ITC_01			BIT16

/*  ------- (0x144) USB Status Register */
/*  Read Only, Read/Write, -Clear */
#define USBSTS_TI1			BIT25			/*  General Purpose Timer Interrupt 1 */
#define USBSTS_TI0			BIT24			/*  General Purpose Timer Interrupt 0 */
#define USBSTS_UPI			BIT19			/*  USB Host Periodic Interrupt */
#define USBSTS_UAI			BIT18			/*  USB Host Asynchronous Inetrrupt */
#define USBSTS_NAKI			BIT16			/*  NAK Interrupt */
#define USBSTS_AS			BIT15			/*  Asynchronous Schedule Status */
#define USBSTS_PS			BIT14			/*  Periodic Schedule Status */
#define USBSTS_RCL			BIT13			/*  Reclamation */
#define USBSTS_HCH			BIT12			/*  HCHaited */
#define USBSTS_ULPII		BIT10			/*  ULPI Interrupt */
#define USBSTS_SLI			BIT08			/*  DC Suspend */
#define USBSTS_SRI			BIT07			/*  SOF Received */
#define USBSTS_URI			BIT06			/*  USB Reset Received */
#define USBSTS_AAI			BIT05			/*  Interrupt on Async Advance */
#define USBSTS_SEI			BIT04			/*  System Error */
#define USBSTS_FRI			BIT03			/*  Frame List Rollover */
#define USBSTS_PCI			BIT02			/*  Port Change Detect */
#define USBSTS_UEI			BIT01			/*  USB Error Interrupt */
#define USBSTS_UI			BIT00			/*  USB Interrupt */

/*  ------- (0x148) USB Interrupt Enable Register */
/*  Read/Write */
#define USBINTR_TIE1		BIT25			/*  General Purpose Timer Interrupt Enable 1 */
#define USBINTR_TIE0		BIT24			/*  General Purpose Timer Interrupt Enable 0 */
#define USBINTR_UPIE		BIT19			/*  USB Host Periodic Interrupt Enable */
#define USBINTR_UAIE		BIT18			/*  USB Host Asynchronous Inetrrupt Enable */
#define USBINTR_NAKE		BIT16			/*  NAK Interrupt Enable */
#define USBINTR_ULPIE		BIT10			/*  ULPI Interrupt Enable */
#define USBINTR_SLE			BIT08			/*  DC Suspend Enable */
#define USBINTR_SRE			BIT07			/*  SOF Received Enable */
#define USBINTR_URE			BIT06			/*  USB Reset Received Enable */
#define USBINTR_AAE			BIT05			/*  Interrupt on Async Advance Enable */
#define USBINTR_SEE			BIT04			/*  System Error Enable */
#define USBINTR_FRE			BIT03			/*  Frame List Rollover Enable */
#define USBINTR_PCE			BIT02			/*  Port Change Detect Enable */
#define USBINTR_UEE			BIT01			/*  USB Error Interrupt Enable */
#define USBINTR_UE			BIT00			/*  USB Interrupt Enable */

#define USB_FC_INT_ENABLE			(USBINTR_TIE1|USBINTR_SLE|USBINTR_URE|USBINTR_PCE|USBINTR_UEE|USBINTR_UE)
#define USB_FC_INT_SUS_ENABLE		(USB_FC_INT_ENABLE|USBINTR_SRE)


/*  ------- (0x14C) USB Frame Index Register */
/*    Host:Read/Write */
/*  Device:Read Only */
#define FRINDEX_FRINDEX			BIT13_00		/*  Frame Index */

/*  ------- (0x154) Host Controller Frame List Base Address */
/*  ------- (0x154) Device Controller USB Device Address */
/*  Read/Write */
#define PERIODICLISTBASE_PERBASE	BIT31_12		/*  Base Address(Low) */

#define DEVICEADDR_USBADR		BIT31_25		/*  Device Address */
#define DEVICEADDR_USBADR_SHIFT		25			/*  Device Address_Position */
#define DEVICEADDR_USBADRA		BIT24			/*  Device Address Advance */

/*  ------- (0x158) Host Controller next Asynchronous Address */
/*  ------- (0x158) Device Controller Endpoint List Address */
/*  Read/Write */
#define ASYNCLISTADDR_ASYBASE		BIT31_05		/*  Link Pointer Low(LPL) */

#define ENDPOINTLISTADDR_EPBASE		BIT31_11		/*  Endpoint List Pointer(Low) */

/*  ------- (0x15C) Host Controller Embedded TT Asynchronous Buffer Control */
/*  Read/Write */
#define TTCTRL_TTHA			BIT30_24

/*  ------- (0x160) Host Controller Embedded TT Asynchronous Buffer Status */
/*  Read/Write */
#define BURSTSIZE_TXPBURST		BIT15_08		/*  Programmable TX Burst Length */
#define BURSTSIZE_RXPBURST		BIT07_00		/*  Programmable RX Burst Length */

/*  ------- (0x164) TX Full Tuning */
/*  Read/Write */
#define TXFILLTUNING_TXFIFOTHRES	BIT21_16
#define TXFILLTUNING_TXSCHHEALTH	BIT12_08
#define TXFILLTUNING_TXSCHOH		BIT07_00

/*  ------- (0x170) ULPI Viewport */
/*  Read/Write */
#define ULPIVIEWPORT_ULPIWU			BIT31			/*  ULPI Wakeup */
#define ULPIVIEWPORT_ULPIRUN		BIT30			/*  ULPI Read/Write Run */
#define ULPIVIEWPORT_ULPIRW			BIT29			/*  ULPI Read/Write Control */
#define ULPIVIEWPORT_ULPISS			BIT27			/*  ULPI Sync State */
#define ULPIVIEWPORT_ULPIPORT		BIT26_24		/*  ULPI Port Number */
#define ULPIVIEWPORT_ULPIADDR		BIT23_16		/*  ULPI Data Address */
#define ULPIVIEWPORT_ULPIDATRD		BIT15_08		/*  ULPI Data Read */
#define ULPIVIEWPORT_ULPIDATWR		BIT07_00		/*  ULPI Data Write */

/*  ------- (0x178) Endpoint NACK Received */
/*  Read/Write Clear */
#define ENDPTNAK_TXEPTN			BIT31_16		/*  TX Endpoint NAK */
#define ENDPTNAK_RXEPTN			BIT15_00		/*  RX Endpoint NAK */

/*  ------- (0x17C) Endpoint NACK Received Interrupt Enable */
/*  Read/Write Clear */
#define ENDPTNAKEN_TXEPTNE		BIT31_16		/*  TX Endpoint NAK */
#define ENDPTNAKEN_RXEPTNE		BIT15_00		/*  RX Endpoint NAK */

/*  ------- (0x180) Configuration Flag Register */

/*  ------- (0x184_1A0) Port Status */
/*  ------- (0x184_1A0) Port Status Control */
/*  Read Only, Read/Write, R/WC */
#define PORTSC_PTS			BIT31_30		/*  Parallel Transceiver Select */
#define PORTSC_STS			BIT29			/*  Serial Transceiver Select */
#define PORTSC_PTW			BIT28			/*  Parallel Transceiver Wide */
#define PORTSC_PSPD			BIT27_26		/*  Port Speed */
#define PORTSC_PFSC			BIT24			/*  Port Force Full Speed Connect */
#define PORTSC_PHCD			BIT23			/*  PHY Low Power Suspned - Clock Disable */
#define PORTSC_WKOC			BIT22			/*  Wake on Over Current Enable */
#define PORTSC_WKDC			BIT21			/*  Wake on Disconnect Enable */
#define PORTSC_WKCN			BIT20			/*  Wake on Connect Enable */
#define PORTSC_PTC			BIT19_16		/*  Port Test Control */
#define PORTSC_PIC			BIT15_14		/*  Port Indicator Control */
#define PORTSC_PO			BIT13			/*  Port Owner */
#define PORTSC_PP			BIT12			/*  Port Power */
#define PORTSC_LS			BIT11_10		/*  Line Status */
#define PORTSC_HSP			BIT09			/*  High-Speed Port */
#define PORTSC_PR			BIT08			/*  Port Reset */
#define PORTSC_SUSP			BIT07			/*  Suspned */
#define PORTSC_FPR			BIT06			/*  Force Port Resume */
#define PORTSC_OCC			BIT05			/*  Over Current Change */
#define PORTSC_OCA			BIT04			/*  Over Current Active */
#define PORTSC_PEC			BIT03			/*  Port Enable/Disable Change */
#define PORTSC_PE			BIT02			/*  Port Enabled/Disabled */
#define PORTSC_CSC			BIT01			/*  Connect Status Change */
#define PORTSC_CCS			BIT00			/*  Current Connect Status */

#define PORTSC_PSPD_FS			0)
#define PORTSC_PSPD_LS			BIT26
#define PORTSC_PSPD_HS			BIT27

/*  ------- (0x1A4) OTG Status Control Register */
/*  Read Only, Read/Write, R/WC */
#define OTGSC_DPIE			BIT30			/*  Data Pulse Interrupt Enable */
#define OTGSC_1msE			BIT29			/*  1 milisecond timer interrupt Enable */
#define OTGSC_BSEIE			BIT28			/*  B Session End Interrupt Enable */
#define OTGSC_BSVIE			BIT27			/*  B Session Valid Interrupt Enable */
#define OTGSC_ASVIE			BIT26			/*  A Session Valid Interrupt Enable */
#define OTGSC_AVVIE			BIT25			/*  A VBus Valid Interrupt Enable */
#define OTGSC_IDIE			BIT24			/*  USB ID Interrupt Enable */
#define OTGSC_DPIS			BIT22			/*  Data Pulse Interrupt Status */
#define OTGSC_1msS			BIT21			/*  1 milisecond timer interrupt Status */
#define OTGSC_BSEIS			BIT20			/*  B Session End Interrupt Status */
#define OTGSC_BSVIS			BIT19			/*  B Session Valid Interrupt Status */
#define OTGSC_ASVIS			BIT18			/*  A Session Valid Interrupt Status */
#define OTGSC_AVVIS			BIT17			/*  A VBus Valid Interrupt Status */
#define OTGSC_IDIS			BIT16			/*  USB ID Interrupt Status */
#define OTGSC_DPS			BIT14			/*  Data Bus Pulsing Status */
#define OTGSC_1msT			BIT13			/*  1 milisecond timer toggle */
#define OTGSC_BSE			BIT12			/*  B Session End */
#define OTGSC_BSV			BIT11			/*  B Session Valid */
#define OTGSC_ASV			BIT10			/*  A Session Valid */
#define OTGSC_AVV			BIT09			/*  A VBus Valid */
#define OTGSC_ID			BIT08			/*  USB ID */
#define OTGSC_HABA			BIT07			/*  Hardware Assist B-Disconnect to A-Connect */
#define OTGSC_HADP			BIT06			/*  Hardware Assist Data-Pulse-Write to Set */
#define OTGSC_IDPU			BIT05			/*  ID Pullup */
#define OTGSC_DP			BIT04			/*  Data Pulsing */
#define OTGSC_OT			BIT03			/*  OTG Termination */
#define OTGSC_HAAR			BIT02			/*  Hardware Assist Auto-Reset */
#define OTGSC_VC			BIT01			/*  VBUS Charge */
#define OTGSC_VD			BIT00			/*  VBUS Discharge */

#define OTG_INT_ENABLE			(OTGSC_BSEIE|OTGSC_BSVIE|OTGSC_ASVIE|OTGSC_AVVIE)
#define OTG_POWER_INT			(OTGSC_BSEIS|OTGSC_BSVIS|OTGSC_ASVIS|OTGSC_AVVIS)

/*  ------- (0x1A8) USB Deivce Mode Register */
/*  Read/Write, Read Only */
#define USBMODE_VBPS			BIT05			/*  VBus Power Select */
#define USBMODE_SDIS			BIT04			/*  Stream Disable Mode */
#define USBMODE_SLOM			BIT03			/*  Setup Lockout Mode */
#define USBMODE_ES				BIT02			/*  Endian Select */
#define USBMODE_CM				BIT01_00		/*  Controller Mode */

#define UDBMODE_CM_FC			BIT01			/*  Function Mode */
#define UDBMODE_CM_HC			BIT01_00		/*  Host Mode */

/*  ------- (0x1AC) Endpoint Setup Status Register */
/*  R/WC */
#define ENDPTSETUPSTAT_ENDPTSETUPSTAT		BIT15_00	/*  Setup Endpoint Status */
#define ENDPTSETUPSTAT_ENDPTSETUPSTAT_EP0	BIT00	/*  Setup Endpoint Status EP0 */

/*  ------- (0x1B0) Endpoint Initializetion Register */
/*  R/WS */
#define ENDPTPRIME_PETB			BIT31_16		/*  Prime Endpoint Transmit Buffer */
#define ENDPTPRIME_PERB			BIT15_00		/*  Prime Endpoint Receive Buffer */

/*  ------- (0x1B4) Endpoint De-Initialize Register */
/*  R/WS */
#define ENDPTFLUSH_FETB			BIT31_16		/*  Flush Endpoint Transmit Buffer */
#define ENDPTFLUSH_FERB			BIT15_00		/*  Flush Endpoint Receive Buffer */

/*  ------- (0x1B8) Endpoint Status Register */
/*  Read Only */
#define ENDPTSTATUS_ETBR		BIT31_16		/*  Endpoint Transmit Buffer Ready */
#define ENDPTSTATUS_ERBR		BIT15_00		/*  Endpoint Receive Buffer Ready */

/*  ------- (0x1BC) Endpoint Complete Register */
/*  R/WC */
#define ENDPTCOMPLETE_ETCE		BIT31_16		/*  Endpoint Transmit Complete Event(IN) */
#define ENDPTCOMPLETE_ERCE		BIT15_00		/*  Endpoint Receive Complete Event(OUT) */
#define ENDPTCOMPLETE_ETCE_SHIFT	16		/*  Endpoint Transmit Complete Event Position */
#define ENDPTCOMPLETE_ERCE_SHIFT	0			/*  Endpoint Receive Complete Event Position */

/* ENDPT_BIT_POS macro Introduction */

#define ENDPT_BIT_POS(bEndpointAddress)\
	((1 << ((bEndpointAddress) & USB_ENDPOINT_NUMBER_MASK)) \
		<< ( (((bEndpointAddress) & USB_ENDPOINT_DIR_MASK) == USB_DIR_IN) \
			? ENDPTCOMPLETE_ETCE_SHIFT : ENDPTCOMPLETE_ERCE_SHIFT))

/*  ------- (0x1C0) Endpoint Control Register */
/*  R/WC */
#define ENDPTCTRL_TXE			BIT23			/*  TX Endpoint Enable */
#define ENDPTCTRL_TXR			BIT22			/*  TX Data Toggle Reset */
#define ENDPTCTRL_TXI			BIT21			/*  TX Data Toggle inhibit */
#define ENDPTCTRL_TXT			BIT19_18		/*  TX Endpoint Type */
#define ENDPTCTRL_TXD			BIT17			/*  TX Endpoint Data Source */
#define ENDPTCTRL_TXS			BIT16			/*  TX Endpoint Stall */
#define ENDPTCTRL_RXE			BIT07			/*  RX Endpoint Enable */
#define ENDPTCTRL_RXR			BIT06			/*  RX Data Toggle Reset */
#define ENDPTCTRL_RXI			BIT05			/*  RX Data Toggle inhibit */
#define ENDPTCTRL_RXT			BIT03_02		/*  RX Endpoint Type */
#define ENDPTCTRL_RXD			BIT01			/*  RX Endpoint Data Sink */
#define ENDPTCTRL_RXS			BIT00			/*  RX Endpoint Stall */

#define ENDPTCTRL_TXT_SHIFT		18
#define ENDPTCTRL_RXT_SHIFT		2



/*---------------------------------------------------------------------------*/
/* PHY Register */
#define PHY_VENDOR_ID_LOW				0x00	/* Vendor ID Low register */
#define PHY_VENDOR_ID_HIGH				0x01	/* Vendor ID High register */
#define PHY_PRODUCT_ID_LOW				0x02	/* Product ID Low register */
#define PHY_PRODUCT_ID_HIGH				0x03	/* Product ID High register */
#define PHY_FUCTION_CONTROL				0x04	/* Function Control register */
#define PHY_FUCTION_CONTROL_S			0x05	/* Function Control register Set */
#define PHY_FUCTION_CONTROL_C			0x06	/* Function Control register Clear */
#define PHY_INTERFACE_CONTROL			0x07	/* Interface Control register */
#define PHY_INTERFACE_CONTROL_S			0x08	/* Interface Control register Set */
#define PHY_INTERFACE_CONTROL_C			0x09	/* Interface Control register Clear */
#define PHY_OTG_CONTROL					0x0a	/* OTG Control register */
#define PHY_OTG_CONTROL_S				0x0b	/* OTG Control register Set */
#define PHY_OTG_CONTROL_C				0x0c	/* OTG Control register Clear */
#define PHY_INTERRUPT_ENABLE_RISING		0x0d	/* USB Interrupt Enable Rising register */
#define PHY_INTERRUPT_ENABLE_RISING_S	0x0e	/* USB Interrupt Enable Rising register Set */
#define PHY_INTERRUPT_ENABLE_RISING_C	0x0f	/* USB Interrupt Enable Rising register Clear */
#define PHY_INTERRUPT_ENABLE_FALLING	0x10	/* USB Interrupt Enable Falling register */
#define PHY_INTERRUPT_ENABLE_FALLING_S	0x11	/* USB Interrupt Enable Falling register Set */
#define PHY_INTERRUPT_ENABLE_FALLING_C	0x12	/* USB Interrupt Enable Falling register Clear */
#define PHY_INTERRUPT_STATUS			0x13	/* USB Interrupt Status register */
#define PHY_INTERRUPT_LATCH				0x14	/* USB Interrupt Latch register */

/*---------------------------------------------------------------------------*/
/*  OTG Control Registers */
typedef struct _T_OTG_REGS {			/*  ----- offset */
	u32 ID;					/*  (0x000) Identification Register */
	u32 HWGENERAL;				/*  (0x004) General Hardware Parameters */
	u32 HWHOST;				/*  (0x008) Host Hardware Parameters */
	u32 HWDEVICE;				/*  (0x00C) Device Hardware Parameters */
	u32 HWTXBUF;				/*  (0x010) TX Buffer Hadware Parameters */
	u32 HWRXBUF;				/*  (0x014) RX Buffer Hadware Parameters */
	u32 HWTTTXBUF;				/*  (0x018) TT TX Buffer Hadware Parameters */
	u32 HWTTRXBUF;				/*  (0x01C) TT RX Buffer Hadware Parameters */
	u32 Reserved020[24];
	u32 GPTIMER0LD;				/*  (0x080) General Purpose Timer 0 Load Register */
	u32 GPTIMER0CTRL;			/*  (0x084) General Purpose Timer 0 Control Register */
	u32 GPTIMER1LD;				/*  (0x088) General Purpose Timer 1 Load Register */
	u32 GPTIMER1CTRL;			/*  (0x08C) General Purpose Timer 1 Control Register */
	u32 Reserved090[28];

	u32 CAPLENGTH_HCIVERSION;		/*  (0x100) Capability Register Length & Host Interface Version Number */
	u32 HCSPARAMS;				/*  (0x104) Host Control Structural Parameters */
	u32 HCCPARAMS;				/*  (0x108) Host Control Capability Parameters */
	u32 Reserved10C[5];
	u32 DCIVERSION;				/*  (0x120) Device Interface Version Number */
	u32 DCCPARAMS;				/*  (0x124) Device Control Capability Parameters */
	u32 Reserved128[6];

	u32 USBCMD;				/*  (0x140) USB Command Register */
	u32 USBSTS;				/*  (0x144) USB Status Register */
	u32 USBINTR;				/*  (0x148) USB Interrupt Enable Register */
	u32 FRINDEX;				/*  (0x14C) USB Frame Index Register */
	u32 Reserved150;
	u32 PERIODICLISTBASE_DEVICEADDR;	/*  (0x154) Host Controller Frame List Base Address */
						/*  (0x154) Device Controller USB Device Address */
	u32 ASYNCLISTADDR_ENDPOINTLISTADDR;	/*  (0x158) Host Controller next Asynchronous Address */
						/*  (0x158) Device Controller Endpoint List Address */
	u32 TTCTRL;				/*  (0x15C) Host Controller Embedded TT Asynchronous Buffer Control */
	u32 BURSTSIZE;				/*  (0x160) Host Controller Embedded TT Asynchronous Buffer Status */
	u32 TXFILLTUNING;			/*  (0x164) TX Full Tuning */
	u32 TXTTFILLTUNING;			/*  (0x168) TT TX Full Tuning */
	u32 Reserved16C;
	u32 ULPIVIEWPORT;			/*  (0x170) ULPI Viewport */
	u32 Reserved174;
	u32 ENDPTNAK;				/*  (0x178) Endpoint NACK Received */
	u32 ENDPTNAKEN;				/*  (0x17C) Endpoint NACK Received Interrupt Enable */
	u32 CONFIGFLAG;				/*  (0x180) Configuration Flag Register */
	u32 PORTSC[8];				/*  (0x184_1A0) Port Status */
	u32 OTGSC;				/*  (0x1A4) OTG Status Control Register */
	u32 USB_MODE;				/*  (0x1A8) USB Deivce Mode Register */
	u32 ENDPTSETUPSTAT;			/*  (0x1AC) Endpoint Setup Status Register */
	u32 ENDPTPRIME;				/*  (0x1B0) Endpoint Initializetion Register */
	u32 ENDPTFLUSH;				/*  (0x1B4) Endpoint De-Initialize Register */
	u32 ENDPTSTATUS;			/*  (0x1B8) Endpoint Status Register */
	u32 ENDPTCOMPLETE;			/*  (0x1BC) Endpoint Complete Register */
	u32 ENDPTCTRL[16];			/*  (0x1C0) Endpoint Control Register */
} __attribute__ ((aligned(32))) T_OTG_REGS, *PT_OTG_REGS;

#define MP200_EHCI_CAPLENGTH_OFFSET		0x100
#define MP200_EHCI_USBCMD_OFFSET		0x140

/*-------------------------------------------------------------------------*/
/*  Function Registers */
typedef struct _T_FC_REGS {
	u32 USBCMD;				/*  (0x140) USB Command Register */
	u32 USBSTS;				/*  (0x144) USB Status Register */
	u32 USBINTR;				/*  (0x148) USB Interrupt Enable Register */
	u32 FRINDEX;				/*  (0x14C) USB Frame Index Register */
	u32 Reserved150;
	u32 DEVICEADDR;				/*  (0x154) Device Controller USB Device Address */
	u32 ENDPOINTLISTADDR;			/*  (0x158) Device Controller Endpoint List Address */
	u32 TTCTRL;				/*  (0x15C) Host Controller Embedded TT Asynchronous Buffer Control */
	u32 BURSTSIZE;				/*  (0x160) Host Controller Embedded TT Asynchronous Buffer Status */
	u32 TXFILLTUNING;			/*  (0x164) TX Full Tuning */
	u32 TXTTFILLTUNING;			/*  (0x168) TT TX Full Tuning */
	u32 Reserved16C;
	u32 ULPIVIEWPORT;			/*  (0x170) ULPI Viewport */
	u32 Reserved174;
	u32 ENDPTNAK;				/*  (0x178) Endpoint NACK Received */
	u32 ENDPTNAKEN;				/*  (0x17C) Endpoint NACK Received Interrupt Enable */
	u32 CONFIGFLAG;				/*  (0x180) Configuration Flag Register */
	u32 PORTSC[8];				/*  (0x184_1A0) Port Status */
	u32 OTGSC;				/*  (0x1A4) OTG Status Control Register */
	u32 USB_MODE;				/*  (0x1A8) USB Deivce Mode Register */
	u32 ENDPTSETUPSTAT;			/*  (0x1AC) Endpoint Setup Status Register */
	u32 ENDPTPRIME;				/*  (0x1B0) Endpoint Initializetion Register */
	u32 ENDPTFLUSH;				/*  (0x1B4) Endpoint De-Initialize Register */
	u32 ENDPTSTATUS;			/*  (0x1B8) Endpoint Status Register */
	u32 ENDPTCOMPLETE;			/*  (0x1BC) Endpoint Complete Register */
	u32 ENDPTCTRL[16];			/*  (0x1C0) Endpoint Control Register */
} __attribute__ ((aligned(32))) T_FC_REGS, *PT_FC_REGS;

/*-------------------------------------------------------------------------*/
/*  Host Registers */
typedef struct _T_HC_REGS {
	u32 USBCMD;					/*  (0x140) USB Command Register */
	u32 USBSTS;					/*  (0x144) USB Status Register */
	u32 USBINTR;				/*  (0x148) USB Interrupt Enable Register */
	u32 FRINDEX;				/*  (0x14C) USB Frame Index Register */
	u32 Reserved150;
	u32 PERIODICLISTBASE;		/*  (0x154) Host Controller Frame List Base Address */
	u32 ASYNCLISTADDR;			/*  (0x158) Host Controller next Asynchronous Address */
	u32 TTCTRL;					/*  (0x15C) Host Controller Embedded TT Asynchronous Buffer Control */
	u32 BURSTSIZE;				/*  (0x160) Host Controller Embedded TT Asynchronous Buffer Status */
	u32 TXFILLTUNING;			/*  (0x164) TX Full Tuning */
	u32 TXTTFILLTUNING;			/*  (0x168) TT TX Full Tuning */
	u32 Reserved16C;
	u32 ULPIVIEWPORT;			/*  (0x170) ULPI Viewport */
	u32 Reserved174;
	u32 ENDPTNAK;				/*  (0x178) Endpoint NACK Received */
	u32 ENDPTNAKEN;				/*  (0x17C) Endpoint NACK Received Interrupt Enable */
	u32 CONFIGFLAG;				/*  (0x180) Configuration Flag Register */
	u32 PORTSC[8];				/*  (0x184_1A0) Port Status */
	u32 OTGSC;					/*  (0x1A4) OTG Status Control Register */
	u32 USB_MODE;				/*  (0x1A8) USB Deivce Mode Register */
	u32 ENDPTSETUPSTAT;			/*  (0x1AC) Endpoint Setup Status Register */
	u32 ENDPTPRIME;				/*  (0x1B0) Endpoint Initializetion Register */
	u32 ENDPTFLUSH;				/*  (0x1B4) Endpoint De-Initialize Register */
	u32 ENDPTSTATUS;			/*  (0x1B8) Endpoint Status Register */
	u32 ENDPTCOMPLETE;			/*  (0x1BC) Endpoint Complete Register */
	u32 ENDPTCTRL[16];			/*  (0x1C0) Endpoint Control Register */
} __attribute__ ((aligned(32))) T_HC_REGS, *PT_HC_REGS;

/*-------------------------------------------------------------------------*/
#ifdef USE_PHY_TYPE
typedef enum _TAG_PHY_TYPE {
	UNKNOWN_PHY=0,
	NXP_PHY,
	SMSC_PHY,
	END_PHY
} ENUM_PHY_TYPE;


typedef struct _T_PHY_TYPE {
	ENUM_PHY_TYPE	phy_type;			/* PHY TYPE   */
	u16				vendorID;			/* Vendor ID  */
	u16				productID;			/* Product ID */
} T_PHY_TYPE, *PT_PHY_TYPE;
#endif	// USE_PHY_TYPE

struct mp200_hcd_work {
	spinlock_t lock;

	int			idint_irq;			/* Interrupt number of terminal ID */

	u64			dma_mask;

	void __iomem *addr_reg;
	void __iomem *data_reg;

#ifdef USE_PHY_TYPE
	ENUM_PHY_TYPE		phy_type;		/* PHY TYPE */
#endif	// USE_PHY_TYPE
#ifdef CONFIG_SNSC_MP200_PLATFORM
	struct mp200_ehci_platform_data *config;
#endif	/* CONFIG_SNSC_MP200_PLATFORM */
};






/*-------------------------------------------------------------------------*/
static inline struct mp200_hcd *hcd_to_mp200_hcd(struct usb_hcd *hcd)
{
	return (struct mp200_hcd *)(hcd->hcd_priv);
}

static inline struct usb_hcd *mp200_hcd_to_hcd(struct mp200_hcd *mp200_hcd)
{
	return container_of((void *)mp200_hcd, struct usb_hcd, hcd_priv);
}



/*-------------------------------------------------------------------------*/
/*  read(DWORD) */
static __inline__ u32 mp200st_udc_readl(u32 *adrs)
{
	return ioread32(adrs);
}

/*-------------------------------------------------------------------------*/
/*  write(DWORD) */
static __inline__ void mp200st_udc_writel(u32 *adrs, u32 data)
{
	iowrite32((data), (adrs));
}

/*-------------------------------------------------------------------------*/
/*  maskget */
static __inline__ u32 mp200st_udc_mask_get_bit(u32 *adrs, u32 mask)
{
	return mp200st_udc_readl(adrs) & mask;
}

/*-------------------------------------------------------------------------*/
/*  maskset */
static __inline__ void mp200st_udc_mask_set_bit(u32 *adrs, u32 mask, u32 data)
{
	u32	tmp;
	tmp = (mp200st_udc_readl(adrs) & ~mask) | data;
	mp200st_udc_writel(adrs, tmp);
}

/*-------------------------------------------------------------------------*/
/*  bitclear */
static __inline__ void mp200st_udc_clear_bit(u32 *adrs, u32 data)
{
	u32	tmp;
	tmp = mp200st_udc_readl(adrs) & ~data;
	mp200st_udc_writel(adrs, tmp);
}

/*-------------------------------------------------------------------------*/
/*  bitset */
static __inline__ void mp200st_udc_set_bit(u32 *adrs, u32 data)
{
	u32	tmp;
	tmp = mp200st_udc_readl(adrs) | data;
	mp200st_udc_writel(adrs, tmp);
}

#define ULPI_REPEATED_COUNT	100

/*-------------------------------------------------------------------------*/
/*  ULPI Read */
static int __inline__ mp200st_udc_ulpi_read(u32 *adrs, u8 phy_adrs)
{
	int		i, status = -EIO;
	u32		tmp_viewport;

	tmp_viewport = ULPIVIEWPORT_ULPIRUN | (phy_adrs <<16);
	mp200st_udc_writel(adrs, tmp_viewport);

	for(i=0; i<ULPI_REPEATED_COUNT; i++){
		tmp_viewport = mp200st_udc_readl(adrs);
		if(tmp_viewport & ULPIVIEWPORT_ULPIRUN) continue;
		else{
			status = (((tmp_viewport & ULPIVIEWPORT_ULPIDATRD) >> 8) & 0xFF);
			break;
		}
	}

	return status;
}

/*-------------------------------------------------------------------------*/
/*  ULPI Write */
static int __inline__ mp200st_udc_ulpi_write(u32 *adrs, u8 phy_adrs, u8 data)
{
	int		i, status = -EIO;
	u32		tmp_viewport;

	tmp_viewport = ULPIVIEWPORT_ULPIRUN | ULPIVIEWPORT_ULPIRW | (phy_adrs <<16) | data;
	mp200st_udc_writel(adrs, tmp_viewport);

	for(i=0; i<ULPI_REPEATED_COUNT; i++){
		tmp_viewport = mp200st_udc_readl(adrs);
		if((tmp_viewport & ULPIVIEWPORT_ULPIRUN) == 0){
			status = 0;
			break;
		}
	}

	return status;
}

/*-------------------------------------------------------------------------*/
static inline char * usb_debug_get_file_name(char *p_filename)	// __in__
{
	int		pos, len, i;
	char *p;

	pos = 0;
	p = p_filename;
	len = strlen(p);

	for(i=0; i<len; i++){
		if(p[i] == '/') pos = i+1;
	}

	p = p + pos;

	return p;
}

#ifdef USE_DEBUG_MESSAGE_ALL

	#ifdef USE_DEBUG_MESSAGE
		#define DBG_MSG(format, arg...) printk(KERN_DEBUG "%s : " format "\n", usb_debug_get_file_name(__FILE__), ## arg)
	#else
		#define DBG_MSG(format, arg...) do {} while (0)
	#endif

	#define DBG_MSGG(format, arg...) do {} while (0)

	#ifdef USE_INFOMATION_MESSAGE
		#define INFO_MSG(format, arg...) printk(KERN_INFO "%s : " format "\n", usb_debug_get_file_name(__FILE__), ## arg)
	#else
		#define INFO_MSG(format, arg...) do {} while (0)
	#endif
	#define INFO_MSGG(format, arg...) do {} while (0)

#else	// !USE_DEBUG_MESSAGE_ALL

	#define DBG_MSG(format, arg...) do {} while (0)
	#define DBG_MSGG(format, arg...) do {} while (0)
	#define INFO_MSG(format, arg...) do {} while (0)
	#define INFO_MSGG(format, arg...) do {} while (0)

#endif	// USE_DEBUG_MESSAGE_ALL

#define ERR_MSG(format, arg...) printk(KERN_ERR "%s : *** Error *** " format "\n", usb_debug_get_file_name(__FILE__), ## arg)
#define WARN_MSG(format, arg...) printk(KERN_WARNING "%s : === Warning === " format "\n", usb_debug_get_file_name(__FILE__), ## arg)

#endif /* __EHCI_MP200_H */
