/* 2009-08-24: File added and changed by Sony Corporation */
/*
 * File Name       : /drivers/video/mp200/mp200_lcd.h
 * Function        : LCD driver corresponding to V4L2
 * Release Version :
 * Release Date    :
 *
 * Copyright (C) NEC Electronics Corporation 2006
 *
 *
 * This program is free software;you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by Free Softwere
 * Foundation; either version 2 of License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warrnty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; If not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */


#ifndef _MP200_LCD_H_
#define _MP200_LCD_H_



/********************************************************
 *  Variables                                           *
 *******************************************************/
extern unsigned int  uiInverseFlag_tmp;	/* inverse mode Flag */

/* LCDC MMIO */
extern char         *LCDCMmioV;

/* FrameBuf(LCD) */
extern unsigned long FrameBufLength;
extern char         *FrameBufV;		/* vaddr */


#if defined(CONFIG_PM) || defined(CONFIG_DPM)
extern int     IMC_reset_flg;
#endif /* CONFIG_PM || CONFIG_DPM */


/********************************************************
 *  Prototype declarations of function                  *
 *******************************************************/
extern int          mp200_lcd_set_v4l2_image(V4L2_IMAGE_INFO *v4l2_image_info);
#ifdef CONFIG_MACH_PGPF
extern int          mp200_lcd_set_fb_image_ex2(FB_IMAGE_INFO *fb_image_info, FB_IMAGE_INFO *bg_image_info, V4L2_IMAGE_INFO *l2_image_info, FB_IMAGE_INFO *console_image_info);
static inline int mp200_lcd_set_fb_image_ex(FB_IMAGE_INFO *fb_image_info, FB_IMAGE_INFO* bg_image_info, FB_IMAGE_INFO* console_image_info)
{
	return mp200_lcd_set_fb_image_ex2(fb_image_info, bg_image_info, NULL, console_image_info);
}
static inline int mp200_lcd_set_fb_image(FB_IMAGE_INFO *fb_image_info)
{
	return mp200_lcd_set_fb_image_ex2(fb_image_info, NULL, NULL, NULL);
}
#else /* CONFIG_MACH_PGPF */
extern int          mp200_lcd_set_fb_image(FB_IMAGE_INFO *fb_image_info);
#endif /* CONFIG_MACH_PGPF */
extern int  __init  mp200_lcd_init_module(void);
extern void         mp200_lcd_exit_module(void);
#if defined(CONFIG_PM) || defined(CONFIG_DPM)
extern int          mp200_lcd_suspend(struct platform_device *dev, pm_message_t state);
extern int          mp200_lcd_resume(struct platform_device *dev);
#endif /* CONFIG_PM || CONFIG_DPM */

/* Private function */
extern irqreturn_t  lcd_irq_handler(int irq, void *dev_id);		/* VSYNC interrupt handler */
extern void         lcd_callback_imc_refresh(void);
extern void         lcd_callback_imc_wb(int status);



#endif /* _MP200_LCD_H_ */
