/* 2010-08-25: File added and changed by Sony Corporation */

#define LCD_PERF  0

#if LCD_PERF
#define LOG_MAX		0x500
/*******************************************************/
enum Sequence{
	SEQ_FB,
	SEQ_V4L2,
	SEQ_IPU,
	SEQ_IMC,
	SEQ_VSYNC,
};

struct time_log{
	enum Sequence	seq;
	struct timeval	now_time;
};

/*******************************************************/
static int		start_perf = 0;
static unsigned long	cnt_time = 0;
static struct time_log	*logtime;

/*******************************************************/
void map_nowtime(void);
void set_nowtime(enum Sequence seq);

/*******************************************************/
void map_nowtime()
{
	logtime = (struct time_log *)ioremap_nocache(OMF_MC_FRAME_BUFFER_ADDR + OMF_MC_FRAME_BUFFER_SIZE / 2, (sizeof(struct time_log) * LOG_MAX));
}

void set_nowtime(enum Sequence seq)
{
	int	cnt_perf, cnt_sps, cnt_seq, i = 0;

	if(start_perf == 1){
		if(cnt_time != LOG_MAX){
			logtime[cnt_time].seq = seq;
			do_gettimeofday(&logtime[cnt_time].now_time);
			cnt_time++;
		}else{
			start_perf = 2;
			printk(",FB,,V4L2,,IPU,,IMC,,VSYNC\n");
			for(cnt_seq = 0; cnt_seq <= SEQ_VSYNC; cnt_seq++){
				for(cnt_perf = 0; cnt_perf < LOG_MAX; cnt_perf++){
					if(cnt_seq == logtime[cnt_perf].seq){
						printk("%d,", logtime[cnt_perf].seq);
						for(cnt_sps = 0; cnt_sps < logtime[cnt_perf].seq; cnt_sps++)		printk(",,");
						printk("%ld,%ld,", logtime[cnt_perf].now_time.tv_sec, logtime[cnt_perf].now_time.tv_usec);
						for(cnt_sps = logtime[cnt_perf].seq; cnt_sps < SEQ_VSYNC; cnt_sps++)	printk(",,");
						printk("\n");

						if(cnt_seq == SEQ_VSYNC) printk("\n");
						else if(i % 2)		 printk("\n");
						i++;
					}
				}
				printk("\n");
			}
		}
	}
}
#else
#endif
