/* 2010-08-25: File added and changed by Sony Corporation */
/*
 * File Name       : /drivers/video/mp200/nts/mp200_nts.h
 * Function        : NTSC Driver corresponding to V4L2
 * Release Version : Ver 1.00
 * Release Date    : 2008/10/29
 *
 * Copyright (C) NEC Electronics Corporation 2008
 *
 *
 * This program is free software;you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by Free Softwere
 * Foundation; either version 2 of License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warrnty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; If not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */


#ifndef _MP200_NTS_H_
#define _MP200_NTS_H_



/********************************************************
 *  Prototype declarations of function                  *
 *******************************************************/
extern int          mp200_nts_reserve(int iActiveDevice, int iSetOutmode);
extern int          mp200_nts_release(int iActiveDevice);
extern int          mp200_nts_getmode(void);
extern int          mp200_nts_set_v4l2_image(V4L2_IMAGE_INFO *v4l2_info);
extern int          mp200_nts_set_fb_image(FB_IMAGE_INFO *fb_info);
extern void         nts_return_callback(void);
extern void         nts_return_callback_refresh(void);
extern void         nts_return_callback_ready(void);

#if defined(CONFIG_PM) || defined(CONFIG_DPM)
extern int          mp200_nts_suspend(struct platform_device *dev, pm_message_t state);
extern int          mp200_nts_resume(struct platform_device *dev);
#endif /* CONFIG_PM || CONFIG_DPM */


#endif /* _MP200_NTS_H_ */
