/* 2010-08-25: File added by Sony Corporation */
/*
 * File Name       : /drivers/video/mp200/nts/mp200_ntsipu.h
 * Function        : NTSC Driver corresponding to V4L2 (IPU Control)
 * Release Version : Ver 1.00
 * Release Date    : 2008/10/29
 *
 * Copyright (C) NEC Electronics Corporation 2008
 *
 *
 * This program is free software;you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by Free Softwere
 * Foundation; either version 2 of License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warrnty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; If not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */


#ifndef _MP200_NTSIPU_H_
#define _MP200_NTSIPU_H_



/********************************************************
 *  Structure                                           *
 *******************************************************/
struct image_data {
	unsigned long ulPhysAddrYRGB;
	unsigned long ulPhysAddrUV;
	unsigned long ulPhysAddrV;
	unsigned int  uiWidth;
	unsigned int  uiHeight;
	unsigned int  uiX;
	unsigned int  uiY;
	unsigned int  uiScreenWidth;
	unsigned int  uiFormat;
	unsigned int  uiEndian;
};


/********************************************************
 *  Prototype declarations of function                  *
 *******************************************************/
extern int  ntsipu_initialize(struct mp200_nts_dev *ntsc);
extern void ntsipu_finitialize(void);
extern int  ntsipu_img_request(void);
extern int  ntsipu_clr_framebuf(struct image_data *buff);



#endif /* _MP200_NTSIPU_H_ */
