/* 2010-08-25: File added by Sony Corporation */
#ifndef __avc_common_info_h__
#define __avc_common_info_h__

#include <linux/ioctl.h>
#define AVC_IOCTL_MAGIC 'H'
#define AVC_IOCQBUFSIZE    _IO  ( AVC_IOCTL_MAGIC, 0 )
#define AVC_IOCSREGCMD     _IOW ( AVC_IOCTL_MAGIC, 1, int )
#define AVC_IOCSREGISTER   _IOW ( AVC_IOCTL_MAGIC, 2, int )
#define AVC_IOCGREGISTER   _IOWR( AVC_IOCTL_MAGIC, 3, int )
#define AVC_IOCGVERSION    _IOR ( AVC_IOCTL_MAGIC, 4, int )
#define AVC_IOCSDEBUGLEVEL _IOW ( AVC_IOCTL_MAGIC,99, int )


#define     AVC_INT_ENC_END_EN           0x0080
#define     AVC_INT_DEC_END_EN           0x0040
#define     AVC_INT_DEC_ERR_EN           0x0020
#define     AVC_INT_ENC_PIC_END_EN       0x0010
#define     AVC_INT_DEC_PIC_END_EN       0x0008
#define     AVC_INT_HEAD_DEC_END_EN      0x0004
#define     AVC_INT_REF_PIC_MANUAL_EN    0x0002

/* err_nal_en */

#define     AVC_ERR_NAL_END             0x0008
#define     AVC_ERR_FORBIDDEN_ZERO_BIT  0x0004
#define     AVC_ERR_REF_IDC             0x0002
#define     AVC_ERR_NAL_UNIT_TYPE       0x0001

/* err_sps_en */

#define     AVC_HRD_ERROR                              0x2000
#define     AVC_VUI_ERROR                              0x1000
#define     AVC_SPS_OTHER_ERROR                        0x0800
#define     AVC_ERR_DIRECT_8X8_INFERENCE_FLAG          0x0400
#define     AVC_ERR_MB_ADAPTIVE_FRAME_FIELD_FLAG       0x0200
#define     AVC_ERR_PROFILE                            0x0100
#define     AVC_ERR_LEVEL_IDC                          0x0080
#define     AVC_ERR_SEQ_PARAMETER_SET_ID               0x0040
#define     AVC_ERR_LOG2_MAX_FRAME_NUM_MINUS4          0x0020
#define     AVC_ERR_PIC_ORDER_CNT_TYPE                 0x0010
#define     AVC_ERR_LOG2_MAX_PIC_ORDER_CNT_LSB_MINUS4  0x0008
#define     AVC_ERR_NUM_REF_FRAMES                     0x0004
#define     AVC_ERR_PIC_WIDTH_IN_MBS_MINUS1            0x0002
#define     AVC_ERR_PIC_HEIGHT_IN_MAP_UNITS_MINUS1     0x0001

/* err_pps_en */

#define     AVC_ERR_PPS_PPS_ID             0x0200
#define     AVC_ERR_PPS_SPS_ID             0x0100
#define     AVC_ERR_PPS_ENTROPY_FLAG       0x0080
#define     AVC_ERR_PPS_NUM_SLICE          0x0040
#define     AVC_ERR_PPS_NUM_REF_IDX        0x0020
#define     AVC_ERR_PPS_WEIGHTED_FLAG      0x0010
#define     AVC_ERR_PPS_WEIGHTED_IDC       0x0008
#define     AVC_ERR_PPS_PIC_INIT_Q         0x0004
#define     AVC_ERR_PPS_CQP_IDX_OFS        0x0002
#define     AVC_ERR_PPS_REDUNDANT_FLAG     0x0001

/* err_sh_en */

#define     AVC_ERR_SH_END                 0x0200
#define     AVC_ERR_SH_SLICE_TYPE          0x0100
#define     AVC_ERR_SH_PPS_ID              0x0080
#define     AVC_ERR_SH_IDR_PIC_ID          0x0040
#define     AVC_ERR_SH_NUM_REF_IDX_L0      0x0020
#define     AVC_ERR_SH_DIS_DBF_IDC         0x0010
#define     AVC_ERR_SH_SLC_A_C0_OFS        0x0008
#define     AVC_ERR_SH_SLC_BETA_OFS        0x0004
#define     AVC_ERR_SH_ROPN_IDC            0x0002
#define     AVC_ERR_SH_MMCO                0x0001


/* err_sd_en */

#define     AVC_ERR_1ST_MB_IN_SLICE       0x0800
#define     AVC_ERR_SD_END                0x0400
#define     AVC_ERR_SD_MB_TYPE            0x0200
#define     AVC_ERR_SD_CBP                0x0100
#define     AVC_ERR_SD_MBP_REF_IDX        0x0080
#define     AVC_ERR_SD_MBP_ICPM           0x0040
#define     AVC_ERR_SD_SMB_REF_IDX        0x0020
#define     AVC_ERR_ZSL_LT_RUN            0x0010
#define     AVC_ERR_CV_COEFT              0x0008
#define     AVC_ERR_CV_LV_PREFIX          0x0004
#define     AVC_ERR_CV_TZEROS             0x0002
#define     AVC_ERR_CV_RUN_BEFORE         0x0001

/* header_end_en */


#define     AVC_SPS_END                   0x0100
#define     AVC_PPS_END                   0x0080
#define     AVC_SEI_END                   0x0040
#define     AVC_AUD_END                   0x0020
#define     AVC_EOSEQ_END                 0x0010
#define     AVC_SH_END                    0x0008
#define     AVC_END_OF_STREAM_END         0x0004
#define     AVC_FILLER_DATA_END           0x0002

/* ref_hw_ctrl */

#define     AVC_REF_HW_CTRL_HW            0x0001
#define     AVC_REF_HW_CTRL_SW            0x0000

/* dec_error_conceal */

#define     AVC_DEC_ERROR_CONCEAL_ON      0x0001
#define     AVC_DEC_ERROR_CONCEAL_OFF     0x0000

/* SEI payloadType */

#define     AVC_SEI_RAW_OUTPUT21          0x00200000
#define     AVC_SEI_RAW_OUTPUT20          0x00100000
#define     AVC_SEI_RAW_OUTPUT19          0x00080000
#define     AVC_SEI_RAW_OUTPUT18          0x00040000
#define     AVC_SEI_RAW_OUTPUT17          0x00020000
#define     AVC_SEI_RAW_OUTPUT16          0x00010000
#define     AVC_SEI_RAW_OUTPUT15          0x00008000
#define     AVC_SEI_RAW_OUTPUT14          0x00004000
#define     AVC_SEI_RAW_OUTPUT13          0x00002000
#define     AVC_SEI_RAW_OUTPUT12          0x00001000
#define     AVC_SEI_RAW_OUTPUT11          0x00000800
#define     AVC_SEI_RAW_OUTPUT10          0x00000400
#define     AVC_SEI_RAW_OUTPUT9           0x00000200
#define     AVC_SEI_RAW_OUTPUT8           0x00000100
#define     AVC_SEI_RAW_OUTPUT7           0x00000080
#define     AVC_SEI_RAW_OUTPUT6           0x00000040
#define     AVC_SEI_RAW_OUTPUT5           0x00000020
#define     AVC_SEI_RAW_OUTPUT4           0x00000010
#define     AVC_SEI_RAW_OUTPUT3           0x00000008
#define     AVC_SEI_RAW_OUTPUT2           0x00000004
#define     AVC_SEI_RAW_OUTPUT1           0x00000002
#define     AVC_SEI_RAW_OUTPUT0           0x00000001

#define     AVC_PLANAR_SEL_PLANAR         0x00000000
#define     AVC_PLANAR_SEL_SEMI_PLANAR    0x00000001

#define AVC_BYTELANE_Y               8
#define AVC_BYTELANE_C               0

#define AVC_BYTELANE(HH, HL, LH, LL, YC)     \
        ((((HH) << 6) | ((HL) << 4) | ((LH) << 2) | (LL)) << (YC))

#define AVC_BYTELANE_Y0123    AVC_BYTELANE(0, 1, 2, 3, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y0132    AVC_BYTELANE(0, 1, 3, 2, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y0213    AVC_BYTELANE(0, 2, 1, 3, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y0231    AVC_BYTELANE(0, 2, 3, 1, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y0312    AVC_BYTELANE(0, 3, 1, 2, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y0321    AVC_BYTELANE(0, 3, 2, 1, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y1023    AVC_BYTELANE(1, 0, 2, 3, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y1032    AVC_BYTELANE(1, 0, 3, 2, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y1203    AVC_BYTELANE(1, 2, 0, 3, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y1230    AVC_BYTELANE(1, 2, 3, 0, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y1302    AVC_BYTELANE(1, 3, 0, 2, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y1320    AVC_BYTELANE(1, 3, 2, 0, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y2013    AVC_BYTELANE(2, 0, 1, 3, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y2031    AVC_BYTELANE(2, 0, 3, 1, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y2103    AVC_BYTELANE(2, 1, 0, 3, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y2130    AVC_BYTELANE(2, 1, 3, 0, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y2301    AVC_BYTELANE(2, 3, 0, 1, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y2310    AVC_BYTELANE(2, 3, 1, 0, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y3012    AVC_BYTELANE(3, 0, 1, 2, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y3021    AVC_BYTELANE(3, 0, 2, 1, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y3102    AVC_BYTELANE(3, 1, 0, 2, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y3120    AVC_BYTELANE(3, 1, 2, 0, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y3201    AVC_BYTELANE(3, 2, 0, 1, AVC_BYTELANE_Y)
#define AVC_BYTELANE_Y3210    AVC_BYTELANE(3, 2, 1, 0, AVC_BYTELANE_Y)


#define AVC_BYTELANE_C0123    AVC_BYTELANE(0, 1, 2, 3, AVC_BYTELANE_C)
#define AVC_BYTELANE_C0132    AVC_BYTELANE(0, 1, 3, 2, AVC_BYTELANE_C)
#define AVC_BYTELANE_C0213    AVC_BYTELANE(0, 2, 1, 3, AVC_BYTELANE_C)
#define AVC_BYTELANE_C0231    AVC_BYTELANE(0, 2, 3, 1, AVC_BYTELANE_C)
#define AVC_BYTELANE_C0312    AVC_BYTELANE(0, 3, 1, 2, AVC_BYTELANE_C)
#define AVC_BYTELANE_C0321    AVC_BYTELANE(0, 3, 2, 1, AVC_BYTELANE_C)
#define AVC_BYTELANE_C1023    AVC_BYTELANE(1, 0, 2, 3, AVC_BYTELANE_C)
#define AVC_BYTELANE_C1032    AVC_BYTELANE(1, 0, 3, 2, AVC_BYTELANE_C)
#define AVC_BYTELANE_C1203    AVC_BYTELANE(1, 2, 0, 3, AVC_BYTELANE_C)
#define AVC_BYTELANE_C1230    AVC_BYTELANE(1, 2, 3, 0, AVC_BYTELANE_C)
#define AVC_BYTELANE_C1302    AVC_BYTELANE(1, 3, 0, 2, AVC_BYTELANE_C)
#define AVC_BYTELANE_C1320    AVC_BYTELANE(1, 3, 2, 0, AVC_BYTELANE_C)
#define AVC_BYTELANE_C2013    AVC_BYTELANE(2, 0, 1, 3, AVC_BYTELANE_C)
#define AVC_BYTELANE_C2031    AVC_BYTELANE(2, 0, 3, 1, AVC_BYTELANE_C)
#define AVC_BYTELANE_C2103    AVC_BYTELANE(2, 1, 0, 3, AVC_BYTELANE_C)
#define AVC_BYTELANE_C2130    AVC_BYTELANE(2, 1, 3, 0, AVC_BYTELANE_C)
#define AVC_BYTELANE_C2301    AVC_BYTELANE(2, 3, 0, 1, AVC_BYTELANE_C)
#define AVC_BYTELANE_C2310    AVC_BYTELANE(2, 3, 1, 0, AVC_BYTELANE_C)
#define AVC_BYTELANE_C3012    AVC_BYTELANE(3, 0, 1, 2, AVC_BYTELANE_C)
#define AVC_BYTELANE_C3021    AVC_BYTELANE(3, 0, 2, 1, AVC_BYTELANE_C)
#define AVC_BYTELANE_C3102    AVC_BYTELANE(3, 1, 0, 2, AVC_BYTELANE_C)
#define AVC_BYTELANE_C3120    AVC_BYTELANE(3, 1, 2, 0, AVC_BYTELANE_C)
#define AVC_BYTELANE_C3201    AVC_BYTELANE(3, 2, 0, 1, AVC_BYTELANE_C)
#define AVC_BYTELANE_C3210    AVC_BYTELANE(3, 2, 1, 0, AVC_BYTELANE_C)


struct avc_mem_num_ref_idx_set_t {
    unsigned short set_ref_idx0;
    unsigned short set_ref_idx1;
    unsigned short set_ref_idx2;
    unsigned short set_ref_idx3;
    unsigned short set_ref_idx4;
    unsigned short set_ref_idx5;
    unsigned short set_ref_idx6;
    unsigned short set_ref_idx7;
    unsigned short set_ref_idx8;
    unsigned short set_ref_idx9;
    unsigned short set_ref_idx10;
    unsigned short set_ref_idx11;
    unsigned short set_ref_idx12;
    unsigned short set_ref_idx13;
    unsigned short set_ref_idx14;
    unsigned short set_ref_idx15;
};


struct avc_user_set_parameter_t {
    unsigned short set_int_en;
    unsigned short set_err_nal_en;
    unsigned short set_err_sps_en;
    unsigned short set_err_pps_en;
    unsigned short set_err_sh_en;
    unsigned short set_err_sd_en;
    unsigned short set_header_end_en;
    unsigned short set_ref_hw_ctrl;
    unsigned short set_dec_error_conceal;
    unsigned short set_mem_num_wr;
    struct avc_mem_num_ref_idx_set_t mem_num_ref_idx;
    unsigned int set_sei_raw_output;
    unsigned int set_planar_sel;
    unsigned int set_bytelane;
};

/*
 * Command for AVC_IOCSREGCMD
 */

enum avc_command_type_t {
    avc_command_encode_start,
    avc_command_encode_reactivate,
    avc_command_decode_start,
    avc_command_decode_reactivate,
    avc_command_stream_change,
    avc_command_reset
};

struct avc_command_t {
    unsigned short command;
    unsigned short last_frame;
};

/*
 * Register access for AVC_IOCSREGISTER/AVC_IOCGREGISTER
 */

struct avc_register_access_t {
    unsigned int address;
    unsigned int value;
};

/*
 * Driver version for AVC_IOCGVERSION
 */

struct avc_driver_version_t {
    int major;
    int minor;
    int local;
};

/*
 * Interruption information
 */

enum action_state_t {
    action_state_standby,
    action_state_compressing,
    action_state_decompressing,
    action_state_reserved
};

enum pic_type_t {
    pic_type_I_slice,
    pic_type_P_slice,
    pic_type_reserved1,
    pic_type_reserved2
};

struct avc_interrupt_t {
    union {
        unsigned int l;
        struct {
            unsigned int reserved :2; //[1:0]
            unsigned int int_head_dec_end :1; //[2]
            unsigned int int_dec_pic_end :1;
            unsigned int int_enc_pic_end :1;
            unsigned int int_dec_err :1;
            unsigned int int_dec_end :1;
            unsigned int int_enc_end :1; //[7]
        } b;
    } interrupt;

    unsigned int int_buf_full; // stream buffer full

    union {
        unsigned int l;
        struct {
            unsigned int reserved :1; //[0]
            unsigned int FD :1; //[1] filler data
            unsigned int EO :1; //[2] end of stream
            unsigned int SH :1;
            unsigned int EOSEQ :1;
            unsigned int AUD :1;
            unsigned int SEI :1;
            unsigned int PPS :1;
            unsigned int SPS :1; //[8]
        } b;
    } decode_header;

    unsigned int payload_type;

    struct {
        union {
            unsigned int l;
            struct {
                unsigned int err_nal_unit_type :1; //[0]
                unsigned int err_ref_idc :1;
                unsigned int err_forbidden_zero_bit :1;
                unsigned int err_nal_end :1; //[3]
            } b;
        } err_nal;

        union {
            unsigned int l;
            struct {
                unsigned int err_pic_height_in_map_units_minus1 :1; //[0]
                unsigned int err_pic_width_in_mbs_minus1 :1;
                unsigned int err_num_ref_frames :1;
                unsigned int err_log2_max_pic_order_cnt_lsb_minus4 :1;
                unsigned int err_pic_order_cnt_type :1;
                unsigned int err_log2_max_frame_num_minus4 :1;
                unsigned int err_seq_parameter_set_id :1;
                unsigned int err_level_idc :1;
                unsigned int err_profile :1;
                unsigned int err_mb_adaptive_frame_field_flag :1;
                unsigned int err_direct_8x8_inference_flag :1;
                unsigned int SPS_other_error :1;
                unsigned int VUI_error :1;
                unsigned int HRD_error :1; //[13]
            } b;
        } err_sps;

        union {
            unsigned int l;
            struct {
                unsigned int err_pps_redundant_flag :1; //[0]
                unsigned int err_pps_cqp_idx_ofs :1;
                unsigned int err_pps_pic_init_q :1;
                unsigned int err_pps_weighted_idc :1;
                unsigned int err_pps_weighted_flag :1;
                unsigned int err_pps_num_ref_idx :1;
                unsigned int err_pps_num_slice :1;
                unsigned int err_pps_entropy_flag :1;
                unsigned int err_pps_sps_id :1;
                unsigned int err_pps_pps_id :1; //[9]
            } b;
        } err_pps;

        union {
            unsigned int l;
            struct {
                unsigned int err_sh_mmco :1; //[0]
                unsigned int err_sh_ropn_idc :1;
                unsigned int err_sh_slc_beta_ofs :1;
                unsigned int err_sh_slc_a_c0_ofs :1;
                unsigned int err_sh_dis_dbf_idc :1;
                unsigned int err_sh_num_ref_idx_l0 :1;
                unsigned int err_sh_idr_pic_id :1;
                unsigned int err_sh_pps_id :1;
                unsigned int err_sh_slice_type :1;
                unsigned int err_sh_end :1; //[9]
            } b;
        } err_sh;

        union {
            unsigned int l;
            struct {
                unsigned int err_cv_run_before :1; //[0]
                unsigned int err_cv_tzeros :1;
                unsigned int err_cv_lv_prefix :1;
                unsigned int err_cv_coeft :1;
                unsigned int err_zsl_lt_run :1;
                unsigned int err_sd_smb_ref_idx :1;
                unsigned int err_sd_mbp_icpm :1;
                unsigned int err_sd_mbp_ref_idx :1;
                unsigned int err_sd_cbp :1;
                unsigned int err_sd_mb_type :1;
                unsigned int err_sd_end :1;
                unsigned int err_1st_mb_in_slice :1; //[11]
            } b;
        } err_sd;

        unsigned int macro_block_number; //[10:0]
    } decode_error;

    struct {
        unsigned short action_state;
        unsigned short pic_type; //[1:0]
    } status;
};


/*
 * AUD (Access Unit Delimiter)
 */

struct aud_parameters_t {
    unsigned short primary_pic_type;
    unsigned short :16;		// alignment
};


/*
 * HRD (Hypothetical Reference Decoder)
 */

#define max_cpb_cnt 32

struct hrd_parameters_t {
    unsigned short cpb_cnt_minus1; //[4:0]

    unsigned short bit_rate_scale;
    unsigned short cpb_size_scale; //[3:0]

    unsigned short padding1;

    unsigned int bit_rate_value_minus1 [max_cpb_cnt];
    unsigned int cpb_size_value_minus1 [max_cpb_cnt];
    unsigned short cbr_flag [max_cpb_cnt]; //[0]

    unsigned short initial_cpb_removal_delay_length_minus1; //[4:0]

    unsigned short cpb_removal_delay_length_minus1;
    unsigned short dpb_output_delay_length_minus1;
    unsigned short time_offset_length; //[4:0]
};

/*
 * VUI (Video Usability Information)
 */

#define Extended_SAR 255

struct vui_parameters_t {
    unsigned short aspect_ratio_info_present_flag; //[0]
    unsigned short aspect_ratio_idc; //[7:0]
    unsigned short sar_width;  //[15:0]
    unsigned short sar_height; //[15:0]
    unsigned short overscan_info_present_flag; //[0]
    unsigned short overscan_appropriate_flag; //[0]
    unsigned short video_signal_type_present_flag; //[0]

    unsigned short video_format;
    unsigned short video_full_range_flag;
    unsigned short colour_description_present_flag;

    unsigned short colour_primaries; //[7:0]
    unsigned short transfer_characteristics;
    unsigned short matrix_coefficients; //[7:0]
    unsigned short chroma_loc_info_present_flag; //[0]
    unsigned short chroma_sample_loc_type_top_field; //[2:0]
    unsigned short chroma_sample_loc_type_bottom_field; //[2:0]
    unsigned short timing_info_present_flag; //[0]
    unsigned short padding1;

    unsigned int num_units_in_tick;
    unsigned int time_scale;

    unsigned short fixed_frame_rate_flag; //[0]

    unsigned short nal_hrd_parameters_present_flag; //[0]
    struct hrd_parameters_t nal_hrd_parameters;

    unsigned short padding2;

    unsigned short vcl_hrd_parameters_present_flag; //[0]
    struct hrd_parameters_t vcl_hrd_parameters;

    unsigned short low_delay_hrd_flag; //[0]

    unsigned short pic_struct_present_flag;
    unsigned short bitstream_restriction_flag; //[0]

    unsigned short motion_vectors_over_pic_boundaries_flag; //[0]
    unsigned short max_bytes_per_pic_denom; //[4:0]
    unsigned short max_bits_per_mb_denom;   //[4:0]
    unsigned short log2_max_mv_length_horizontal; //[4:0]
    unsigned short log2_max_mv_length_vertical;   //[4:0]
    unsigned short num_reorder_frames; //[4:0]
    unsigned short max_dec_frame_buffering; //[4:0]
};

/*
 * SPS (Sequence Parameter Set)
 */

#define max_num_ref_frames_in_pic_order_nct_cycle 256

struct seq_parameter_set_rbsp_t {
    unsigned short profile_idc; //[7:0]

    unsigned short constraint_set0_flag;
    unsigned short constraint_set1_flag;
    unsigned short constraint_set2_flag;
    unsigned short level_idc;

    unsigned short seq_parameter_set_id; //[4:0]
    unsigned short log2_max_frame_num_minus4; //[3:0]
    unsigned short pic_order_cnt_type; //[1:0]
    unsigned short log2_max_pic_order_cnt_lsb_minus4; //[3:0]
    unsigned short delta_pic_order_always_zero_flag; //[0]

    unsigned int offset_for_non_ref_pic;
    unsigned int offset_for_top_to_bottom_field;

    unsigned short num_ref_frames_in_pic_order_nct_cycle; //[7:0]
    unsigned short padding1;

    unsigned int offset_for_ref_frame [max_num_ref_frames_in_pic_order_nct_cycle];

    unsigned short num_ref_frames; //[15:0]->[4:0]
    unsigned short gaps_in_frame_num_value_allowed_flag; //[0]
    unsigned short pic_width_in_mbs_minus1; //[5:0]
    unsigned short pic_height_in_maps_units_minus1; //[5:0]
    unsigned short frame_mbs_only_flag; //[0]
    unsigned short mb_adaptive_frame_field_flag; //[0]

    unsigned short direct_8x8_inference_flag;
    unsigned short frame_cropping_flag;

    unsigned short frame_crop_left_offset;      //[9:0]
    unsigned short frame_crop_right_offset;     //[9:0]
    unsigned short frame_crop_top_offset;       //[9:0]
    unsigned short frame_crop_bottom_offset;    //[9:0]
    unsigned short vui_parameters_present_flag; //[0]
    unsigned short padding2;

    struct vui_parameters_t vui_parameters;
};


/*
 * PPS (Picture Parameter Set)
 */

#define max_num_slice_groups 8
#define max_pic_size_in_map_units 2048

struct pic_parameter_set_rbsp_t {
    unsigned short pic_parameter_set_id; //[7:0]
    unsigned short seq_parameter_set_id; //[4:0]

    unsigned short entropy_coding_mode_flag;
    unsigned short pic_order_present_flag;

    unsigned short num_slice_groups_minus1; //[2:0]
    unsigned short slice_group_map_type; //[2:0]

    unsigned short run_length_minus1 [max_num_slice_groups]; //[10:0]
    unsigned short top_left [max_num_slice_groups];          //[10:0]
    unsigned short bottom_right [max_num_slice_groups];      //[10:0]
    unsigned short slice_group_change_direction_flag; //[0]
    unsigned short slice_group_change_rate_minus1; //[10:0]
    unsigned short pic_size_in_map_units_minus1;   //[10:0]

    unsigned char slice_group_id [max_pic_size_in_map_units]; //[2:0]

    unsigned short num_ref_idx_l0_active_minus1; //[4:0]
    unsigned short num_ref_idx_l1_active_minus1; //[4:0]

    unsigned short weighted_pred_flag;  //[2]
    unsigned short weighted_bipred_idc; //[1:0]

    unsigned short pic_init_qp_minus26; //[15:0]
    unsigned short pic_init_qs_minus26; //[15:0]
    unsigned short chroma_qp_index_offset; //[15:0]
    unsigned short deblocking_filter_control_present_flag; //[2]
    unsigned short constrained_intra_flag; //[1]
    unsigned short redundant_pic_cnt_present_flag; //[0]

    unsigned short :16;		// padding
};


/*
 * SH (Slice Header)
 */

#define max_reordering_of_pic 16

struct ref_pic_list_reordering_t {
    unsigned short sh_slice_type;

    unsigned short ref_pic_list_reordering_flag_l0; //[0]

    struct {
        unsigned short reordering_of_pic_nums_idc;

	unsigned short :16;	// padding

        union {
            unsigned short abs_diff_pic_num_minus1;
            unsigned short long_term_pic_num; //[4:0]
	    unsigned int :32;	// alignment
        } u;
    } rop [max_reordering_of_pic + 1];
};

#define max_memory_management_control_operation 6

struct dec_ref_pic_marking_t {
    unsigned short nal_unit_type;

    unsigned short no_output_of_prior_pics_flag;
    unsigned short long_term_reference_flag;
    unsigned short adaptive_ref_pic_marking_mode_flag;

    struct {
        unsigned short memory_management_control_operation; //[2:0]

        unsigned short difference_of_pic_nums_minus1; //[15:0]
        unsigned short long_term_pic_num;   //[15:0]
        unsigned short long_term_frame_idx; //[6:0]
        unsigned short max_long_term_frame_idx_plus1; //[15:0]

	unsigned short :16;	// padding
    } mmco [max_memory_management_control_operation + 1];
};

#define is_slice_type_P(_x)  ((_x) == 0 || (_x) == 5)
#define is_slice_type_B(_x)  ((_x) == 1 || (_x) == 6)
#define is_slice_type_I(_x)  ((_x) == 2 || (_x) == 7)
#define is_slice_type_SP(_x) ((_x) == 3 || (_x) == 8)
#define is_slice_type_SI(_x) ((_x) == 4 || (_x) == 9)

struct slice_header_t {
    unsigned short nal_ref_idc;
    unsigned short nal_unit_type;
    unsigned short sps_pic_order_cnt_type;
    unsigned short sps_delta_pic_order_always_zero_flag;
    unsigned short sps_frame_mbs_only_flag;
    unsigned short pps_pic_order_present_flag;
    unsigned short pps_deblocking_filter_control_present_flag;

    unsigned short slice_type; //[3:0]
    unsigned short pic_parameter_set_id; //[7:0]
    unsigned short frame_num; //[15:0]
    unsigned short field_pic_flag;    //[0]
    unsigned short bottom_field_flag; //[0]
    unsigned short idr_pic_id;        //[15:0]
    unsigned short pic_order_cnt_lsb; //[15:0]

    unsigned int delta_pic_order_cnt_bottom;
    unsigned int delta_pic_order_cnt[2];

    unsigned short num_ref_idx_active_override_flag; //[0]
    unsigned short num_ref_idx_l0_active_minus1; //[4:0]

    struct ref_pic_list_reordering_t ref_pic_list_reordering;
    struct dec_ref_pic_marking_t dec_ref_pic_marking;

    unsigned short slice_qp_delta; //[15:0]
    unsigned short slice_qs_delta; //[15:0]
    unsigned short disable_deblocking_filter_idc; //[1:0]
    unsigned short slice_alpha_c0_offset_div2; //[15:0]
    unsigned short slice_beta_offset_div2;     //[15:0]

    unsigned short :16;		// padding
};


/*
 * SEI (Supplemental Enhancement Information)
 */

enum sei_payloadtype_t {
    buffering_period = 0,
    pic_timing,
    pan_scan_rect,
    filler_payload,
    user_data_registered_itu_t_t35,
    user_data_unregistered,
    recovery_point,
    dec_ref_pic_marking_repetition,
    spare_pic,
    scene_info,
    sub_seq_info, //10
    sub_seq_layer_characteristics,
    sub_seq_characteristics,
    full_frame_freeze,
    full_frame_freeze_release, //14 not supported
    full_frame_snapshot,
    progressive_refinement_segment_start,
    progressive_refinement_segment_end,
    motion_constrained_slice_group_set,
    film_grain_characteristics,
    deblocking_filter_display_preference, //20
    stereo_video_info
};

struct sei_decode_flags_t {
    unsigned short NalHrdBpPresentFlag;
    unsigned short VclHrdBpPresentFlag;
    unsigned short CpbDpbDelaysPresentFlag;

    unsigned short :16;		// padding
};

/* SEI 0: buffering_period */

struct buffering_period_t {
    unsigned short NalHrdBpPresentFlag;
    unsigned short VclHrdBpPresentFlag;
    unsigned short nal_hrd_cpb_cnt_minus1;
    unsigned short vcl_hrd_cpb_cnt_minus1;

    unsigned short seq_parameter_set_id; //[4:0]
    unsigned short padding1;

    unsigned int nal_initial_cpb_removal_delay [max_cpb_cnt];
    unsigned int nal_initial_cpb_removal_delay_offset [max_cpb_cnt];
    unsigned int vcl_initial_cpb_removal_delay [max_cpb_cnt];
    unsigned int vcl_initial_cpb_removal_delay_offset [max_cpb_cnt];
};

/* SEI 1: pic_timing */

#define NumClockTS 3

struct pic_timing_t {
    unsigned short CpbDpbDelaysPresentFlag;
    unsigned short vui_pic_struct_present_flag;

    unsigned int cpb_removal_delay;
    unsigned int dpb_output_delay;

    unsigned short pic_struct; //[3:0]
    unsigned short padding1;

    struct {
        unsigned short clock_timestamp_flag; //[NumClockTS-1:0]

        unsigned short ct_type;
        unsigned short nuit_field_based_flag;
        unsigned short counting_type; //[4:0]

        unsigned short full_timestamp_flag;
        unsigned short discontinuity_flag;
        unsigned short cnt_dropped_flag;
        unsigned short n_frames;

        unsigned short seconds_value;
        unsigned short minutes_value;
        unsigned short hours_value;

        unsigned short seconds_flag;
        unsigned short minutes_flag;
        unsigned short hours_flag;

        unsigned int time_offset;
    } ct [NumClockTS];

};

/* SEI 2: pan_scan_rect */

#define max_pan_scan_cnt 4

struct pan_scan_rect_t {
    unsigned int pan_scan_rect_id;
    unsigned short pan_scan_rect_cancel_flag; //[0]
    unsigned short pan_scan_cnt_minus1; //[1:0]

    struct {
        unsigned int left_offset;
        unsigned int right_offset;
        unsigned int top_offset;
        unsigned int bottom_offset;
    } psr [max_pan_scan_cnt];

    unsigned short pan_scan_rect_repetition_period; //[14:0]
};

/* SEI 3: filler_payload */

struct filler_payload_t {
    unsigned int payloadSize;
};

/* SEI 4: user_data_registered_itu_t_t35 */

struct user_data_registered_itu_t_t35_t {
    unsigned short itu_t_t35_country_code;
    unsigned short itu_t_t35_payload_byte; //[7:0]
    unsigned short itu_t_t35_country_code_extension_byte; //[7:0]

    //itu_t_t35_payload_byte[];

    unsigned short :16;		// padding
};

/* SEI 5: user_data_unregistered */

struct user_data_unregistered_t {
    unsigned short uuid_iso_iec_11578[8]; //[127:0]

    //user_data_payload_byte[];
};

/* SEI 6: recovery_point */

struct recovery_point_t {
    unsigned short recovery_frame_cnt; //[15:0]
    unsigned short exact_match_flag;
    unsigned short broken_link_flag;
    unsigned short changing_slice_group_idc; //[1:0]
};

/* SEI 7: dec_ref_pic_marking_repetition */

struct dec_ref_pic_marking_repetition_t {
    unsigned short sps_frame_mbs_only_flag;
    unsigned short padding1;

    unsigned short original_idr_flag;  //[0]
    unsigned short original_frame_num; //[15:0]
    unsigned short original_field_pic_flag; //[0]
    unsigned short original_bottom_field_flag; //[0]

    struct dec_ref_pic_marking_t dec_ref_pic_marking;
};

/* SEI 8: spare_pic */

#define max_num_spare_pics 16

struct spare_pic_t {
    unsigned short pps_pic_size_in_map_units; //[10:0]
    unsigned short padding1;

    unsigned short target_frame_num; //[15:0]
    unsigned short spare_field_flag; //[0]
    unsigned short target_bottom_field_flag; //[0]
    unsigned short num_spare_pics_minus1;    //[3:0]

    struct {
        unsigned short delta_spare_frame_num;   //[15:0]
        unsigned short spare_bottom_field_flag; //[0]
        unsigned short spare_area_idc; //[1:0]

	unsigned short :16;	// padding

        union {
            unsigned short spare_unit_flag [max_pic_size_in_map_units];//[0]
            unsigned short zero_run_length [max_pic_size_in_map_units];//[10:0]
	    unsigned int :32;	// alignment
        } u;
    } spare_pics [max_num_spare_pics];
};

/* SEI 9: scene_info */

struct scene_info_t {
    unsigned short scene_info_present_flag; //[0]
    unsigned short padding1;
    unsigned int scene_id;
    unsigned short scene_transition_type; //[2:0]
    unsigned int second_scene_id;
};

/* SEI 10: sub_seq_info */

struct sub_seq_info_t {
    unsigned short sub_seq_layer_num; //[7:0]
    unsigned short sub_seq_id; //[15:0]
    unsigned short first_ref_pic_flag;
    unsigned short leading_non_ref_pic_flag;
    unsigned short last_pic_flag;
    unsigned short sub_seq_frame_num_flag;
    unsigned short sub_seq_frame_num;

    unsigned short :16;		// padding
};

/* SEI 11: sub_seq_layer_characteristics */

struct sub_seq_layer_characteristics_t {
    unsigned short num_sub_seq_layers_minus1; //[7:0]
    unsigned short accurate_statistics_flag; //[0]
    unsigned short average_bit_rate; //[15:0]
    unsigned short average_frame_rate; //[15:0]
};

/* SEI 12: sub_seq_characteristics */

struct sub_seq_characteristics_t {
    unsigned short sub_seq_layer_num; //[7:0]
    unsigned short sub_seq_id; //[15:0]
    unsigned short duration_flag; //[0]
    unsigned short padding1;
    unsigned int sub_seq_duration;
    unsigned short average_rate_flag;
    unsigned short accurate_statistics_flag;
    unsigned short average_bit_rate; //[15:0]
    unsigned short average_frame_rate; //[15:0]
    unsigned short num_referenced_subseqs; //[7:0]
    unsigned short ref_sub_seq_layer_num; //[7:0]
    unsigned short ref_sub_seq_id; //[15:0]
    unsigned short ref_sub_seq_direction; //[0]
};

/* SEI 13: full_frame_freeze */

struct full_frame_freeze_t {
    unsigned short full_frame_freeze_repetition_period; //[14:0]
    unsigned short :16;		// padding
};

/* SEI 14: full_frame_freeze_release */

/* SEI 15: full_frame_snapshot */

struct full_frame_snapshot_t {
    unsigned int snapshot_id;
    unsigned short :16;		// padding
};

/* SEI 16: progressive_refinement_segment_start */

struct progressive_refinement_segment_start_t {
    unsigned int progressive_refinement_id;
    unsigned short num_refinement_steps_minus1; //[15:0]
    unsigned short :16;		// padding
};

/* SEI 17: progressive_refinement_segment_end */

struct progressive_refinement_segment_end_t {
    unsigned int progressive_refinement_id;
};

/* SEI 18: motion_constrained_slice_group_set */

#define max_num_slice_groups_in_set 8

struct motion_constrained_slice_group_set_t {
    unsigned short num_slice_groups_in_set_minus1; //[2:0]
    unsigned short slice_group_id [max_num_slice_groups_in_set]; //[2:0]
    unsigned short exact_sample_value_match_flag;
    unsigned short pan_scan_rect_flag;
    unsigned short padding1;
    unsigned int pan_scan_rect_id;
};

/* SEI 19: film_grain_characteristics */

#define max_num_intensity_intervals 256
#define max_num_model_values 8

struct film_grain_characteristics_t {
    unsigned short film_grain_characteristics_cancel_flag; //[0]

    unsigned short model_id;
    unsigned short separate_colour_description_present_flag; //[0]

    unsigned short film_grain_bit_depth_luma_minus8;
    unsigned short film_grain_bit_depth_chroma_minus8;
    unsigned short film_grain_full_range_flag;
    unsigned short film_grain_colour_primaries; //[7:0]

    unsigned short film_grain_transfer_characteristics;
    unsigned short film_grain_matrix_coefficients; //[7:0]

    unsigned short blending_mode_id;
    unsigned short log2_scale_factor;
    unsigned short comp_model_present_flag[3]; //[2:0]

    unsigned short num_intensity_intervals_minus1[3];
    unsigned short num_model_values_minus1[3];

    unsigned char intensity_interval_lower_bound[3][256];
    unsigned char intensity_interval_upper_bound[3][256];

    unsigned short comp_model_value[3][256][8]; //[15:0]

    unsigned short film_grain_characteristics_repetition_period; //[14:0]

    unsigned short :16;		// padding
};

/* SEI 20: deblocking_filter_display_preference */

struct deblocking_filter_display_preference_t {
    unsigned short deblocking_display_preference_cancel_flag; //[0]
    unsigned short display_prior_to_deblocking_preferred_flag;
    unsigned short dec_frame_buffering_constraint_flag; //[0]
    unsigned short deblocking_display_preference_repetition_period; //[14:0]
};

/* SEI 21: stereo_video_info */

struct stereo_video_info_t {
    unsigned short field_views_flag; //[0]
    unsigned short top_field_is_left_view_flag; //[0]
    unsigned short current_frame_is_left_view_flag;
    unsigned short next_frame_is_second_view_flag; //[0]
    unsigned short left_view_self_contained_flag;
    unsigned short right_view_self_contained_flag; //[0]
};


/*
 * Encode information
 */

struct encode_info_t {
    unsigned short enc_width; //80..720 16x
    unsigned short enc_height; //80..576 16x
    unsigned short enc_rc_rate; //16..8000 kbps
    unsigned short enc_rc_frame_rate; //1..62
    unsigned short enc_ifrm_rate; //1..1023
    unsigned short sps_rate; //0..1023
    unsigned short pps_rate; //0..1023
    unsigned short enc_cpb_size;
    unsigned short enc_max_rate;
    unsigned short slice_mb_num;
    unsigned short enc_image_value; // Maximum QP
    unsigned short enc_initial_image_value; // Initial QP
    unsigned short enc_islice_image_mode; // Decrement Q for IDR
    unsigned short enc_min_qp_i; // Minimum QP for I-pic
    unsigned short enc_min_qp_p; // Minimum QP for P-pic

    // SPS
    unsigned short frm_crop_flag;
    unsigned short frm_crop_rect_lft_oft;
    unsigned short frm_crop_rect_rgt_oft;
    unsigned short frm_crop_rect_top_oft;
    unsigned short frm_crop_rect_btm_oft;
    unsigned short enc_vui_present_flag;
    unsigned short level_idc;

    // PPS
    unsigned short const_intra_pred_flg;
    unsigned short chroma_qp_idx_oft;

    // SH
    unsigned short dis_deblk_filter_idc_i;
    unsigned short slice_alpha_oft_div2_i;
    unsigned short slice_beta_oft_div2_i;
    unsigned short dis_deblk_filter_idc_p;
    unsigned short slice_alpha_oft_div2_p;
    unsigned short slice_beta_oft_div2_p;

    // SEI
    unsigned short enc_buffering_period_en;
    unsigned short enc_pic_timing_en;
    unsigned short enc_pan_scan_rect_en;
    unsigned short enc_sei_filler_en;

    unsigned short enc_aud_on; // Access unit delimiter
    unsigned short enc_fil_on; // Filler data
};


/*
 * Decode information
 */

struct decode_info_t {
    unsigned short dec_width;
    unsigned short dec_height;
    unsigned short frm_crop_flag;
    unsigned short frm_crop_rect_lft_oft;
    unsigned short frm_crop_rect_rgt_oft;
    unsigned short frm_crop_rect_top_oft;
    unsigned short frm_crop_rect_btm_oft;
    unsigned short nal_ref_idc;
    unsigned short nal_unit_type;

    unsigned short :16;		// padding
};

struct avc_buffer_address_t {
    unsigned int raster0_Y;
    unsigned int raster0_U;
    unsigned int raster0_V;
    unsigned int raster1_Y;
    unsigned int raster1_U;
    unsigned int raster1_V;
    unsigned int raster_select; // 0:raster0 1:raster1

    unsigned int stream0_base; // physical address
    unsigned int stream0_size;
    unsigned int stream1_base; // physical address
    unsigned int stream1_size;
    unsigned int stream_select; // 0:stream0 1:stream1

    unsigned int stream_buf_adr; //[r] physical address
    unsigned int enc_bit_cnt;    //[r] encoded bit quantity
    unsigned int change_endian;  // 1(default)/0
};

struct avc_work_address_t {
    unsigned int work_yuv01;
    unsigned int work_yuv02;
    unsigned int work_yuv03;
    unsigned int work_yuv04;
    unsigned int work_yuv05;
    unsigned int work_yuv06;
    unsigned int work_yuv07;
    unsigned int work_yuv08;
    unsigned int work_yuv09;
    unsigned int work_yuv10;
    unsigned int work_yuv11;
    unsigned int work_yuv12;
    unsigned int work_yuv13;
    unsigned int work_yuv14;
    unsigned int work_yuv15;
    unsigned int work_yuv16;
    unsigned int work_yuv17;
    unsigned int work_yuv18;
    unsigned int max_work_num;
};

struct avc_common_info_t {
    struct avc_buffer_address_t avc_buffer_address;
    struct avc_work_address_t avc_work_address;

    struct avc_user_set_parameter_t avc_user_set_parameter;

    struct encode_info_t encode_info;
    struct decode_info_t decode_info;

    struct aud_parameters_t aud_parameters;
    struct seq_parameter_set_rbsp_t seq_parameter_set_rbsp;
    struct pic_parameter_set_rbsp_t pic_parameter_set_rbsp;
    struct slice_header_t slice_header;

    /*
     * SEI
     */
    struct sei_decode_flags_t sei_decode_flags;

    struct buffering_period_t buffering_period; //0
    struct pic_timing_t pic_timing;
    struct pan_scan_rect_t pan_scan_rect;
    struct filler_payload_t filler_payload;
    struct user_data_registered_itu_t_t35_t user_data_registered_itu_t_t35;
    struct user_data_unregistered_t user_data_unregistered;
    struct recovery_point_t recovery_point;
    struct dec_ref_pic_marking_repetition_t dec_ref_pic_marking_repetition;
    struct spare_pic_t spare_pic;
    struct scene_info_t scene_info;
    struct sub_seq_info_t sub_seq_info; //10
    struct sub_seq_layer_characteristics_t sub_seq_layer_characteristics;
    struct sub_seq_characteristics_t sub_seq_characteristics;
    struct full_frame_freeze_t full_frame_freeze; //13
    struct full_frame_snapshot_t full_frame_snapshot; //15
    struct progressive_refinement_segment_start_t progressive_refinement_segment_start;
    struct progressive_refinement_segment_end_t progressive_refinement_segment_end;
    struct motion_constrained_slice_group_set_t motion_constrained_slice_group_set;
    struct film_grain_characteristics_t film_grain_characteristics;
    struct deblocking_filter_display_preference_t deblocking_filter_display_preference; //20
    struct stereo_video_info_t stereo_video_info;
};

#endif // __avc_common_info_h__
