/* 2009-09-04: File added and changed by Sony Corporation */
/*
 *  Copyright 2009 Sony Corporation.
 *
 *  This file is based on linux/include/asm-arm/arch-ne1/debug-macro.S
 */
/*
 * linux/include/asm-arm/arch-ne1/debug-macro.S
 *
 * Debugging macro include header
 *
 * Copyright (C) NEC Electronics Corporation 2007, 2008
 *
 * This file is based on include/asm-arm/arch-realview/debug-macro.S
 *
 * Copyright (C) 1994-1999 Russell King
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307	 USA
 */

#ifndef __ASM_ARCH_DEBUG_MACRO_S
#define __ASM_ARCH_DEBUG_MACRO_S

#include <asm/hardware.h>
#include <asm/arch/uart.h>
#include <linux/serial_reg.h>

	.macro	addruart,rx
	mrc 	p15, 0, \rx, c1, c0
	tst	\rx, #1					@ MMU enabled?
	ldreq	\rx, =MP200_LL_UART_BASE		@ physical base
	ldrne	\rx, =IO_ADDRESS(MP200_LL_UART_BASE)	@ virtual base
	.endm

	.macro	senduart,rd,rx
	strb	\rd, [\rx, #MP200_UART_TX]
	.endm

	.macro	busyuart,rd,rx
1002:	ldrb	\rd, [\rx, #MP200_UART_LSR]
	and	\rd, \rd, #UART_LSR_TEMT | UART_LSR_THRE
	teq	\rd, #UART_LSR_TEMT | UART_LSR_THRE
	bne	1002b
	.endm

	.macro	waituart,rd,rx
	.endm

#endif /* __ASM_ARCH_DEBUG_MACRO_S */
