/* 2010-08-25: File added by Sony Corporation */
/*
 *  File Name	    : linux/include/asm-arm/arch-mp200/dma.h
 *  Function	    : dmac
 *  Release Version : Ver 1.00
 *  Release Date    : 2006/10/18
 *
 *  Copyright (C) NEC Electronics Corporation 2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __ASM_ARM_ARCH_MP200_DMA_H
#define __ASM_ARM_ARCH_MP200_DMA_H

#define MAX_DMA_ADDRESS 		0xffffffff
#define MAX_DMA_CHANNELS		0	/* don't use standard DMA I/F */

#define MP200_DMAC_MAX_P_CHANNELS	4

#define	MP200_DMAC_OWNER_ACPU		0x00000000
#define	MP200_DMAC_OWNER_CCPU		0x01000000
#define	MP200_DMAC_OWNER_DSP		0x03000000

/* DMAC logical channel ID */

/* P0 for ACPU */
#define MP200_DMAC_M2M_ACPU_LCH0	(0x00|MP200_DMAC_OWNER_ACPU) /* M2M */
#define MP200_DMAC_ARM_LCH0		MP200_DMAC_M2M_ACPU_LCH0
#define MP200_DMAC_M2M_ACPU_LCH1	(0x01|MP200_DMAC_OWNER_ACPU) /* M2M */
#define MP200_DMAC_ARM_LCH1		MP200_DMAC_M2M_ACPU_LCH1
#define MP200_DMAC_M2M_ACPU_LCH2	(0x02|MP200_DMAC_OWNER_ACPU) /* M2M */
#define MP200_DMAC_ARM_LCH2		MP200_DMAC_M2M_ACPU_LCH2
#define MP200_DMAC_M2M_ACPU_LCH3	(0x03|MP200_DMAC_OWNER_ACPU) /* M2M */
#define MP200_DMAC_ARM_LCH3		MP200_DMAC_M2M_ACPU_LCH3
/* P0 for CCPU */
#define MP200_DMAC_M2M_CCPU_LCH0	(0x00|MP200_DMAC_OWNER_CCPU) /* M2M */
#define MP200_DMAC_M2M_CCPU_LCH1	(0x01|MP200_DMAC_OWNER_CCPU) /* M2M */
#define MP200_DMAC_M2M_CCPU_LCH2	(0x02|MP200_DMAC_OWNER_CCPU) /* M2M */
#define MP200_DMAC_M2M_CCPU_LCH3	(0x03|MP200_DMAC_OWNER_CCPU) /* M2M */
/* P0 for DSP */
#define MP200_DMAC_M2M_DSP_LCH0		(0x00|MP200_DMAC_OWNER_DSP) /* M2M */
#define MP200_DMAC_M2M_DSP_LCH1		(0x01|MP200_DMAC_OWNER_DSP) /* M2M */
#define MP200_DMAC_M2M_DSP_LCH2		(0x02|MP200_DMAC_OWNER_DSP) /* M2M */
#define MP200_DMAC_M2M_DSP_LCH3		(0x03|MP200_DMAC_OWNER_DSP) /* M2M */
#define MP200_DMAC_P0_MAX_L_CHANNELS	4

/* P1 dummy */
#define MP200_DMAC_P1_MAX_L_CHANNELS	0

/* P2 for ACPU */
#define MP200_DMAC_M2P_ACPU_LCH0	(0x40|MP200_DMAC_OWNER_ACPU) /* U70 */
#define MP200_DMAC_M2P_LCH0		MP200_DMAC_M2P_ACPU_LCH0
#define MP200_DMAC_M2P_ACPU_LCH1	(0x41|MP200_DMAC_OWNER_ACPU) /* U71 */
#define MP200_DMAC_M2P_LCH1		MP200_DMAC_M2P_ACPU_LCH1
#define MP200_DMAC_M2P_ACPU_LCH2	(0x42|MP200_DMAC_OWNER_ACPU) /* U72 */
#define MP200_DMAC_M2P_LCH2		MP200_DMAC_M2P_ACPU_LCH2
#define MP200_DMAC_M2P_ACPU_LCH3	(0x43|MP200_DMAC_OWNER_ACPU) /* U73 */
#define MP200_DMAC_M2P_LCH3		MP200_DMAC_M2P_ACPU_LCH3
#define MP200_DMAC_M2P_ACPU_LCH4	(0x44|MP200_DMAC_OWNER_ACPU) /* MOD1/MOD0 not secure */
#define MP200_DMAC_M2P_LCH4		MP200_DMAC_M2P_ACPU_LCH4
#define MP200_DMAC_M2P_ACPU_LCH5	(0x45|MP200_DMAC_OWNER_ACPU) /* MMM/MOD0 secure */
#define MP200_DMAC_M2P_LCH5		MP200_DMAC_M2P_ACPU_LCH5
#define MP200_DMAC_M2P_ACPU_LCH7	(0x47|MP200_DMAC_OWNER_ACPU) /* SI1 */
#define MP200_DMAC_M2P_LCH7		MP200_DMAC_M2P_ACPU_LCH7
#define MP200_DMAC_M2P_ACPU_LCH9	(0x49|MP200_DMAC_OWNER_ACPU) /* PM0 */
#define MP200_DMAC_M2P_LCH9		MP200_DMAC_M2P_ACPU_LCH9
#define MP200_DMAC_M2P_ACPU_LCH10	(0x4a|MP200_DMAC_OWNER_ACPU) /* PM1 */
#define MP200_DMAC_M2P_LCH10		MP200_DMAC_M2P_ACPU_LCH10
#define MP200_DMAC_M2P_ACPU_LCH11	(0x4b|MP200_DMAC_OWNER_ACPU) /* PM2 */
#define MP200_DMAC_M2P_LCH11		MP200_DMAC_M2P_ACPU_LCH11
#define MP200_DMAC_M2P_ACPU_LCH12	(0x4c|MP200_DMAC_OWNER_ACPU) /* SP0 */
#define MP200_DMAC_M2P_LCH12		MP200_DMAC_M2P_ACPU_LCH12
#define MP200_DMAC_M2P_ACPU_LCH13	(0x4d|MP200_DMAC_OWNER_ACPU) /* SP1 */
#define MP200_DMAC_M2P_LCH13		MP200_DMAC_M2P_ACPU_LCH13
#define MP200_DMAC_M2P_ACPU_LCH14	(0x4e|MP200_DMAC_OWNER_ACPU) /* SP2 */
#define MP200_DMAC_M2P_LCH14		MP200_DMAC_M2P_ACPU_LCH14
/* P2 for CCPU */
#define MP200_DMAC_M2P_CCPU_LCH0	(0x40|MP200_DMAC_OWNER_CCPU) /* U70 */
#define MP200_DMAC_M2P_CCPU_LCH1	(0x41|MP200_DMAC_OWNER_CCPU) /* U71 */
#define MP200_DMAC_M2P_CCPU_LCH2	(0x42|MP200_DMAC_OWNER_CCPU) /* U72 */
#define MP200_DMAC_M2P_CCPU_LCH3	(0x43|MP200_DMAC_OWNER_CCPU) /* U73 */
#define MP200_DMAC_M2P_CCPU_LCH4	(0x44|MP200_DMAC_OWNER_CCPU) /* MOD1/MOD0 not secure */
#define MP200_DMAC_M2P_CCPU_LCH5	(0x45|MP200_DMAC_OWNER_CCPU) /* MMM/MOD0 secure */
#define MP200_DMAC_M2P_CCPU_LCH7	(0x47|MP200_DMAC_OWNER_CCPU) /* SI1 */
#define MP200_DMAC_M2P_CCPU_LCH9	(0x49|MP200_DMAC_OWNER_CCPU) /* PM0 */
#define MP200_DMAC_M2P_CCPU_LCH10	(0x4a|MP200_DMAC_OWNER_CCPU) /* PM1 */
#define MP200_DMAC_M2P_CCPU_LCH11	(0x4b|MP200_DMAC_OWNER_CCPU) /* PM2 */
#define MP200_DMAC_M2P_CCPU_LCH12	(0x4c|MP200_DMAC_OWNER_CCPU) /* SP0 */
#define MP200_DMAC_M2P_CCPU_LCH13	(0x4d|MP200_DMAC_OWNER_CCPU) /* SP1 */
#define MP200_DMAC_M2P_CCPU_LCH14	(0x4e|MP200_DMAC_OWNER_CCPU) /* SP2 */
/* P2 for DSP */
#define MP200_DMAC_M2P_DSP_LCH0		(0x40|MP200_DMAC_OWNER_DSP) /* U70 */
#define MP200_DMAC_M2P_DSP_LCH1		(0x41|MP200_DMAC_OWNER_DSP) /* U71 */
#define MP200_DMAC_M2P_DSP_LCH2		(0x42|MP200_DMAC_OWNER_DSP) /* U72 */
#define MP200_DMAC_M2P_DSP_LCH3		(0x43|MP200_DMAC_OWNER_DSP) /* U73 */
#define MP200_DMAC_M2P_DSP_LCH4		(0x44|MP200_DMAC_OWNER_DSP) /* MOD1/MOD0 not secure */
#define MP200_DMAC_M2P_DSP_LCH5		(0x45|MP200_DMAC_OWNER_DSP) /* MMM/MOD0 secure */
#define MP200_DMAC_M2P_DSP_LCH7		(0x47|MP200_DMAC_OWNER_DSP) /* SI1 */
#define MP200_DMAC_M2P_DSP_LCH9		(0x49|MP200_DMAC_OWNER_DSP) /* PM0 */
#define MP200_DMAC_M2P_DSP_LCH10	(0x4a|MP200_DMAC_OWNER_DSP) /* PM1 */
#define MP200_DMAC_M2P_DSP_LCH11	(0x4b|MP200_DMAC_OWNER_DSP) /* PM2 */
#define MP200_DMAC_M2P_DSP_LCH12	(0x4c|MP200_DMAC_OWNER_DSP) /* SP0 */
#define MP200_DMAC_M2P_DSP_LCH13	(0x4d|MP200_DMAC_OWNER_DSP) /* SP1 */
#define MP200_DMAC_M2P_DSP_LCH14	(0x4e|MP200_DMAC_OWNER_DSP) /* SP2 */
#define MP200_DMAC_P2_MAX_L_CHANNELS	15	/* includes dummy LCH6 and 8 */

/* P3 for ACPU */
#define MP200_DMAC_P2M_ACPU_LCH0	(0x60|MP200_DMAC_OWNER_ACPU) /* U70 */
#define MP200_DMAC_P2M_LCH0		MP200_DMAC_P2M_ACPU_LCH0
#define MP200_DMAC_P2M_ACPU_LCH1	(0x61|MP200_DMAC_OWNER_ACPU) /* U71 */
#define MP200_DMAC_P2M_LCH1		MP200_DMAC_P2M_ACPU_LCH1
#define MP200_DMAC_P2M_ACPU_LCH2	(0x62|MP200_DMAC_OWNER_ACPU) /* U72 */
#define MP200_DMAC_P2M_LCH2		MP200_DMAC_P2M_ACPU_LCH2
#define MP200_DMAC_P2M_ACPU_LCH3	(0x63|MP200_DMAC_OWNER_ACPU) /* U73 */
#define MP200_DMAC_P2M_LCH3		MP200_DMAC_P2M_ACPU_LCH3
#define MP200_DMAC_P2M_ACPU_LCH4	(0x64|MP200_DMAC_OWNER_ACPU) /* MOD1/MOD0 not secure */
#define MP200_DMAC_P2M_LCH4		MP200_DMAC_P2M_ACPU_LCH4
#define MP200_DMAC_P2M_ACPU_LCH5	(0x65|MP200_DMAC_OWNER_ACPU) /* MMM/MOD0 secure */
#define MP200_DMAC_P2M_LCH5		MP200_DMAC_P2M_ACPU_LCH5
#define MP200_DMAC_P2M_ACPU_LCH7	(0x67|MP200_DMAC_OWNER_ACPU) /* SI1 */
#define MP200_DMAC_P2M_LCH7		MP200_DMAC_P2M_ACPU_LCH7
#define MP200_DMAC_P2M_ACPU_LCH9	(0x69|MP200_DMAC_OWNER_ACPU) /* PM0 */
#define MP200_DMAC_P2M_LCH9		MP200_DMAC_P2M_ACPU_LCH9
#define MP200_DMAC_P2M_ACPU_LCH10	(0x6a|MP200_DMAC_OWNER_ACPU) /* PM1 */
#define MP200_DMAC_P2M_LCH10		MP200_DMAC_P2M_ACPU_LCH10
#define MP200_DMAC_P2M_ACPU_LCH11	(0x6b|MP200_DMAC_OWNER_ACPU) /* PM2 */
#define MP200_DMAC_P2M_LCH11		MP200_DMAC_P2M_ACPU_LCH11
#define MP200_DMAC_P2M_ACPU_LCH12	(0x6c|MP200_DMAC_OWNER_ACPU) /* SP0 */
#define MP200_DMAC_P2M_LCH12		MP200_DMAC_P2M_ACPU_LCH12
#define MP200_DMAC_P2M_ACPU_LCH13	(0x6d|MP200_DMAC_OWNER_ACPU) /* SP1 */
#define MP200_DMAC_P2M_LCH13		MP200_DMAC_P2M_ACPU_LCH13
#define MP200_DMAC_P2M_ACPU_LCH14	(0x6e|MP200_DMAC_OWNER_ACPU) /* SP2 */
#define MP200_DMAC_P2M_LCH14		MP200_DMAC_P2M_ACPU_LCH14
/* P3 for CCPU */
#define MP200_DMAC_P2M_CCPU_LCH0	(0x60|MP200_DMAC_OWNER_CCPU) /* U70 */
#define MP200_DMAC_P2M_CCPU_LCH1	(0x61|MP200_DMAC_OWNER_CCPU) /* U71 */
#define MP200_DMAC_P2M_CCPU_LCH2	(0x62|MP200_DMAC_OWNER_CCPU) /* U72 */
#define MP200_DMAC_P2M_CCPU_LCH3	(0x63|MP200_DMAC_OWNER_CCPU) /* U73 */
#define MP200_DMAC_P2M_CCPU_LCH4	(0x64|MP200_DMAC_OWNER_CCPU) /* MOD1/MOD0 not secure */
#define MP200_DMAC_P2M_CCPU_LCH5	(0x65|MP200_DMAC_OWNER_CCPU) /* MMM/MOD0 secure */
#define MP200_DMAC_P2M_CCPU_LCH7	(0x67|MP200_DMAC_OWNER_CCPU) /* SI1 */
#define MP200_DMAC_P2M_CCPU_LCH9	(0x69|MP200_DMAC_OWNER_CCPU) /* PM0 */
#define MP200_DMAC_P2M_CCPU_LCH10	(0x6a|MP200_DMAC_OWNER_CCPU) /* PM1 */
#define MP200_DMAC_P2M_CCPU_LCH11	(0x6b|MP200_DMAC_OWNER_CCPU) /* PM2 */
#define MP200_DMAC_P2M_CCPU_LCH12	(0x6c|MP200_DMAC_OWNER_CCPU) /* SP0 */
#define MP200_DMAC_P2M_CCPU_LCH13	(0x6d|MP200_DMAC_OWNER_CCPU) /* SP1 */
#define MP200_DMAC_P2M_CCPU_LCH14	(0x6e|MP200_DMAC_OWNER_CCPU) /* SP2 */
/* P3 for DSP */
#define MP200_DMAC_P2M_DSP_LCH0		(0x60|MP200_DMAC_OWNER_DSP) /* U70 */
#define MP200_DMAC_P2M_DSP_LCH1		(0x61|MP200_DMAC_OWNER_DSP) /* U71 */
#define MP200_DMAC_P2M_DSP_LCH2		(0x62|MP200_DMAC_OWNER_DSP) /* U72 */
#define MP200_DMAC_P2M_DSP_LCH3		(0x63|MP200_DMAC_OWNER_DSP) /* U73 */
#define MP200_DMAC_P2M_DSP_LCH4		(0x64|MP200_DMAC_OWNER_DSP) /* MOD1/MOD0 not secure */
#define MP200_DMAC_P2M_DSP_LCH5		(0x65|MP200_DMAC_OWNER_DSP) /* MMM/MOD0 secure */
#define MP200_DMAC_P2M_DSP_LCH7		(0x67|MP200_DMAC_OWNER_DSP) /* SI1 */
#define MP200_DMAC_P2M_DSP_LCH9		(0x69|MP200_DMAC_OWNER_DSP) /* PM0 */
#define MP200_DMAC_P2M_DSP_LCH10	(0x6a|MP200_DMAC_OWNER_DSP) /* PM1 */
#define MP200_DMAC_P2M_DSP_LCH11	(0x6b|MP200_DMAC_OWNER_DSP) /* PM2 */
#define MP200_DMAC_P2M_DSP_LCH12	(0x6c|MP200_DMAC_OWNER_DSP) /* SP0 */
#define MP200_DMAC_P2M_DSP_LCH13	(0x6d|MP200_DMAC_OWNER_DSP) /* SP1 */
#define MP200_DMAC_P2M_DSP_LCH14	(0x6e|MP200_DMAC_OWNER_DSP) /* SP2 */
#define MP200_DMAC_P3_MAX_L_CHANNELS	15	/* includes dummy LCH6 and 8 */

typedef struct {
    volatile u32    aadd;		/* +0x00 source (start) address */
    volatile u32    aadp;		/* +0x04 source address pointer */
    volatile u32    aoff;		/* +0x08 source address offset (lower 16bit) */
    volatile u32    asize;		/* +0x0c source block size (lower 16bit) */
    volatile u32    asize_count;	/* +0x10 source block count (lower 4bit) */
    volatile u32    rfu0;		/* +0x14 */
    volatile u32    rfu1;		/* +0x18 */
    volatile u32    rfu2;		/* +0x1c */
    volatile u32    badd;		/* +0x20 destination (start) address */
    volatile u32    badp;		/* +0x24 destination address pointer */
    volatile u32    boff;		/* +0x28 destination address offset (lower 16bit) */
    volatile u32    bsize;		/* +0x2c destination block size (lower 16bit) */
    volatile u32    bsize_count;	/* +0x30 destination block count (lower 4bit) */
    volatile u32    rfu3;		/* +0x34 */
    volatile u32    rfu4;		/* +0x38 */
    volatile u32    rfu5;		/* +0x3c */
    volatile u32    leng;		/* +0x40 length (lower 24bit) */
    volatile u32    rcount;		/* +0x44 read length count (lower 24bit) */
    volatile u32    wcount;		/* +0x48 write length count (lower 24bit) */
    volatile u32    size;		/* +0x4c block size (lower 16bit) */
    volatile u32    mode;		/* +0x50 mode (lower 2bit and bit8) */
    volatile u32    time;		/* +0x54 timer (lower 24bit) */
    volatile u32    time_count; 	/* +0x58 timer count (lower 24bit) */
    volatile u32    rfu6[64 - 23];	/* +0x5c fill up to offset of 0xff */
} dma_regs_t;

/* for `aoff' `boff' setting */
#define MP200_DMAC_OFFSET_ADD		0x00000000
#define MP200_DMAC_OFFSET_SUB		0x00010000

/* for `mode' setting */
#define MP200_DMAC_BMODE_REPEAT 	0x100
#define MP200_DMAC_AMODE_BIT32		(0x0 << 4)
#define MP200_DMAC_AMODE_BIT16		(0x1 << 4)
#define MP200_DMAC_AMODE_BIT8		(0x2 << 4)
#define MP200_DMAC_AMODE_TIME		0x4

#define MP200_DMAC_AMODE_REPEAT 	0x1

#define MP200_DMAC_DEFMODE_32BIT (MP200_DMAC_AMODE_BIT32 | \
				  MP200_DMAC_ENDI_R3210 | \
				  MP200_DMAC_ENDI_W3210)
#define MP200_DMAC_DEFMODE_16BIT (MP200_DMAC_AMODE_BIT16 | \
				  MP200_DMAC_ENDI_R10 | \
				  MP200_DMAC_ENDI_W10)
#define MP200_DMAC_DEFMODE_8BIT MP200_DMAC_AMODE_BIT8

/* Endian conversion (byte lane selections) */
#define MP200_DMAC_ENDI_R		16
#define MP200_DMAC_ENDI_W		24
#define MP200_DMAC_ENDI(HH, HL, LH, LL, RW)	\
		((((HH) << 6) | ((HL) << 4) | ((LH) << 2) | (LL)) << (RW))
/* Endian(Read) for 32bit */
#define MP200_DMAC_ENDI_R0123	MP200_DMAC_ENDI(0, 1, 2, 3, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R0132	MP200_DMAC_ENDI(0, 1, 3, 2, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R0213	MP200_DMAC_ENDI(0, 2, 1, 3, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R0231	MP200_DMAC_ENDI(0, 2, 3, 1, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R0312	MP200_DMAC_ENDI(0, 3, 1, 2, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R0321	MP200_DMAC_ENDI(0, 3, 2, 1, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R1023	MP200_DMAC_ENDI(1, 0, 2, 3, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R1032	MP200_DMAC_ENDI(1, 0, 3, 2, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R1203	MP200_DMAC_ENDI(1, 2, 0, 3, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R1230	MP200_DMAC_ENDI(1, 2, 3, 0, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R1302	MP200_DMAC_ENDI(1, 3, 0, 2, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R1320	MP200_DMAC_ENDI(1, 3, 2, 0, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R2013	MP200_DMAC_ENDI(2, 0, 1, 3, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R2031	MP200_DMAC_ENDI(2, 0, 3, 1, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R2103	MP200_DMAC_ENDI(2, 1, 0, 3, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R2130	MP200_DMAC_ENDI(2, 1, 3, 0, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R2301	MP200_DMAC_ENDI(2, 3, 0, 1, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R2310	MP200_DMAC_ENDI(2, 3, 1, 0, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R3012	MP200_DMAC_ENDI(3, 0, 1, 2, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R3021	MP200_DMAC_ENDI(3, 0, 2, 1, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R3102	MP200_DMAC_ENDI(3, 1, 0, 2, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R3120	MP200_DMAC_ENDI(3, 1, 2, 0, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R3201	MP200_DMAC_ENDI(3, 2, 0, 1, MP200_DMAC_ENDI_R)
#define MP200_DMAC_ENDI_R3210	MP200_DMAC_ENDI(3, 2, 1, 0, MP200_DMAC_ENDI_R)
/* Endian(Write) for 32bit */
#define MP200_DMAC_ENDI_W0123	MP200_DMAC_ENDI(0, 1, 2, 3, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W0132	MP200_DMAC_ENDI(0, 1, 3, 2, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W0213	MP200_DMAC_ENDI(0, 2, 1, 3, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W0231	MP200_DMAC_ENDI(0, 2, 3, 1, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W0312	MP200_DMAC_ENDI(0, 3, 1, 2, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W0321	MP200_DMAC_ENDI(0, 3, 2, 1, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W1023	MP200_DMAC_ENDI(1, 0, 2, 3, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W1032	MP200_DMAC_ENDI(1, 0, 3, 2, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W1203	MP200_DMAC_ENDI(1, 2, 0, 3, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W1230	MP200_DMAC_ENDI(1, 2, 3, 0, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W1302	MP200_DMAC_ENDI(1, 3, 0, 2, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W1320	MP200_DMAC_ENDI(1, 3, 2, 0, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W2013	MP200_DMAC_ENDI(2, 0, 1, 3, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W2031	MP200_DMAC_ENDI(2, 0, 3, 1, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W2103	MP200_DMAC_ENDI(2, 1, 0, 3, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W2130	MP200_DMAC_ENDI(2, 1, 3, 0, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W2301	MP200_DMAC_ENDI(2, 3, 0, 1, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W2310	MP200_DMAC_ENDI(2, 3, 1, 0, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W3012	MP200_DMAC_ENDI(3, 0, 1, 2, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W3021	MP200_DMAC_ENDI(3, 0, 2, 1, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W3102	MP200_DMAC_ENDI(3, 1, 0, 2, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W3120	MP200_DMAC_ENDI(3, 1, 2, 0, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W3201	MP200_DMAC_ENDI(3, 2, 0, 1, MP200_DMAC_ENDI_W)
#define MP200_DMAC_ENDI_W3210	MP200_DMAC_ENDI(3, 2, 1, 0, MP200_DMAC_ENDI_W)
/* Endian(Read) for 16bit */
#define MP200_DMAC_ENDI_R01	MP200_DMAC_ENDI_R2301
#define MP200_DMAC_ENDI_R10	MP200_DMAC_ENDI_R3210
/* Endian(Write) for 16bit */
#define MP200_DMAC_ENDI_W01	MP200_DMAC_ENDI_W2301
#define MP200_DMAC_ENDI_W10	MP200_DMAC_ENDI_W3210

/* for checking interrupt status */
#define MP200_DMAC_INT_TIME_WR		0x80
#define MP200_DMAC_INT_ERROR_WR 	0x40
#define MP200_DMAC_INT_BLOCK_WR 	0x20
#define MP200_DMAC_INT_LENG_WR		0x10
#define MP200_DMAC_INT_TIME_RD		0x08
#define MP200_DMAC_INT_ERROR_RD 	0x04
#define MP200_DMAC_INT_BLOCK_RD 	0x02	/* Just indicate status on PCH0, Cause INT on only PCH2. */
#define MP200_DMAC_INT_LENG_RD		0x01	/* Never cause INT on any PCH's. Just indicate status. */

/* for setting interrupt mask */
#define MP200_DMAC_INT_TIME_EN		0x08
#define MP200_DMAC_INT_ERROR_EN 	0x04
#define MP200_DMAC_INT_BLOCK_EN 	0x02
#define MP200_DMAC_INT_LENG_EN		0x01

typedef void	(*dma_callback_t)(void *data, int intsts, int intrawsts);


extern int		mp200_request_dma(int channel, const char *device_id,
					  dma_callback_t callback, void *data,
					  dma_regs_t **dma_regs);
extern void		mp200_free_dma(int channel);
extern int		mp200_start_dma(int channel, dma_addr_t src_ptr, u_int size,
					dma_addr_t dst_ptr, int intmask);
extern int		mp200_dma_status(int channel);
extern int		mp200_dma_busy(void);
extern void		mp200_clear_dma(int channel);
extern void		mp200_reset_dma(int channel);
extern dma_addr_t	mp200_get_dma_pos(int channel);
extern void		mp200_stop_dma(int channel);
extern int		mp200_dma_writable_flag(int channel);

#endif /* __ASM_ARM_ARCH_MP200_DMA_H */
