/* 2009-10-02: File added and changed by Sony Corporation */
/*
 *  Copyright 2009 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __ASM_ARCH_GROVER_BOARD_H
#define __ASM_ARCH_GROVER_BOARD_H

/*
 * Base addresses of external devices
 */
#define GROVER_LAN_BASE		0x00000000

/*
 * GPIOs
 */
#define GROVER_GPIO_DIPSW1	GPIO_P2
#define GROVER_GPIO_DIPSW2	GPIO_P3
#define GROVER_GPIO_DIPSW3	GPIO_P4
#define GROVER_GPIO_DIPSW4	GPIO_P5
#define GROVER_GPIO_LED1	GPIO_P6
#define GROVER_GPIO_LED2	GPIO_P7
#define GROVER_GPIO_LED3	GPIO_P8
#define GROVER_GPIO_LED4	GPIO_P9
#define GROVER_GPIO_LAN_IRQ	GPIO_P77
#define GROVER_GPIO_LAN_RESET	GPIO_P78

/*
 * Interrupts
 */
#define GROVER_INT_LAN		INT_GPIO_77

/*
 * Board ID
 */
#define GROVER_BOARD_ID()	(system_rev & 0xf)
#define   GROVER_BOARD_ID_EMEVA01_GCP01	0x0
#define   GROVER_BOARD_ID_GCP02		0x1
#define   GROVER_BOARD_ID_GCP03		0x2

/*
 * Kernel low-level debugging
 */
#define MP200_LL_UART_PORT	0
#define MP200_LL_UART_BAUD	115200
#define MP200_LL_UART_BASE	MP200_UART0_BASE

/*
 * NBLArgs
 */
#define NBLARGS_STD_LEN		0x1000
#define NBLARGS_STD_ADDR	0xc1ffe000

#endif /* !__ASM_ARCH_GROVER_BOARD_H */
