/* 2009-03-05: File added and changed by Sony Corporation */
/*
 *  File Name       : linux/include/asm-arm/arch-mp200/irqs.h
 *  Function        : irq
 *  Release Version : Ver 1.00
 *  Release Date    : 2008/07/16
 *
 *  Copyright (C) NEC Electronics Corporation 2005-2008
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __ASM_ARM_ARCH_MP200_IRQS_H
#define __ASM_ARM_ARCH_MP200_IRQS_H

/*
 * Interrupt numbers
 */
#define INT_IRQ_0		0
#define INT_IRQ_1		1
#define INT_IRQ_2		2
#define INT_IRQ_3		3
#define INT_IRQ_4		4
#define INT_IRQ_5		5
#define INT_IRQ_6		6
#define INT_IRQ_7		7
#define INT_IRQ_8		8
#define INT_IRQ_9		9
#define INT_IRQ_10		10
#define INT_IRQ_11		11
#define INT_IRQ_12		12
#define INT_IRQ_13		13
#define INT_IRQ_14		14
#define INT_IRQ_15		15
#define INT_IRQ_16		16
#define INT_IRQ_17		17
#define INT_IRQ_18		18
#define INT_IRQ_19		19
#define INT_IRQ_20		20
#define INT_IRQ_21		21
#define INT_IRQ_22		22
#define INT_IRQ_23		23
#define INT_IRQ_24		24
#define INT_IRQ_25		25
#define INT_IRQ_26		26
#define INT_IRQ_27		27
#define INT_IRQ_28		28
#define INT_IRQ_29		29
#define INT_IRQ_30		30
#define INT_IRQ_31		31
#define INT_IRQ_32		32
#define INT_IRQ_33		33
#define INT_IRQ_34		34
#define INT_IRQ_35		35
#define INT_IRQ_36		36
#define INT_IRQ_37		37
#define INT_IRQ_38		38
#define INT_IRQ_39		39
#define INT_IRQ_40		40
#define INT_IRQ_41		41
#define INT_IRQ_42		42
#define INT_IRQ_43		43
#define INT_IRQ_44		44
#define INT_IRQ_45		45
#define INT_IRQ_46		46
#define INT_IRQ_47		47
#define INT_IRQ_48		48
#define INT_IRQ_49		49
#define INT_IRQ_50		50
#define INT_IRQ_51		51
#define INT_IRQ_52		52
#define INT_IRQ_53		53
#define INT_IRQ_54		54
#define INT_IRQ_55		55
#define INT_IRQ_56		56
#define INT_IRQ_57		57
#define INT_IRQ_58		58
#define INT_IRQ_59		59
#define INT_IRQ_60		60
#define INT_IRQ_61		61
#define INT_IRQ_62		62
#define INT_IRQ_63		63
#define INT_IRQ_64		64
#define INT_IRQ_65		65
#define INT_IRQ_66		66
#define INT_IRQ_67		67
#define INT_IRQ_68		68
#define INT_IRQ_69		69
#define INT_IRQ_70		70
#define INT_IRQ_71		71
#define INT_IRQ_72		72
#define INT_IRQ_73		73
#define INT_IRQ_74		74
#define INT_IRQ_75		75
#define INT_IRQ_76		76
#define INT_IRQ_77		77
#define INT_IRQ_78		78
#define INT_IRQ_79		79
#define INT_IRQ_80		80
#define INT_IRQ_81		81
#define INT_IRQ_82		82
#define INT_IRQ_83		83
#define INT_IRQ_84		84
#define INT_IRQ_85		85
#define INT_IRQ_86		86
#define INT_IRQ_87		87
#define INT_IRQ_88		88
#define INT_IRQ_89		89
#define INT_IRQ_90		90
#define INT_IRQ_91		91
#define INT_IRQ_92		92
#define INT_IRQ_93		93
#define INT_IRQ_94		94
#define INT_IRQ_95		95

#define INT_LAST		INT_IRQ_95

#define INT_ACPU		INT_IRQ_0
#define INT_DSP			INT_IRQ_3
#define INT_SDIASD		INT_IRQ_5
#define INT_SDIACC		INT_IRQ_6
#define INT_SDIBSD		INT_IRQ_7
#define INT_SDIBCC		INT_IRQ_8
#define INT_UART0		INT_IRQ_9
#define INT_UART1		INT_IRQ_10
#define INT_UART2		INT_IRQ_11
#define INT_PCM0		INT_IRQ_13
#define INT_PCM1		INT_IRQ_14
#define INT_SMU			INT_IRQ_17
#define INT_MWI			INT_IRQ_18
#define INT_PDMA		INT_IRQ_19
#define INT_LCD			INT_IRQ_20
#define INT_IMG			INT_IRQ_22
#define INT_ROT			INT_IRQ_23
#define INT_SP0			INT_IRQ_24
#define INT_SP1			INT_IRQ_25
#define INT_GIO6		INT_IRQ_26
#define INT_GIO7		INT_IRQ_27
#define INT_NTSC		INT_IRQ_28
#define INT_SDIC_SD		INT_IRQ_29
#define INT_SDIC_CC		INT_IRQ_30
#define INT_IIC			INT_IRQ_33
#define INT_TG0			INT_IRQ_34
#define INT_TG1			INT_IRQ_35
#define INT_TG2			INT_IRQ_36
#define INT_DMAPE0		INT_IRQ_37
#define INT_IIC2		INT_IRQ_39
#define INT_DMADSP		INT_IRQ_40
#define INT_USB			INT_IRQ_41
#define INT_SP2			INT_IRQ_42
#define INT_USBWAK		INT_IRQ_43
#define INT_TG3			INT_IRQ_44
#define INT_TG4			INT_IRQ_45
#define INT_TG5			INT_IRQ_46
#define INT_NAND		INT_IRQ_47
#define INT_DTV			INT_IRQ_48
#define INT_GIO0		INT_IRQ_50
#define INT_GIO1		INT_IRQ_51
#define INT_GIO2		INT_IRQ_52
#define INT_GIO3		INT_IRQ_53
#define INT_TIMER0		INT_IRQ_54
#define INT_TIMER1		INT_IRQ_55
#define INT_TIMER2		INT_IRQ_56
#define INT_TIMER3		INT_IRQ_57
#define INT_WDT0		INT_IRQ_58
#define INT_WDT1		INT_IRQ_59
#define INT_WDT2		INT_IRQ_60
#define INT_WDT3		INT_IRQ_61
#define INT_PMU_ACPU	INT_IRQ_65
#define INT_AVC_A		INT_IRQ_66
#define INT_AVC_C		INT_IRQ_67
#define INT_PWM			INT_IRQ_69
#define INT_IMC			INT_IRQ_70
#define INT_IPU_DMA		INT_IRQ_72
#define INT_ACPU_PMU	INT_IRQ_74
#define INT_ACPU_L2		INT_IRQ_75
#define INT_DCV			INT_IRQ_76
#define INT_MSP			INT_IRQ_77
#define INT_MMM			INT_IRQ_78
#define INT_GIO4		INT_IRQ_79
#define INT_GIO5		INT_IRQ_80
#define INT_SSD0		INT_IRQ_81
#define INT_SSD1		INT_IRQ_82
#define INT_SSD2		INT_IRQ_83
#define INT_SSD3		INT_IRQ_84

#define INT_AAXI_INT_A	INT_IRQ_88
#define INT_MEMC_ERR	INT_IRQ_89
#define INT_AB0_ERR		INT_IRQ_90
#define INT_PB1_ERR		INT_IRQ_91
#define INT_SRC_ERR		INT_IRQ_92
#define INT_AXL0_ERR	INT_IRQ_93


/*
 * IRQ Numbers for interrupts muxed through GPIO
 */
#define INT_GPIO_BASE	(INT_LAST + 1)
#define INT_GPIO_0		(INT_GPIO_BASE + 0)
#define INT_GPIO_1		(INT_GPIO_BASE + 1)
#define INT_GPIO_2		(INT_GPIO_BASE + 2)
#define INT_GPIO_3		(INT_GPIO_BASE + 3)
#define INT_GPIO_4		(INT_GPIO_BASE + 4)
#define INT_GPIO_5		(INT_GPIO_BASE + 5)
#define INT_GPIO_6		(INT_GPIO_BASE + 6)
#define INT_GPIO_7		(INT_GPIO_BASE + 7)
#define INT_GPIO_8		(INT_GPIO_BASE + 8)
#define INT_GPIO_9		(INT_GPIO_BASE + 9)
#define INT_GPIO_10		(INT_GPIO_BASE + 10)
#define INT_GPIO_11		(INT_GPIO_BASE + 11)
#define INT_GPIO_12		(INT_GPIO_BASE + 12)
#define INT_GPIO_13		(INT_GPIO_BASE + 13)
#define INT_GPIO_14		(INT_GPIO_BASE + 14)
#define INT_GPIO_15		(INT_GPIO_BASE + 15)
#define INT_GPIO_16		(INT_GPIO_BASE + 16)
#define INT_GPIO_17		(INT_GPIO_BASE + 17)
#define INT_GPIO_18		(INT_GPIO_BASE + 18)
#define INT_GPIO_19		(INT_GPIO_BASE + 19)
#define INT_GPIO_20		(INT_GPIO_BASE + 20)
#define INT_GPIO_21		(INT_GPIO_BASE + 21)
#define INT_GPIO_22		(INT_GPIO_BASE + 22)
#define INT_GPIO_23		(INT_GPIO_BASE + 23)
#define INT_GPIO_24		(INT_GPIO_BASE + 24)
#define INT_GPIO_25		(INT_GPIO_BASE + 25)
#define INT_GPIO_26		(INT_GPIO_BASE + 26)
#define INT_GPIO_27		(INT_GPIO_BASE + 27)
#define INT_GPIO_28		(INT_GPIO_BASE + 28)
#define INT_GPIO_29		(INT_GPIO_BASE + 29)
#define INT_GPIO_30		(INT_GPIO_BASE + 30)
#define INT_GPIO_31		(INT_GPIO_BASE + 31)
#define INT_GPIO_32		(INT_GPIO_BASE + 32)
#define INT_GPIO_33		(INT_GPIO_BASE + 33)
#define INT_GPIO_34		(INT_GPIO_BASE + 34)
#define INT_GPIO_35		(INT_GPIO_BASE + 35)
#define INT_GPIO_36		(INT_GPIO_BASE + 36)
#define INT_GPIO_37		(INT_GPIO_BASE + 37)
#define INT_GPIO_38		(INT_GPIO_BASE + 38)
#define INT_GPIO_39		(INT_GPIO_BASE + 39)
#define INT_GPIO_40		(INT_GPIO_BASE + 40)
#define INT_GPIO_41		(INT_GPIO_BASE + 41)
#define INT_GPIO_42		(INT_GPIO_BASE + 42)
#define INT_GPIO_43		(INT_GPIO_BASE + 43)
#define INT_GPIO_44		(INT_GPIO_BASE + 44)
#define INT_GPIO_45		(INT_GPIO_BASE + 45)
#define INT_GPIO_46		(INT_GPIO_BASE + 46)
#define INT_GPIO_47		(INT_GPIO_BASE + 47)
#define INT_GPIO_48		(INT_GPIO_BASE + 48)
#define INT_GPIO_49		(INT_GPIO_BASE + 49)
#define INT_GPIO_50		(INT_GPIO_BASE + 50)
#define INT_GPIO_51		(INT_GPIO_BASE + 51)
#define INT_GPIO_52		(INT_GPIO_BASE + 52)
#define INT_GPIO_53		(INT_GPIO_BASE + 53)
#define INT_GPIO_54		(INT_GPIO_BASE + 54)
#define INT_GPIO_55		(INT_GPIO_BASE + 55)
#define INT_GPIO_56		(INT_GPIO_BASE + 56)
#define INT_GPIO_57		(INT_GPIO_BASE + 57)
#define INT_GPIO_58		(INT_GPIO_BASE + 58)
#define INT_GPIO_59		(INT_GPIO_BASE + 59)
#define INT_GPIO_60		(INT_GPIO_BASE + 60)
#define INT_GPIO_61		(INT_GPIO_BASE + 61)
#define INT_GPIO_62		(INT_GPIO_BASE + 62)
#define INT_GPIO_63		(INT_GPIO_BASE + 63)
#define INT_GPIO_64		(INT_GPIO_BASE + 64)
#define INT_GPIO_65		(INT_GPIO_BASE + 65)
#define INT_GPIO_66		(INT_GPIO_BASE + 66)
#define INT_GPIO_67		(INT_GPIO_BASE + 67)
#define INT_GPIO_68		(INT_GPIO_BASE + 68)
#define INT_GPIO_69		(INT_GPIO_BASE + 69)
#define INT_GPIO_70		(INT_GPIO_BASE + 70)
#define INT_GPIO_71		(INT_GPIO_BASE + 71)
#define INT_GPIO_72		(INT_GPIO_BASE + 72)
#define INT_GPIO_73		(INT_GPIO_BASE + 73)
#define INT_GPIO_74		(INT_GPIO_BASE + 74)
#define INT_GPIO_75		(INT_GPIO_BASE + 75)
#define INT_GPIO_76		(INT_GPIO_BASE + 76)
#define INT_GPIO_77		(INT_GPIO_BASE + 77)
#define INT_GPIO_78		(INT_GPIO_BASE + 78)
#define INT_GPIO_79		(INT_GPIO_BASE + 79)
#define INT_GPIO_80		(INT_GPIO_BASE + 80)
#define INT_GPIO_81		(INT_GPIO_BASE + 81)
#define INT_GPIO_82		(INT_GPIO_BASE + 82)
#define INT_GPIO_83		(INT_GPIO_BASE + 83)
#define INT_GPIO_84		(INT_GPIO_BASE + 84)
#define INT_GPIO_85		(INT_GPIO_BASE + 85)
#define INT_GPIO_86		(INT_GPIO_BASE + 86)
#define INT_GPIO_87		(INT_GPIO_BASE + 87)
#define INT_GPIO_88		(INT_GPIO_BASE + 88)
#define INT_GPIO_89		(INT_GPIO_BASE + 89)
#define INT_GPIO_90		(INT_GPIO_BASE + 90)
#define INT_GPIO_91		(INT_GPIO_BASE + 91)
#define INT_GPIO_92		(INT_GPIO_BASE + 92)
#define INT_GPIO_93		(INT_GPIO_BASE + 93)
#define INT_GPIO_94		(INT_GPIO_BASE + 94)
#define INT_GPIO_95		(INT_GPIO_BASE + 95)
#define INT_GPIO_96		(INT_GPIO_BASE + 96)
#define INT_GPIO_97		(INT_GPIO_BASE + 97)
#define INT_GPIO_98		(INT_GPIO_BASE + 98)
#define INT_GPIO_99		(INT_GPIO_BASE + 99)
#define INT_GPIO_100	(INT_GPIO_BASE + 100)
#define INT_GPIO_101	(INT_GPIO_BASE + 101)
#define INT_GPIO_102	(INT_GPIO_BASE + 102)
#define INT_GPIO_103	(INT_GPIO_BASE + 103)
#define INT_GPIO_104	(INT_GPIO_BASE + 104)
#define INT_GPIO_105	(INT_GPIO_BASE + 105)
#define INT_GPIO_106	(INT_GPIO_BASE + 106)
#define INT_GPIO_107	(INT_GPIO_BASE + 107)
#define INT_GPIO_108	(INT_GPIO_BASE + 108)
#define INT_GPIO_109	(INT_GPIO_BASE + 109)
#define INT_GPIO_110	(INT_GPIO_BASE + 110)
#define INT_GPIO_111	(INT_GPIO_BASE + 111)
#define INT_GPIO_112	(INT_GPIO_BASE + 112)
#define INT_GPIO_113	(INT_GPIO_BASE + 113)
#define INT_GPIO_114	(INT_GPIO_BASE + 114)
#define INT_GPIO_115	(INT_GPIO_BASE + 115)
#define INT_GPIO_116	(INT_GPIO_BASE + 116)
#define INT_GPIO_117	(INT_GPIO_BASE + 117)
#define INT_GPIO_118	(INT_GPIO_BASE + 118)
#define INT_GPIO_119	(INT_GPIO_BASE + 119)
#define INT_GPIO_120	(INT_GPIO_BASE + 120)
#define INT_GPIO_121	(INT_GPIO_BASE + 121)
#define INT_GPIO_122	(INT_GPIO_BASE + 122)
#define INT_GPIO_123	(INT_GPIO_BASE + 123)
#define INT_GPIO_124	(INT_GPIO_BASE + 124)
#define INT_GPIO_125	(INT_GPIO_BASE + 125)
#define INT_GPIO_126	(INT_GPIO_BASE + 126)
#define INT_GPIO_127	(INT_GPIO_BASE + 127)

#define INT_GPIO_LAST	INT_GPIO_127

#ifdef CONFIG_MACH_MP200
#define INT_GPIO_INTOUT		INT_GPIO_0
#define INT_GPIO_ETHER_INT	INT_GPIO_4
#define INT_GPIO_USB_INT	INT_GPIO_7
#define INT_GPIO_TS_INT		INT_GPIO_10
#endif /* CONFIG_MACH_MP200 */

/* 5T735 IRQ */
#define INT_PWC_BASE		(INT_GPIO_LAST + 1)

#define INT_PWC_MASK1_BASE	INT_PWC_BASE
#define INT_PWC_IO00		(INT_PWC_MASK1_BASE + 0)
#define INT_PWC_IO01		(INT_PWC_MASK1_BASE + 1)
#define INT_PWC_IO02		(INT_PWC_MASK1_BASE + 2)
#define INT_PWC_IO03		(INT_PWC_MASK1_BASE + 3)
#define INT_PWC_IO04		(INT_PWC_MASK1_BASE + 4)
#define INT_PWC_IO05		(INT_PWC_MASK1_BASE + 5)
#define INT_PWC_IO06		(INT_PWC_MASK1_BASE + 6)
#define INT_PWC_IO07		(INT_PWC_MASK1_BASE + 7)

#define INT_PWC_MASK1_LAST	INT_PWC_IO07

#define INT_PWC_MASK2_BASE	(INT_PWC_MASK1_LAST + 1)
#define INT_PWC_IO08		(INT_PWC_MASK2_BASE + 0)
#define INT_PWC_IO09		(INT_PWC_MASK2_BASE + 1)
#define INT_PWC_IO10		(INT_PWC_MASK2_BASE + 2)
#define INT_PWC_IO11		(INT_PWC_MASK2_BASE + 3)
#define INT_PWC_IO12		(INT_PWC_MASK2_BASE + 4)
#define INT_PWC_IO13		(INT_PWC_MASK2_BASE + 5)
#define INT_PWC_IO14		(INT_PWC_MASK2_BASE + 6)
#define INT_PWC_IO15		(INT_PWC_MASK2_BASE + 7)

#define INT_PWC_MASK2_LAST	INT_PWC_IO15

#define INT_PWC_MASK3_BASE	(INT_PWC_MASK2_LAST + 1)
#define INT_PWC_ADINT		(INT_PWC_MASK3_BASE + 0)
#define INT_PWC_RTCINT		(INT_PWC_MASK3_BASE + 1)
#define INT_PWC_CHGINT		(INT_PWC_MASK3_BASE + 2)
#define INT_PWC_PWOFINT		(INT_PWC_MASK3_BASE + 3)
#define INT_PWC_PWUPINT		(INT_PWC_MASK3_BASE + 4)
#define INT_PWC_USBWAKINT	(INT_PWC_MASK3_BASE + 4)
#define INT_PWC_DETBATINT	(INT_PWC_MASK3_BASE + 5)
#define INT_PWC_DETADPINT	(INT_PWC_MASK3_BASE + 6)
#define INT_PWC_DETUSBINT	(INT_PWC_MASK3_BASE + 7)

#define INT_PWC_MASK3_LAST	INT_PWC_DETUSBINT
#define INT_PWC_LAST		INT_PWC_MASK3_LAST

#ifdef CONFIG_MACH_MP200
#define INT_PWC_GPIO_KEY_DATA0	INT_PWC_IO00
#define INT_PWC_GPIO_KEY_DATA1	INT_PWC_IO01
#define INT_PWC_GPIO_KEY_DATA2	INT_PWC_IO02
#define INT_PWC_GPIO_KEY_DATA3	INT_PWC_IO03
#endif /* CONFIG_MACH_MP200 */


#define MAXIRQNUM		INT_PWC_LAST
#define MAXFIQNUM		MAXIRQNUM
#define MAXSWINUM		MAXIRQNUM

#define NR_IRQS			(MAXIRQNUM + 1)

/*
 * Interrupt detection
 */
#define __IRQT_ASYNC		(1 << 31)

#ifndef __ASSEMBLY__
extern void mp200_init_irq(void);
#endif

#include <asm/arch/hardware.h>

/*
 * Define the timer interrupt for PREEMPT_RT case
 */
#define ARCH_TIMER_IRQ		INT_STI

#endif				/* __ASM_ARM_ARCH_MP200_IRQS_H */
