/* 2009-07-11: File added and changed by Sony Corporation */
/*
 *  Copyright 2009 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __ASM_ARCH_MMC_SD_H
#define __ASM_ARCH_MMC_SD_H

#include <linux/pm.h>
#include <linux/platform_device.h>
#include <linux/mmc/host.h>

struct mp200_mmc_sdi {
	u_int32_t mmc_base;
	u_int32_t mmc_clockgate;
	u_int32_t mmc_resetdevice;
	u_int32_t mmc_waitctrl;
	u_int32_t mmc_readctrl;
	u_int32_t mmc_int;
	u_int32_t mmc_dma_rx_ch;
	u_int32_t mmc_dma_tx_ch;
	unsigned int *mmc_save;
};

struct mp200_mmc_sd_platform_data
{
	struct mp200_mmc_sdi *mmc_sdi;
	/* target-dependent operations */
	int (*mmc_sd_get_ro)(struct mmc_host *mmc);
	int (*mmc_sd_probe)(struct platform_device *pdev, struct mmc_host *mmc);
	void (*mmc_sd_remove)(struct platform_device *pdev);
	int (*mmc_sd_suspend)(struct platform_device *pdev, pm_message_t state);
	int (*mmc_sd_resume)(struct platform_device *pdev);
};

#ifdef CONFIG_SNSC_MMC_SD_MP200_MULTIPLE_HOSTS
extern struct mp200_mmc_sdi mp200_mmc_sdia;
extern struct mp200_mmc_sdi mp200_mmc_sdib;
#endif /* CONFIG_SNSC_MMC_SD_MP200_MULTIPLE_HOSTS */

#endif /* __ASM_ARCH_MMC_SD_H */
