/* 2010-08-25: File added by Sony Corporation */
/*
*  File Name       : /include/asm-arm/arch-mp200/MMU.h
*  Function        : IPU MMIO definitions, and Driver - Driver I/F of IPU driver
*  Release Version : Ver 1.00
*  Release Date    : 2006/11/20
*
*  Copyright (C) NEC Electronics Corporation 2006
*
*
*  This program is free software;you can redistribute it and/or modify it under the terms of
*  the GNU General Public License as published by Free Softwere Foundation; either version 2
*  of License, or (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
*  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*  See the GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License along with this program;
*  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
*  MA 02111-1307, USA.
*
*/

/* History */
/*-----------+------+------------------+-------------------+------------------------------------------------*/
/* Date      |Rev.No|Name              |KeyWord            | Reason                                         */
/*-----------+------+------------------+-------------------+------------------------------------------------*/
/* 2006/11/20| 1.00 | M.Sasaki         |                   |                                                */
/*-----------+------+------------------+-------------------+------------------------------------------------*/
/* 2007/02/22|      | Y.Utsuhara       |                   |                                                */
/*-----------+------+------------------+-------------------+------------------------------------------------*/

#ifndef _MMU_H_
#define _MMU_H_


/*===============================================================*/
/* MMU register bit assigns                                      */
/*===============================================================*/

/*------------------------------*/
/* IMG_MMU_MODE                 */
/*------------------------------*/
#define IMG_MMU_DST_EN_BIT          0x00040000
#define IMG_MMU_DST_EN_SFT          18

#define IMG_MMU_SRC2_EN_BIT         0x00020000
#define IMG_MMU_SRC2_EN_SFT         17

#define IMG_MMU_SRC1_EN_BIT         0x00010000
#define IMG_MMU_SRC1_EN_SFT         16

#define IMG_MMU_CHK_PERMISSION_BIT  0x00000020
#define IMG_MMU_CHK_PERMISSION_SFT  5

#define IMG_MMU_CHK_PAGEMODE_BIT    0x00000010
#define IMG_MMU_CHK_PAGEMODE_SFT    4

#define IMG_MMU_PRMMODE_BIT         0x00000008
#define IMG_MMU_PRMMODE_SFT         3

#define IMG_MMU_ARMMODE_BIT         0x00000004
#define IMG_MMU_ARMMODE_SFT         2

#define IMG_MMU_PAGEMODE_BIT        0x00000002
#define IMG_MMU_PAGEMODE_SFT        1

#define IMG_MMU_EN_BIT              0x00000001
#define IMG_MMU_EN_SFT              0


/*------------------------------*/
/* ROT_MMU_MODE                 */
/*------------------------------*/
#define ROT_MMU_DST_EN_BIT          0x00020000
#define ROT_MMU_DST_EN_SFT          17

#define ROT_MMU_SRC_EN_BIT          0x00010000
#define ROT_MMU_SRC_EN_SFT          16

#define ROT_MMU_CHK_PERMISSION_BIT  0x00000020
#define ROT_MMU_CHK_PERMISSION_SFT  5

#define ROT_MMU_CHK_PAGEMODE_BIT    0x00000010
#define ROT_MMU_CHK_PAGEMODE_SFT    4

#define ROT_MMU_PRMMODE_BIT         0x00000008
#define ROT_MMU_PRMMODE_SFT         3

#define ROT_MMU_ARMMODE_BIT         0x00000004
#define ROT_MMU_ARMMODE_SFT         2

#define ROT_MMU_PAGEMODE_BIT        0x00000002
#define ROT_MMU_PAGEMODE_SFT        1

#define ROT_MMU_EN_BIT              0x00000001
#define ROT_MMU_EN_SFT              0


/*------------------------------*/
/* DMA_MMU_MODE                 */
/*------------------------------*/
#define DMA_MMU_DST_EN_BIT          0x00040000
#define DMA_MMU_DST_EN_SFT          18

#define DMA_MMU_SRC2_EN_BIT         0x00020000
#define DMA_MMU_SRC2_EN_SFT         17

#define DMA_MMU_SRC1_EN_BIT         0x00010000
#define DMA_MMU_SRC1_EN_SFT         16

#define DMA_MMU_CHK_PERMISSION_BIT  0x00000020
#define DMA_MMU_CHK_PERMISSION_SFT  5

#define DMA_MMU_CHK_PAGEMODE_BIT    0x00000010
#define DMA_MMU_CHK_PAGEMODE_SFT    4

#define DMA_MMU_PRMMODE_BIT         0x00000008
#define DMA_MMU_PRMMODE_SFT         3

#define DMA_MMU_ARMMODE_BIT         0x00000004
#define DMA_MMU_ARMMODE_SFT         2

#define DMA_MMU_PAGEMODE_BIT        0x00000002
#define DMA_MMU_PAGEMODE_SFT        1

#define DMA_MMU_EN_BIT              0x00000001
#define DMA_MMU_EN_SFT              0


/*------------------------------*/
/* IMG_MMU_STATUS1              */
/* ROT_MMU_STATUS1              */
/* DMA_MMU_STATUS1              */
/*------------------------------*/
#define MMU_STATUS1_VA_BIT          0xFFFFFFFF
#define MMU_STATUS1_VA_SFT          0


/*------------------------------*/
/* IMG_MMU_STATUS2              */
/* ROT_MMU_STATUS2              */
/* DMA_MMU_STATUS2              */
/*------------------------------*/
#define MMU_STATUS2_SBA_BIT         0xFFFFF000
#define MMU_STATUS2_SBA_SFT         12

#define MMU_STATUS2_SAP_BIT         0x0000000C
#define MMU_STATUS2_SAP_SFT         2

#define MMU_STATUS2_SPM_BIT         0x00000001
#define MMU_STATUS2_SPM_SFT         0


/*------------------------------*/
/* IMG_MMU_CTRL                 */
/* ROT_MMU_CTRL                 */
/* DMA_MMU_CTRL                 */
/*------------------------------*/
#define MMU_CTRL_IAE_BIT            0x00000001
#define MMU_CTRL_IAE_SFT            0


/*------------------------------*/
/* IMG_MMU_1Dx                  */
/* ROT_MMU_1Dx                  */
/* DMA_MMU_1Dx                  */
/*------------------------------*/
#define MMU_F_BA_x_BIT              0xFFFFFC00
#define MMU_F_BA_x_SFT              10


/*------------------------------*/
/* IMG_MMU_INDEXx               */
/* ROT_MMU_INDEXx               */
/* DMA_MMU_INDEXx               */
/*------------------------------*/
#define MMU_F_INDX_x_BIT            0xFFF00000
#define MMU_F_INDX_x_SFT            20

#define MMU_F_VLD_x_BIT             0x00000001
#define MMU_F_VLD_x_SFT             0


#define IMG_MMU_MODE_PRESET         (1 << IMG_MMU_CHK_PERMISSION_SFT | \
                                     1 << IMG_MMU_CHK_PAGEMODE_SFT   | \
                                     0 << IMG_MMU_PRMMODE_SFT        | \
                                     0 << IMG_MMU_ARMMODE_SFT        | \
                                     0 << IMG_MMU_PAGEMODE_SFT        )
#define ROT_MMU_MODE_PRESET         (1 << ROT_MMU_CHK_PERMISSION_SFT | \
                                     1 << ROT_MMU_CHK_PAGEMODE_SFT   | \
                                     0 << ROT_MMU_PRMMODE_SFT        | \
                                     0 << ROT_MMU_ARMMODE_SFT        | \
                                     0 << ROT_MMU_PAGEMODE_SFT        )
#define DMA_MMU_MODE_PRESET         (1 << DMA_MMU_CHK_PERMISSION_SFT | \
                                     1 << DMA_MMU_CHK_PAGEMODE_SFT   | \
                                     0 << DMA_MMU_PRMMODE_SFT        | \
                                     0 << DMA_MMU_ARMMODE_SFT        | \
                                     0 << DMA_MMU_PAGEMODE_SFT        )


#endif /* _MMU_H_ */
