/* 2009-04-09: File added and changed by Sony Corporation */
/*
 *  File Name       : linux/include/asm-arm/arch-mp200/mp200_board.h
 *  Function        : mp200_board
 *  Release Version : Ver 1.01
 *  Release Date    : 2006/02/22
 *
 *  Copyright (C) NEC Electronics Corporation 2005-2006
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __ASM_ARCH_MP200_BOARD_H
#define __ASM_ARCH_MP200_BOARD_H

/* BANK 0 -- ASYNC0 1/3 [NOR FLASH] */
#define MP200_BANK0_BASE	0x00000000

#define MP200_FLASH_BASE	MP200_BANK0_BASE
#define MP200_FLASH_SIZE	(SZ_64M * 2)

/* BANK 1 -- ASYNC0 2/3 [NAND FLASH] */
#define MP200_BANK1_BASE	0x10000000

#define MP200_NAND_DATA_BASE	(MP200_BANK1_BASE + 0x00000000)
#define MP200_NAND_COMMAND_BASE	(MP200_BANK1_BASE + 0x00020000)
#define MP200_NAND_ADDRESS_BASE	(MP200_BANK1_BASE + 0x00040000)

/* BANK 2 -- ASYNC0 3/3 */
#define MP200_BANK2_BASE	0x20000000

#define MP200_LOGPSRAM_OFFSET	0x0c000000
#define MP200_LOGPSRAM_SIZE	SZ_16M
#define MP200_ETHER_OFFSET	0x00000000
#define MP200_ETHER_SIZE	SZ_4K


#define MP200_LOGPSRAM_BASE	(MP200_BANK2_BASE+MP200_LOGPSRAM_OFFSET)
#define MP200_ETHER_BASE	(MP200_BANK2_BASE+MP200_ETHER_OFFSET)

#define MP200_LOGPSRAM_VIRT	0xd1000000

/* Kernel low-level debugging */
#define MP200_LL_UART_PORT	0
#define MP200_LL_UART_BAUD	115200
#define MP200_LL_UART_BASE	MP200_UART0_BASE

/* NBLArgs */
#define NBLARGS_STD_LEN		0x1000
#define NBLARGS_STD_ADDR	0xc1ffe000

#endif				/* __ASM_ARCH_MP200_BOARD_H */
