/* 2010-08-25: File added by Sony Corporation */
/*
 *  File Name	    : linux/include/asm-arm/arch-mp200/pcm_irq.h
 *  Function	    : Power Management
 *  Release Version : Ver 1.00
 *  Release Date    : 2009/02/12
 *
 *  Copyright (C) NEC Electronics Corporation 2009
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */
#ifndef __ASM_ARM_ARCH_MP200_PCM_IRQ_H
#define __ASM_ARM_ARCH_MP200_PCM_IRQ_H

#define MP200_PCMMODE_NONE	0
#define MP200_PCMMODE_ALSA	1
#define MP200_PCMMODE_DSP	2

typedef irqreturn_t (*pcm_callback_t)(int irq_no, void *data);

extern int mp200_pcm0_request_irq(irq_handler_t handler, unsigned long irqflags, 
	const char *devname, void *dev_id, unsigned int pcmmode);
extern void mp200_pcm0_free_irq(void *dev_id, unsigned int pcmmode);
extern int mp200_pdma_request_irq(irq_handler_t handler, unsigned long irqflags, 
	const char *devname, void *dev_id, unsigned int pcmmode);
extern void mp200_pdma_free_irq(void *dev_id, unsigned int pcmmode);

extern unsigned int mp200_pcm0_get_pcmmode(void);
#endif /* __ASM_ARM_ARCH_MP200_PCM_IRQ_H */
