/* 2010-08-25: File added by Sony Corporation */
/*
 *  File Name	    : linux/include/asm-arm/arch-mp200/pmu.h
 *  Function	    : pmu
 *  Release Version : Ver 1.01
 *  Release Date    : 2008/08/27
 *
 *  Copyright (C) NEC Electronics Corporation 2008
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __ASM_ARM_ARCH_MP200_PMU_H
#define __ASM_ARM_ARCH_MP200_PMU_H

#define SMU_GCLKCTRL0_GROUP		(0 << 16)
#define SMU_GCLKCTRL1_GROUP		(1 << 16)
#define SMU_GCLKCTRL2_GROUP		(2 << 16)
#define SMU_GCLKCTRL3_GROUP		(3 << 16)
#define SMU_GCLKCTRL4_GROUP		(4 << 16)

#define SMU_RESETREQ0_GROUP		(5 << 16)
#define SMU_RESETREQ1_GROUP		(6 << 16)
#define SMU_RESETREQ2_GROUP		(7 << 16)
#define SMU_RESETREQ3_GROUP		(8 << 16)


#define SMU_AHBCLKCTRL0_GROUP	(16 << 16)
#define SMU_AHBCLKCTRL1_GROUP	(17 << 16)
#define SMU_APBCLKCTRL0_GROUP	(18 << 16)
#define SMU_APBCLKCTRL1_GROUP	(19 << 16)
#define SMU_CLKCTRL_GROUP		(20 << 16)
#define SMU_APBCLKCTRL2_GROUP	(21 << 16)

#define SMU_REG_GROUP_MASK		0xffff0000
#define SMU_REG_BIT_MASK		0x0000ffff
#define SMU_REG_MAX_BIT_LEN		32


#define MP200_CLOCKGATE_DMA_TCLK		(SMU_GCLKCTRL0_GROUP | 30)
#define MP200_CLOCKGATE_DMA_PCH3_CLK	(SMU_GCLKCTRL0_GROUP | 29)
#define MP200_CLOCKGATE_DMA_PCH2_CLK	(SMU_GCLKCTRL0_GROUP | 28)
#define MP200_CLOCKGATE_DMA_PCH0_CLK	(SMU_GCLKCTRL0_GROUP | 26)
#define MP200_CLOCKGATE_DMA_PCLK		(SMU_GCLKCTRL0_GROUP | 25)
#define MP200_CLOCKGATE_IMC_PCLK		(SMU_GCLKCTRL0_GROUP | 19)
#define MP200_CLOCKGATE_IMC_CLK			(SMU_GCLKCTRL0_GROUP | 18)
#define MP200_CLOCKGATE_IPUAHB_CLK		(SMU_GCLKCTRL0_GROUP | 17)
#define MP200_CLOCKGATE_IPUDMA_PCLK		(SMU_GCLKCTRL0_GROUP | 16)
#define MP200_CLOCKGATE_IPUDMA_CLK		(SMU_GCLKCTRL0_GROUP | 15)
#define MP200_CLOCKGATE_ROT_PCLK		(SMU_GCLKCTRL0_GROUP | 14)
#define MP200_CLOCKGATE_ROT_CLK 		(SMU_GCLKCTRL0_GROUP | 13)
#define MP200_CLOCKGATE_IMG_PCLK		(SMU_GCLKCTRL0_GROUP | 12)
#define MP200_CLOCKGATE_IMG_2_CLK		(SMU_GCLKCTRL0_GROUP | 11)
#define MP200_CLOCKGATE_IMG_1_CLK		(SMU_GCLKCTRL0_GROUP | 10)
#define MP200_CLOCKGATE_PDMA_PCLK		(SMU_GCLKCTRL0_GROUP | 7)
#define MP200_CLOCKGATE_PDMA_HCLK		(SMU_GCLKCTRL0_GROUP | 6)
#define MP200_CLOCKGATE_PDMA_ACLK		(SMU_GCLKCTRL0_GROUP | 5)
#define MP200_CLOCKGATE_DSP_ACLK		(SMU_GCLKCTRL0_GROUP | 1)
#define MP200_CLOCKGATE_DSP_CLK 		(SMU_GCLKCTRL0_GROUP | 0)

/* */
#define MP200_CLOCKGATE_AVC_HSCLK		(SMU_GCLKCTRL1_GROUP | 31)
#define MP200_CLOCKGATE_AVC_HMCLK		(SMU_GCLKCTRL1_GROUP | 30)
#define MP200_CLOCKGATE_AVC_CLKM		(SMU_GCLKCTRL1_GROUP | 29)
#define MP200_CLOCKGATE_AVC_CLKE		(SMU_GCLKCTRL1_GROUP | 28)
#define MP200_CLOCKGATE_AVC_CLKD		(SMU_GCLKCTRL1_GROUP | 27)
#define MP200_CLOCKGATE_AVC_CLKC		(SMU_GCLKCTRL1_GROUP | 26)
#define MP200_CLOCKGATE_DCV_PCLK 		(SMU_GCLKCTRL1_GROUP | 25)
#define MP200_CLOCKGATE_DCV_CLK 		(SMU_GCLKCTRL1_GROUP | 24)
#define MP200_CLOCKGATE_AB1_CLK 		(SMU_GCLKCTRL1_GROUP | 23)
#define MP200_CLOCKGATE_PB0_CLK 		(SMU_GCLKCTRL1_GROUP | 22)
#define MP200_CLOCKGATE_AXL1_PMON_CLK	(SMU_GCLKCTRL1_GROUP | 21)
#define MP200_CLOCKGATE_MHXB_CLK		(SMU_GCLKCTRL1_GROUP | 20)
#define MP200_CLOCKGATE_DHXB_CLK		(SMU_GCLKCTRL1_GROUP | 19)
#define MP200_CLOCKGATE_SWL1_CLK		(SMU_GCLKCTRL1_GROUP | 18)
#define MP200_CLOCKGATE_AXL1_PCLK		(SMU_GCLKCTRL1_GROUP | 17)
#define MP200_CLOCKGATE_AXL1_CLK		(SMU_GCLKCTRL1_GROUP | 16)
#define MP200_CLOCKGATE_CHG_PCLK		(SMU_GCLKCTRL1_GROUP | 15)
#define MP200_CLOCKGATE_AINT_PCLK		(SMU_GCLKCTRL1_GROUP | 14)

#define MP200_CLOCKGATE_LCD_CCLK		(SMU_GCLKCTRL1_GROUP | 12)
#define MP200_CLOCKGATE_LCD_LCLK		(SMU_GCLKCTRL1_GROUP | 11)
#define MP200_CLOCKGATE_LCD_PCLK		(SMU_GCLKCTRL1_GROUP | 10)
#define MP200_CLOCKGATE_LCD_CLK 		(SMU_GCLKCTRL1_GROUP | 9)
#define MP200_CLOCKGATE_SRC_CLK 		(SMU_GCLKCTRL1_GROUP | 8)
#define MP200_CLOCKGATE_MEMC_RCLK 		(SMU_GCLKCTRL1_GROUP | 7)
#define MP200_CLOCKGATE_MEMC_PCLK 		(SMU_GCLKCTRL1_GROUP | 6)
#define MP200_CLOCKGATE_MEMC_CLK270 	(SMU_GCLKCTRL1_GROUP | 5)
#define MP200_CLOCKGATE_MEMC_CLK		(SMU_GCLKCTRL1_GROUP | 4)
#define MP200_CLOCKGATE_SWL0_CLK		(SMU_GCLKCTRL1_GROUP | 2)
#define MP200_CLOCKGATE_AXL0_PCLK		(SMU_GCLKCTRL1_GROUP | 1)
#define MP200_CLOCKGATE_AXL0_CLK		(SMU_GCLKCTRL1_GROUP | 0)

/* */
#define MP200_CLOCKGATE_SHXB_HCLK 		(SMU_GCLKCTRL2_GROUP | 30)
#define MP200_CLOCKGATE_SHXB_CLK 		(SMU_GCLKCTRL2_GROUP | 29)
#define MP200_CLOCKGATE_DTV_PCLK		(SMU_GCLKCTRL2_GROUP | 26)
#define MP200_CLOCKGATE_DTV_CLK 		(SMU_GCLKCTRL2_GROUP | 25)
#define MP200_CLOCKGATE_NTS_PCLK		(SMU_GCLKCTRL2_GROUP | 24)
#define MP200_CLOCKGATE_NTS_CLK			(SMU_GCLKCTRL2_GROUP | 23)
#define MP200_CLOCKGATE_NAND_PCLK		(SMU_GCLKCTRL2_GROUP | 22)
#define MP200_CLOCKGATE_NAND_HCLK		(SMU_GCLKCTRL2_GROUP | 21)
#define MP200_CLOCKGATE_REFCLK			(SMU_GCLKCTRL2_GROUP | 20)
#define MP200_CLOCKGATE_MSP_RTCK		(SMU_GCLKCTRL2_GROUP | 19)
#define MP200_CLOCKGATE_MSP_SCLK		(SMU_GCLKCTRL2_GROUP | 18)
#define MP200_CLOCKGATE_MSP_PCLK		(SMU_GCLKCTRL2_GROUP | 17)
#define MP200_CLOCKGATE_MMM_CLK			(SMU_GCLKCTRL2_GROUP | 16)
#define MP200_CLOCKGATE_PM1_SCLK		(SMU_GCLKCTRL2_GROUP | 14)
#define MP200_CLOCKGATE_PM0_SCLK		(SMU_GCLKCTRL2_GROUP | 13)
#define MP200_CLOCKGATE_PM0_PCLK		(SMU_GCLKCTRL2_GROUP | 12)
#define MP200_CLOCKGATE_USB_CLK 		(SMU_GCLKCTRL2_GROUP | 11)
#define MP200_CLOCKGATE_U72_SCLK		(SMU_GCLKCTRL2_GROUP | 8)
#define MP200_CLOCKGATE_U71_SCLK		(SMU_GCLKCTRL2_GROUP | 7)
#define MP200_CLOCKGATE_U70_SCLK		(SMU_GCLKCTRL2_GROUP | 6)
#define MP200_CLOCKGATE_U70_CLK 		(SMU_GCLKCTRL2_GROUP | 5)
#define MP200_CLOCKGATE_IIC_SCLK		(SMU_GCLKCTRL2_GROUP | 4)
#define MP200_CLOCKGATE_IIC_CLK 		(SMU_GCLKCTRL2_GROUP | 3)
#define MP200_CLOCKGATE_IIC2_SCLK		(SMU_GCLKCTRL2_GROUP | 2)
#define MP200_CLOCKGATE_IIC2_CLK		(SMU_GCLKCTRL2_GROUP | 1)

/* */
#define MP200_CLOCKGATE_FLASHCLK 		(SMU_GCLKCTRL3_GROUP | 31)
#define MP200_CLOCKGATE_EFS_PCLK 		(SMU_GCLKCTRL3_GROUP | 30)
#define MP200_CLOCKGATE_PWM_PWCLK1		(SMU_GCLKCTRL3_GROUP | 29)
#define MP200_CLOCKGATE_PWM_PWCLK0		(SMU_GCLKCTRL3_GROUP | 28)
#define MP200_CLOCKGATE_PWM_PCLK		(SMU_GCLKCTRL3_GROUP | 27)
#define MP200_CLOCKGATE_SP2_SCLK		(SMU_GCLKCTRL3_GROUP | 26)
#define MP200_CLOCKGATE_SP2_PCLK		(SMU_GCLKCTRL3_GROUP | 25)
#define MP200_CLOCKGATE_SP1_SCLK		(SMU_GCLKCTRL3_GROUP | 24)
#define MP200_CLOCKGATE_SP1_PCLK		(SMU_GCLKCTRL3_GROUP | 23)
#define MP200_CLOCKGATE_SP0_SCLK		(SMU_GCLKCTRL3_GROUP | 22)
#define MP200_CLOCKGATE_SP0_PCLK		(SMU_GCLKCTRL3_GROUP | 21)
#define MP200_CLOCKGATE_MWI_SCLK		(SMU_GCLKCTRL3_GROUP | 20)
#define MP200_CLOCKGATE_MWI_PCLK		(SMU_GCLKCTRL3_GROUP | 19)
#define MP200_CLOCKGATE_ATIM_PCLK		(SMU_GCLKCTRL3_GROUP | 14)
#define MP200_CLOCKGATE_TW3_TIN 		(SMU_GCLKCTRL3_GROUP | 13)
#define MP200_CLOCKGATE_TW2_TIN 		(SMU_GCLKCTRL3_GROUP | 12)
#define MP200_CLOCKGATE_TW1_TIN 		(SMU_GCLKCTRL3_GROUP | 11)
#define MP200_CLOCKGATE_TW0_TIN 		(SMU_GCLKCTRL3_GROUP | 10)
#define MP200_CLOCKGATE_TG5_TIN 		(SMU_GCLKCTRL3_GROUP | 9)
#define MP200_CLOCKGATE_TG4_TIN 		(SMU_GCLKCTRL3_GROUP | 8)
#define MP200_CLOCKGATE_TG3_TIN 		(SMU_GCLKCTRL3_GROUP | 7)
#define MP200_CLOCKGATE_TG2_TIN 		(SMU_GCLKCTRL3_GROUP | 6)
#define MP200_CLOCKGATE_TG1_TIN 		(SMU_GCLKCTRL3_GROUP | 5)
#define MP200_CLOCKGATE_TG0_TIN 		(SMU_GCLKCTRL3_GROUP | 4)
#define MP200_CLOCKGATE_TI3_TIN 		(SMU_GCLKCTRL3_GROUP | 3)
#define MP200_CLOCKGATE_TI2_TIN 		(SMU_GCLKCTRL3_GROUP | 2)
#define MP200_CLOCKGATE_TI1_TIN 		(SMU_GCLKCTRL3_GROUP | 1)
#define MP200_CLOCKGATE_TI0_TIN 		(SMU_GCLKCTRL3_GROUP | 0)

#define MP200_CLOCKGATE_PM1_CLK			(SMU_GCLKCTRL4_GROUP | 9)
#define MP200_CLOCKGATE_PM0_CLK			(SMU_GCLKCTRL4_GROUP | 8)
#define MP200_CLOCKGATE_SDIC_CLK		(SMU_GCLKCTRL4_GROUP | 7)
#define MP200_CLOCKGATE_SDIB_CLK		(SMU_GCLKCTRL4_GROUP | 6)
#define MP200_CLOCKGATE_SDIA_CLK		(SMU_GCLKCTRL4_GROUP | 5)


#define MP200_RESETDEVICE_U72			(SMU_RESETREQ0_GROUP | 29)
#define MP200_RESETDEVICE_U71			(SMU_RESETREQ0_GROUP | 28)
#define MP200_RESETDEVICE_U70			(SMU_RESETREQ0_GROUP | 27)
#define MP200_RESETDEVICE_GIO			(SMU_RESETREQ0_GROUP | 26)
#define MP200_RESETDEVICE_AINT			(SMU_RESETREQ0_GROUP | 25)
#define MP200_RESETDEVICE_SRC			(SMU_RESETREQ0_GROUP | 24)
#define MP200_RESETDEVICE_PB1			(SMU_RESETREQ0_GROUP | 23)
#define MP200_RESETDEVICE_PB0			(SMU_RESETREQ0_GROUP | 22)
#define MP200_RESETDEVICE_AB1			(SMU_RESETREQ0_GROUP | 21)
#define MP200_RESETDEVICE_AB0			(SMU_RESETREQ0_GROUP | 20)
#define MP200_RESETDEVICE_NTS			(SMU_RESETREQ0_GROUP | 19)
#define MP200_RESETDEVICE_DTV			(SMU_RESETREQ0_GROUP | 18)
#define MP200_RESETDEVICE_IMC			(SMU_RESETREQ0_GROUP | 17)
#define MP200_RESETDEVICE_AVC			(SMU_RESETREQ0_GROUP | 15)
#define MP200_RESETDEVICE_DMA			(SMU_RESETREQ0_GROUP | 14)
#define MP200_RESETDEVICE_LCD			(SMU_RESETREQ0_GROUP | 13)
#define MP200_RESETDEVICE_IPUAHB		(SMU_RESETREQ0_GROUP | 11)
#define MP200_RESETDEVICE_IPUDMA		(SMU_RESETREQ0_GROUP | 10)
#define MP200_RESETDEVICE_IPUROT		(SMU_RESETREQ0_GROUP | 9)
#define MP200_RESETDEVICE_IPUIMG		(SMU_RESETREQ0_GROUP | 8)
#define MP200_RESETDEVICE_DCV			(SMU_RESETREQ0_GROUP | 5)
#define MP200_RESETDEVICE_ADSP_S		(SMU_RESETREQ0_GROUP | 4)
#define MP200_RESETDEVICE_ADSP_A		(SMU_RESETREQ0_GROUP | 3)
#define MP200_RESETDEVICE_ACPU_AT		(SMU_RESETREQ0_GROUP | 2)
#define MP200_RESETDEVICE_ACPU_PO		(SMU_RESETREQ0_GROUP | 1)
#define MP200_RESETDEVICE_ACPU			(SMU_RESETREQ0_GROUP | 0)

#define MP200_RESETDEVICE_MMM			(SMU_RESETREQ1_GROUP | 30)
#define MP200_RESETDEVICE_MSP			(SMU_RESETREQ1_GROUP | 29)
#define MP200_RESETDEVICE_USB			(SMU_RESETREQ1_GROUP | 28)
#define MP200_RESETDEVICE_NAND			(SMU_RESETREQ1_GROUP | 27)
#define MP200_RESETDEVICE_IIC			(SMU_RESETREQ1_GROUP | 26)
#define MP200_RESETDEVICE_IIC2			(SMU_RESETREQ1_GROUP | 25)
#define MP200_RESETDEVICE_SP2			(SMU_RESETREQ1_GROUP | 24)
#define MP200_RESETDEVICE_SP1			(SMU_RESETREQ1_GROUP | 23)
#define MP200_RESETDEVICE_SP0			(SMU_RESETREQ1_GROUP | 22)
#define MP200_RESETDEVICE_MWI			(SMU_RESETREQ1_GROUP | 21)
#define MP200_RESETDEVICE_PDMA			(SMU_RESETREQ1_GROUP | 19)
#define MP200_RESETDEVICE_PM1			(SMU_RESETREQ1_GROUP | 17)
#define MP200_RESETDEVICE_PM0			(SMU_RESETREQ1_GROUP | 16)
#define MP200_RESETDEVICE_TG5			(SMU_RESETREQ1_GROUP | 13)
#define MP200_RESETDEVICE_TG4			(SMU_RESETREQ1_GROUP | 12)
#define MP200_RESETDEVICE_TG3			(SMU_RESETREQ1_GROUP | 11)
#define MP200_RESETDEVICE_TG2			(SMU_RESETREQ1_GROUP | 10)
#define MP200_RESETDEVICE_TG1			(SMU_RESETREQ1_GROUP | 9)
#define MP200_RESETDEVICE_TG0			(SMU_RESETREQ1_GROUP | 8)
#define MP200_RESETDEVICE_TW3			(SMU_RESETREQ1_GROUP | 7)
#define MP200_RESETDEVICE_TW2			(SMU_RESETREQ1_GROUP | 6)
#define MP200_RESETDEVICE_TW1			(SMU_RESETREQ1_GROUP | 5)
#define MP200_RESETDEVICE_TW0			(SMU_RESETREQ1_GROUP | 4)
#define MP200_RESETDEVICE_TI3			(SMU_RESETREQ1_GROUP | 3)
#define MP200_RESETDEVICE_TI2			(SMU_RESETREQ1_GROUP | 2)
#define MP200_RESETDEVICE_TI1			(SMU_RESETREQ1_GROUP | 1)
#define MP200_RESETDEVICE_TI0			(SMU_RESETREQ1_GROUP | 0)

#define MP200_RESETDEVICE_PMU			(SMU_RESETREQ2_GROUP | 12)
#define MP200_RESETDEVICE_CHG			(SMU_RESETREQ2_GROUP | 10)
#define MP200_RESETDEVICE_PWM			(SMU_RESETREQ2_GROUP | 9)
#define MP200_RESETDEVICE_SHXB			(SMU_RESETREQ2_GROUP | 6)
#define MP200_RESETDEVICE_DXHB			(SMU_RESETREQ2_GROUP | 5)
#define MP200_RESETDEVICE_MHXB			(SMU_RESETREQ2_GROUP | 4)
#define MP200_RESETDEVICE_SWL1			(SMU_RESETREQ2_GROUP | 3)
#define MP200_RESETDEVICE_SWL0			(SMU_RESETREQ2_GROUP | 2)
#define MP200_RESETDEVICE_AXL1			(SMU_RESETREQ2_GROUP | 1)
#define MP200_RESETDEVICE_AXL0			(SMU_RESETREQ2_GROUP | 0)

#define MP200_RESETDEVICE_SDIC			(SMU_RESETREQ3_GROUP | 4)
#define MP200_RESETDEVICE_SDIB			(SMU_RESETREQ3_GROUP | 3)
#define MP200_RESETDEVICE_SDIA			(SMU_RESETREQ3_GROUP | 2)


#define MP200_CLKCTRL_AVCHSCK			(SMU_AHBCLKCTRL0_GROUP | 31)
#define MP200_CLKCTRL_AVCHMCK			(SMU_AHBCLKCTRL0_GROUP | 30)
#define MP200_CLKCTRL_AVCCKM			(SMU_AHBCLKCTRL0_GROUP | 29)
#define MP200_CLKCTRL_AVCCKE			(SMU_AHBCLKCTRL0_GROUP | 28)
#define MP200_CLKCTRL_AVCCKD			(SMU_AHBCLKCTRL0_GROUP | 27)
#define MP200_CLKCTRL_AVCCKC			(SMU_AHBCLKCTRL0_GROUP | 26)
#define MP200_CLKCTRL_MMM				(SMU_AHBCLKCTRL0_GROUP | 25)
#define MP200_CLKCTRL_NTS				(SMU_AHBCLKCTRL0_GROUP | 24)
#define MP200_CLKCTRL_NAND				(SMU_AHBCLKCTRL0_GROUP | 23)
#define MP200_CLKCTRL_IMC				(SMU_AHBCLKCTRL0_GROUP | 22)
#define MP200_CLKCTRL_MSP				(SMU_AHBCLKCTRL0_GROUP | 20)
#define MP200_CLKCTRL_DTV				(SMU_AHBCLKCTRL0_GROUP | 19)
#define MP200_CLKCTRL_DMAPCH3			(SMU_AHBCLKCTRL0_GROUP | 18)
#define MP200_CLKCTRL_DMAPCH2			(SMU_AHBCLKCTRL0_GROUP | 17)
#define MP200_CLKCTRL_DMAPCH0			(SMU_AHBCLKCTRL0_GROUP | 15)
#define MP200_CLKCTRL_LCDCCK			(SMU_AHBCLKCTRL0_GROUP | 14)
#define MP200_CLKCTRL_LCD				(SMU_AHBCLKCTRL0_GROUP | 13)
#define MP200_CLKCTRL_IPUAHB			(SMU_AHBCLKCTRL0_GROUP | 11)
#define MP200_CLKCTRL_IPUDMA			(SMU_AHBCLKCTRL0_GROUP | 10)
#define MP200_CLKCTRL_IPUROT			(SMU_AHBCLKCTRL0_GROUP | 9)
#define MP200_CLKCTRL_IPUIMG2			(SMU_AHBCLKCTRL0_GROUP | 8)
#define MP200_CLKCTRL_IPUIMG1			(SMU_AHBCLKCTRL0_GROUP | 7)
#define MP200_CLKCTRL_PDMAACK			(SMU_AHBCLKCTRL0_GROUP | 6)
#define MP200_CLKCTRL_PDMAHCK			(SMU_AHBCLKCTRL0_GROUP | 5)
#define MP200_CLKCTRL_ADSP				(SMU_AHBCLKCTRL0_GROUP | 1)
#define MP200_CLKCTRL_ACPU				(SMU_AHBCLKCTRL0_GROUP | 0)

#define MP200_CLKCTRL_AXL1HCLK			(SMU_AHBCLKCTRL1_GROUP | 15)
#define MP200_CLKCTRL_AXL0HCLK			(SMU_AHBCLKCTRL1_GROUP | 14)
#define MP200_CLKCTRL_SHXBHCLK			(SMU_AHBCLKCTRL1_GROUP | 13)
#define MP200_CLKCTRL_SHXB				(SMU_AHBCLKCTRL1_GROUP | 12)
#define MP200_CLKCTRL_MHXB				(SMU_AHBCLKCTRL1_GROUP | 11)
#define MP200_CLKCTRL_DHXB				(SMU_AHBCLKCTRL1_GROUP | 10)
#define MP200_CLKCTRL_AXL1				(SMU_AHBCLKCTRL1_GROUP | 9)
#define MP200_CLKCTRL_AXL0				(SMU_AHBCLKCTRL1_GROUP | 8)
#define MP200_CLKCTRL_SWL1				(SMU_AHBCLKCTRL1_GROUP | 7)
#define MP200_CLKCTRL_SWL0				(SMU_AHBCLKCTRL1_GROUP | 6)
#define MP200_CLKCTRL_SRC				(SMU_AHBCLKCTRL1_GROUP | 5)
#define MP200_CLKCTRL_MEMC				(SMU_AHBCLKCTRL1_GROUP | 4)
#define MP200_CLKCTRL_PB1				(SMU_AHBCLKCTRL1_GROUP | 3)
#define MP200_CLKCTRL_PB0				(SMU_AHBCLKCTRL1_GROUP | 2)
#define MP200_CLKCTRL_AB1				(SMU_AHBCLKCTRL1_GROUP | 1)
#define MP200_CLKCTRL_AB0				(SMU_AHBCLKCTRL1_GROUP | 0)

#define MP200_CLKCTRL_IPUDMACLK			(SMU_APBCLKCTRL0_GROUP | 16)
#define MP200_CLKCTRL_IMCPCLK			(SMU_APBCLKCTRL0_GROUP | 15)
#define MP200_CLKCTRL_NANDPCLK			(SMU_APBCLKCTRL0_GROUP | 14)
#define MP200_CLKCTRL_NTSPCLK			(SMU_APBCLKCTRL0_GROUP | 12)
#define MP200_CLKCTRL_DCVPCLK			(SMU_APBCLKCTRL0_GROUP | 9)
#define MP200_CLKCTRL_AXIPCLK			(SMU_APBCLKCTRL0_GROUP | 8)
#define MP200_CLKCTRL_SP2PCLK			(SMU_APBCLKCTRL0_GROUP | 7)
#define MP200_CLKCTRL_PWMPCLK			(SMU_APBCLKCTRL0_GROUP | 6)
#define MP200_CLKCTRL_DTVPCLK			(SMU_APBCLKCTRL0_GROUP | 5)
#define MP200_CLKCTRL_DMAPCLK			(SMU_APBCLKCTRL0_GROUP | 4)
#define MP200_CLKCTRL_IPUROTPCLK		(SMU_APBCLKCTRL0_GROUP | 2)
#define MP200_CLKCTRL_IPUIMGPCLK		(SMU_APBCLKCTRL0_GROUP | 1)
#define MP200_CLKCTRL_LCDPCLK			(SMU_APBCLKCTRL0_GROUP | 0)

#define MP200_CLKCTRL_AXL0PCLK			(SMU_APBCLKCTRL1_GROUP | 15)
#define MP200_CLKCTRL_CHGPCLK			(SMU_APBCLKCTRL1_GROUP | 13)
#define MP200_CLKCTRL_MSPPCLK			(SMU_APBCLKCTRL1_GROUP | 11)	/* no exist ?*/
#define MP200_CLKCTRL_PDMAPCLK			(SMU_APBCLKCTRL1_GROUP | 10)
#define MP200_CLKCTRL_GIOPCLK			(SMU_APBCLKCTRL1_GROUP | 9)
#define MP200_CLKCTRL_SP1PCLK			(SMU_APBCLKCTRL1_GROUP | 8)
#define MP200_CLKCTRL_SP0PCLK			(SMU_APBCLKCTRL1_GROUP | 7)
#define MP200_CLKCTRL_PMUPCLK			(SMU_APBCLKCTRL1_GROUP | 6)
#define MP200_CLKCTRL_SMUPCLK			(SMU_APBCLKCTRL1_GROUP | 5)
#define MP200_CLKCTRL_MWIPCLK			(SMU_APBCLKCTRL1_GROUP | 4)
#define MP200_CLKCTRL_TIMPCLK			(SMU_APBCLKCTRL1_GROUP | 3)
#define MP200_CLKCTRL_INTPCLK			(SMU_APBCLKCTRL1_GROUP | 2)
#define MP200_CLKCTRL_MEMCPCLK			(SMU_APBCLKCTRL1_GROUP | 1)

#define MP200_CLKCTRL_PM1PCLK			(SMU_APBCLKCTRL2_GROUP | 3)
#define MP200_CLKCTRL_PM0PCLK			(SMU_APBCLKCTRL2_GROUP | 2)

#define MP200_CLKCTRL_FLASH_CLK			(SMU_CLKCTRL_GROUP | 5)
#define MP200_CLKCTRL_SP2SCLK			(SMU_CLKCTRL_GROUP | 4)
#define MP200_CLKCTRL_SP1SCLK			(SMU_CLKCTRL_GROUP | 3)
#define MP200_CLKCTRL_SP0SCLK			(SMU_CLKCTRL_GROUP | 2)
#define MP200_CLKCTRL_MWISCLK			(SMU_CLKCTRL_GROUP | 1)
#define MP200_CLKCTRL_MEMCCLK270		(SMU_CLKCTRL_GROUP | 0)

extern int mp200_pmu_open_clockgate(unsigned int clkbit);
extern int mp200_pmu_close_clockgate(unsigned int clkbit);
extern int mp200_pmu_get_clockgate(unsigned int clkbit);

extern int mp200_pmu_reset_device(unsigned int rstdevl);
extern int mp200_pmu_unreset_device(unsigned int rstdevl);
extern int mp200_pmu_get_reset_status(unsigned int rstdevl);

extern int mp200_pmu_clkctrl_on(unsigned int dev);
extern int mp200_pmu_clkctrl_off(unsigned int dev);
extern int mp200_pmu_get_clkctrl_status(unsigned int dev);

#endif	/* __ASM_ARM_ARCH_MP200_PMU_H */
