/* 2010-08-25: File added by Sony Corporation */
/*
 *  File Name       : linux/include/asm-arm/arch-mp200/pwc.h
 *  Function        : pwc
 *  Release Version : Ver 1.00
 *  Release Date    : 2007/06/25
 *
 *  Copyright (C) NEC Electronics Corporation 2007
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */
#ifndef _ASM_ARCH_PWC_H_
#define _ASM_ARCH_PWC_H_

/* Power register */
#define PWC_REGA		0x0002	/* write */
#define PWC_PSCNT1		0x0004	/* write */
#define PWC_PSCNT2		0x0006	/* write */
#define PWC_MODESET1	0x0008	/* write */
#define PWC_VOUTSET1	0x000A	/* write */
#define PWC_VOUTSET2	0x000C	/* write */
#define PWC_VOUTSET3	0x000E	/* write */

/* GPIO register */
#define PWC_IOSEL1		0x0010	/* write */
#define PWC_IOSEL2		0x0012	/* write */
#define PWC_IOOUT1		0x0014	/* write */
#define PWC_IOIN1		0x0015	/* read  */
#define PWC_IOOUT2		0x0016	/* write */
#define PWC_IOIN2		0x0017	/* read  */
#define PWC_GPPUPD1		0x0018	/* write */
#define PWC_GPPUPD2		0x001A	/* write */
#define PWC_GPPUPD3		0x001C	/* write */
#define PWC_GPPUPD4		0x001E	/* write */

/* INTC register */
#define PWC_FMASK1		0x0020	/* write */
#define PWC_FACTOR1		0x0021	/* read  */
#define PWC_FMASK2		0x0022	/* write */
#define PWC_FACTOR2		0x0023	/* read  */
#define PWC_FMASK3		0x0024	/* write */
#define PWC_FACTOR3		0x0025	/* read  */
#define PWC_STATE1		0x0026	/* write */
#define PWC_STATE2		0x0028	/* write */
#define PWC_STATE3		0x002A	/* write */
#define PWC_CLRFACT1	0x002C	/* write */
#define PWC_CLRFACT2	0x002E	/* write */
#define PWC_CLRFACT3	0x0030	/* write */
#define PWC_DETMOD1L	0x0032	/* write */
#define PWC_DETMOD1H	0x0034	/* write */
#define PWC_DETMOD2L	0x0036	/* write */
#define PWC_DETMOD2H	0x0038	/* write */
#define PWC_DETMOD3L	0x003A	/* write */
#define PWC_DETMOD3H	0x003C	/* write */
#define PWC_BMASK1		0x003E	/* write */
#define PWC_BMASK2		0x0040	/* write */
#define PWC_BMASK3		0x0042	/* write */
#define PWC_REGPWONMSK	0x004C	/* write */
#define PWC_WRSTFCT		0x006D	/* read  */
#define PWC_WRSTCL		0x006E	/* write */
#define PWC_WRSTMSK		0x0092	/* write */
#define PWC_WAKECONT	0x0094	/* write */

/* Power switch register */
#define PWC_PSW_STATE	0x0065	/* read  */

/* ADC register */
#define PWC_ADDATA1		0x004D	/* read  */
#define PWC_ADMODE		0x004E	/* write */
#define PWC_ADDATA2		0x004F	/* read  */
#define PWC_VCCVBATSW	0x0050	/* write */
#define PWC_ADDATA3		0x0051	/* read  */
#define PWC_VCCADPSW	0x0052	/* write */
#define PWC_VCCVBUSSW	0x0052	/* write */
#define PWC_ADDATA4		0x0053	/* read  */
#define PWC_ADDATA5		0x0055	/* read  */
#define PWC_ADDATA6		0x0057	/* read  */
#define PWC_ADDATA7		0x0059	/* read  */
#define PWC_ADDATA8		0x005B	/* read  */

/* Charge register */
#define PWC_CHGCNTR1	0x005C	/* write */
#define PWC_CHGIRR		0x005D	/* read  */
#define PWC_CHGIRCL		0x005E	/* write */
#define PWC_CHGSTATE	0x005F	/* read  */
#define PWC_TIMCNTR		0x0060	/* write */
#define PWC_CVSETR		0x0062	/* write */
#define PWC_CHGCNTR2	0x0064	/* write */

/* Reset register */
#define PWC_SFTRST		0x0066	/* write */
#define PWC_RDET_EN		0x0068	/* write */
#define PWC_PWRSWCONT	0x006A	/* write */
#define PWC_DETIOCONT	0x006C	/* write */

/* LSI discrimination register */
#define PWC_LSIVER		0x006F	/* read  */

/* RTC register */
#define PWC_SEC			0x0070	/* write */
#define PWC_SEC_RD		0x0071	/* read  */
#define PWC_MIN			0x0072	/* write */
#define PWC_MIN_RD		0x0073	/* read  */
#define PWC_HOUR		0x0074	/* write */
#define PWC_HOUR_RD		0x0075	/* read  */
#define PWC_WEEK		0x0076	/* write */
#define PWC_WEEK_RD		0x0077	/* read  */
#define PWC_DAY			0x0078	/* write */
#define PWC_DAY_RD		0x0079	/* read  */
#define PWC_MONTH		0x007A	/* write */
#define PWC_MONTH_RD	0x007B	/* read  */
#define PWC_YEAR		0x007C	/* write */
#define PWC_YEAR_RD		0x007D	/* read  */
#define PWC_TRIM		0x007E	/* write */
#define PWC_TRIM_RD		0x007F	/* read  */
#define PWC_ALM_WM		0x0080	/* write */
#define PWC_ALM_WM_RD	0x0081	/* read  */
#define PWC_ALM_WH		0x0082	/* write */
#define PWC_ALM_WH_RD	0x0083	/* read  */
#define PWC_ALM_WW		0x0084	/* write */
#define PWC_ALM_WW_RD	0x0085	/* read  */
#define PWC_ALM_DM		0x0086	/* write */
#define PWC_ALM_DM_RD	0x0087	/* read  */
#define PWC_ALM_DH		0x0088	/* write */
#define PWC_ALM_DH_RD	0x0089	/* read  */
#define PWC_RTC1		0x008A	/* write */
#define PWC_RTC1_RD		0x008B	/* read  */
#define PWC_RTC2		0x008C	/* write */
#define PWC_RTC2_RD		0x008D	/* read  */

/* USB register */
#define PWC_USBCONT		0x0090	/* write */

#define PWC_MAX			0x0095

/* GPIO port */
#define PWC_INT_B0		0x00
#define PWC_INT_B1		0x01
#define PWC_INT_B2		0x02
#define PWC_INT_B3		0x03
#define PWC_INT_B4		0x04
#define PWC_INT_B5		0x05
#define PWC_INT_B6		0x06
#define PWC_INT_B7		0x07
#define PWC_INT_MAX		0x07



/* GPIO Output/Input select */
#define PWC_GPIO_OUTPUT	0
#define PWC_GPIO_INPUT	1

extern int  pwc_reg_read(unsigned char addr, unsigned char *data);
extern int  pwc_reg_write(unsigned char addr, unsigned char data);
extern int  pwc_read(unsigned short offset, unsigned int *data);
extern int  pwc_write(unsigned short offset, unsigned int data, unsigned int mask);
extern int  pwc_set_direction(unsigned gpio, int is_input);
extern int  pwc_get_value(unsigned int gpio);
extern void pwc_set_value(unsigned int gpio, int value);
extern int  pwc_get_output_value(unsigned int gpio);

#endif /* _ASM_ARCH_PWC_H_ */
