/* 2010-08-25: File added by Sony Corporation */
/*
 *  File Name	    : include/asm-arm/arch-mp200/smu.h
 *  Function	    : smu
 *  Release Version : Ver 1.02
 *  Release Date    : 2008/09/22
 *
 *  Copyright (C) NEC Electronics Corporation 2006, 2007, 2008
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __ARCH_ARM_MACH_MP200_SMU_H
#define __ARCH_ARM_MACH_MP200_SMU_H

#include <asm/arch/hardware.h>

/* AB0 */

#define AB0_FLASHCOMSET			(IO_ADDRESS(MP200_AB0_BASE) + 0x000)
#define AB0_FLASHCOMLATCH		(IO_ADDRESS(MP200_AB0_BASE) + 0x004)
#define AB0_FLASHCOMADD0		(IO_ADDRESS(MP200_AB0_BASE) + 0x010)
#define AB0_FLASHCOMDATA0		(IO_ADDRESS(MP200_AB0_BASE) + 0x014)
#define AB0_FLASHCOMADD1		(IO_ADDRESS(MP200_AB0_BASE) + 0x018)
#define AB0_FLASHCOMDATA1		(IO_ADDRESS(MP200_AB0_BASE) + 0x01C)

#define AB0_FLASHCLKCTRL		(IO_ADDRESS(MP200_AB0_BASE) + 0x080)
#define AB0_FLA_RCLK_DLY		(IO_ADDRESS(MP200_AB0_BASE) + 0x084)

#define AB0_CS0BASEADD			(IO_ADDRESS(MP200_AB0_BASE) + 0x100)
#define AB0_CS0BITCOMP			(IO_ADDRESS(MP200_AB0_BASE) + 0x104)
#define AB0_CS1BASEADD			(IO_ADDRESS(MP200_AB0_BASE) + 0x110)
#define AB0_CS1BITCOMP			(IO_ADDRESS(MP200_AB0_BASE) + 0x114)
#define AB0_CS2BASEADD			(IO_ADDRESS(MP200_AB0_BASE) + 0x120)
#define AB0_CS2BITCOMP			(IO_ADDRESS(MP200_AB0_BASE) + 0x124)
#define AB0_CS3BASEADD			(IO_ADDRESS(MP200_AB0_BASE) + 0x130)
#define AB0_CS3BITCOMP			(IO_ADDRESS(MP200_AB0_BASE) + 0x134)
#define AB0_CS4BASEADD			(IO_ADDRESS(MP200_AB0_BASE) + 0x140)
#define AB0_CS4BITCOMP			(IO_ADDRESS(MP200_AB0_BASE) + 0x144)
#define AB0_CS5BASEADD			(IO_ADDRESS(MP200_AB0_BASE) + 0x150)
#define AB0_CS5BITCOMP			(IO_ADDRESS(MP200_AB0_BASE) + 0x154)

#define AB0_CS0WAITCTRL			(IO_ADDRESS(MP200_AB0_BASE) + 0x200)
#define AB0_CS0WAITCTRL_W		(IO_ADDRESS(MP200_AB0_BASE) + 0x204)
#define AB0_CS0READCTRL			(IO_ADDRESS(MP200_AB0_BASE) + 0x208)
#define AB0_CS0WAIT_MASK		(IO_ADDRESS(MP200_AB0_BASE) + 0x20C)
#define AB0_CS0CONTROL			(IO_ADDRESS(MP200_AB0_BASE) + 0x210)

#define AB0_CS0FLASHRCR			(IO_ADDRESS(MP200_AB0_BASE) + 0x214)
#define AB0_CS0FLASHWCR			(IO_ADDRESS(MP200_AB0_BASE) + 0x218)

#define AB0_CS1WAITCTRL			(IO_ADDRESS(MP200_AB0_BASE) + 0x220)
#define AB0_CS1WAITCTRL_W		(IO_ADDRESS(MP200_AB0_BASE) + 0x224)
#define AB0_CS1READCTRL			(IO_ADDRESS(MP200_AB0_BASE) + 0x228)
#define AB0_CS1WAIT_MASK		(IO_ADDRESS(MP200_AB0_BASE) + 0x22C)
#define AB0_CS1CONTROL			(IO_ADDRESS(MP200_AB0_BASE) + 0x230)

#define AB0_CS1FLASHRCR			(IO_ADDRESS(MP200_AB0_BASE) + 0x234)
#define AB0_CS1FLASHWCR			(IO_ADDRESS(MP200_AB0_BASE) + 0x238)

#define AB0_CS2WAITCTRL			(IO_ADDRESS(MP200_AB0_BASE) + 0x240)
#define AB0_CS2WAITCTRL_W		(IO_ADDRESS(MP200_AB0_BASE) + 0x244)
#define AB0_CS2READCTRL			(IO_ADDRESS(MP200_AB0_BASE) + 0x248)
#define AB0_CS2WAIT_MASK		(IO_ADDRESS(MP200_AB0_BASE) + 0x24C)
#define AB0_CS2CONTROL			(IO_ADDRESS(MP200_AB0_BASE) + 0x250)

#define AB0_CS2FLASHRCR			(IO_ADDRESS(MP200_AB0_BASE) + 0x254)
#define AB0_CS2FLASHWCR			(IO_ADDRESS(MP200_AB0_BASE) + 0x258)

#define AB0_CS3WAITCTRL			(IO_ADDRESS(MP200_AB0_BASE) + 0x260)
#define AB0_CS3WAITCTRL_W		(IO_ADDRESS(MP200_AB0_BASE) + 0x264)
#define AB0_CS3READCTRL			(IO_ADDRESS(MP200_AB0_BASE) + 0x268)
#define AB0_CS3WAIT_MASK		(IO_ADDRESS(MP200_AB0_BASE) + 0x26C)
#define AB0_CS3CONTROL			(IO_ADDRESS(MP200_AB0_BASE) + 0x270)

#define AB0_CS3FLASHRCR			(IO_ADDRESS(MP200_AB0_BASE) + 0x274)
#define AB0_CS3FLASHWCR			(IO_ADDRESS(MP200_AB0_BASE) + 0x278)

#define AB0_CS4WAITCTRL			(IO_ADDRESS(MP200_AB0_BASE) + 0x280)
#define AB0_CS4WAITCTRL_W		(IO_ADDRESS(MP200_AB0_BASE) + 0x284)
#define AB0_CS4READCTRL			(IO_ADDRESS(MP200_AB0_BASE) + 0x288)
#define AB0_CS4WAIT_MASK		(IO_ADDRESS(MP200_AB0_BASE) + 0x28C)
#define AB0_CS4CONTROL			(IO_ADDRESS(MP200_AB0_BASE) + 0x290)

#define AB0_CS4FLASHRCR			(IO_ADDRESS(MP200_AB0_BASE) + 0x294)
#define AB0_CS4FLASHWCR			(IO_ADDRESS(MP200_AB0_BASE) + 0x298)

#define AB0_CS5WAITCTRL			(IO_ADDRESS(MP200_AB0_BASE) + 0x2A0)
#define AB0_CS5WAITCTRL_W		(IO_ADDRESS(MP200_AB0_BASE) + 0x2A4)
#define AB0_CS5READCTRL			(IO_ADDRESS(MP200_AB0_BASE) + 0x2A8)
#define AB0_CS5WAIT_MASK		(IO_ADDRESS(MP200_AB0_BASE) + 0x2AC)
#define AB0_CS5CONTROL			(IO_ADDRESS(MP200_AB0_BASE) + 0x2B0)

#define AB0_CS5FLASHRCR			(IO_ADDRESS(MP200_AB0_BASE) + 0x2B4)
#define AB0_CS5FLASHWCR			(IO_ADDRESS(MP200_AB0_BASE) + 0x2B8)


#define AB0_CS0WAITCTRL2		(IO_ADDRESS(MP200_AB0_BASE) + 0x300)
#define AB0_CS0WAITCTRL_W2		(IO_ADDRESS(MP200_AB0_BASE) + 0x304)
#define AB0_CS0READCTRL2		(IO_ADDRESS(MP200_AB0_BASE) + 0x308)
#define AB0_CS0WAIT_MASK2		(IO_ADDRESS(MP200_AB0_BASE) + 0x30C)
#define AB0_CS0CONTROL2			(IO_ADDRESS(MP200_AB0_BASE) + 0x310)

#define AB0_CS0FLASHRCR2		(IO_ADDRESS(MP200_AB0_BASE) + 0x314)
#define AB0_CS0FLASHWCR2		(IO_ADDRESS(MP200_AB0_BASE) + 0x318)

#define AB0_CS1WAITCTRL2		(IO_ADDRESS(MP200_AB0_BASE) + 0x320)
#define AB0_CS1WAITCTRL_W2		(IO_ADDRESS(MP200_AB0_BASE) + 0x324)
#define AB0_CS1READCTRL2		(IO_ADDRESS(MP200_AB0_BASE) + 0x328)
#define AB0_CS1WAIT_MASK2		(IO_ADDRESS(MP200_AB0_BASE) + 0x32C)
#define AB0_CS1CONTROL2			(IO_ADDRESS(MP200_AB0_BASE) + 0x330)

#define AB0_CS1FLASHRCR2		(IO_ADDRESS(MP200_AB0_BASE) + 0x334)
#define AB0_CS1FLASHWCR2		(IO_ADDRESS(MP200_AB0_BASE) + 0x338)

#define AB0_CS2WAITCTRL2		(IO_ADDRESS(MP200_AB0_BASE) + 0x340)
#define AB0_CS2WAITCTRL_W2		(IO_ADDRESS(MP200_AB0_BASE) + 0x344)
#define AB0_CS2READCTRL2		(IO_ADDRESS(MP200_AB0_BASE) + 0x348)
#define AB0_CS2WAIT_MASK2		(IO_ADDRESS(MP200_AB0_BASE) + 0x34C)
#define AB0_CS2CONTROL2			(IO_ADDRESS(MP200_AB0_BASE) + 0x350)

#define AB0_CS2FLASHRCR2		(IO_ADDRESS(MP200_AB0_BASE) + 0x354)
#define AB0_CS2FLASHWCR2		(IO_ADDRESS(MP200_AB0_BASE) + 0x358)

#define AB0_CS3WAITCTRL2		(IO_ADDRESS(MP200_AB0_BASE) + 0x360)
#define AB0_CS3WAITCTRL_W2		(IO_ADDRESS(MP200_AB0_BASE) + 0x364)
#define AB0_CS3READCTRL2		(IO_ADDRESS(MP200_AB0_BASE) + 0x368)
#define AB0_CS3WAIT_MASK2		(IO_ADDRESS(MP200_AB0_BASE) + 0x36C)
#define AB0_CS3CONTROL2			(IO_ADDRESS(MP200_AB0_BASE) + 0x370)

#define AB0_CS3FLASHRCR2		(IO_ADDRESS(MP200_AB0_BASE) + 0x374)
#define AB0_CS3FLASHWCR2		(IO_ADDRESS(MP200_AB0_BASE) + 0x378)

#define AB0_CS4WAITCTRL2		(IO_ADDRESS(MP200_AB0_BASE) + 0x380)
#define AB0_CS4WAITCTRL_W2		(IO_ADDRESS(MP200_AB0_BASE) + 0x384)
#define AB0_CS4READCTRL2		(IO_ADDRESS(MP200_AB0_BASE) + 0x388)
#define AB0_CS4WAIT_MASK2		(IO_ADDRESS(MP200_AB0_BASE) + 0x38C)
#define AB0_CS4CONTROL2			(IO_ADDRESS(MP200_AB0_BASE) + 0x390)

#define AB0_CS4FLASHRCR2		(IO_ADDRESS(MP200_AB0_BASE) + 0x394)
#define AB0_CS4FLASHWCR2		(IO_ADDRESS(MP200_AB0_BASE) + 0x398)

#define AB0_CS5WAITCTRL2		(IO_ADDRESS(MP200_AB0_BASE) + 0x3A0)
#define AB0_CS5WAITCTRL_W2		(IO_ADDRESS(MP200_AB0_BASE) + 0x3A4)
#define AB0_CS5READCTRL2		(IO_ADDRESS(MP200_AB0_BASE) + 0x3A8)
#define AB0_CS5WAIT_MASK2		(IO_ADDRESS(MP200_AB0_BASE) + 0x3AC)
#define AB0_CS5CONTROL2			(IO_ADDRESS(MP200_AB0_BASE) + 0x3B0)

#define AB0_CS5FLASHRCR2		(IO_ADDRESS(MP200_AB0_BASE) + 0x3B4)
#define AB0_CS5FLASHWCR2		(IO_ADDRESS(MP200_AB0_BASE) + 0x3B8)




/* S0 */
#define SMU_RESETCTRL0		(IO_ADDRESS(MP200_SMU_BASE) + 0x0000)
#define SMU_RESETREQ0		(IO_ADDRESS(MP200_SMU_BASE) + 0x0004)
#define SMU_RESETREQ0ENA	(IO_ADDRESS(MP200_SMU_BASE) + 0x0008)
#define SMU_RESETREQ1		(IO_ADDRESS(MP200_SMU_BASE) + 0x000c)
#define SMU_RESETREQ1ENA	(IO_ADDRESS(MP200_SMU_BASE) + 0x0010)
 /* reserved:0x0014 */
#define SMU_RESETREQ2		(IO_ADDRESS(MP200_SMU_BASE) + 0x0018)
#define SMU_RESETREQ2ENA	(IO_ADDRESS(MP200_SMU_BASE) + 0x001c)
#define SMU_WDT_INT_RESET	(IO_ADDRESS(MP200_SMU_BASE) + 0x0020)
#define SMU_RESET_PCLK_COUNT	(IO_ADDRESS(MP200_SMU_BASE) + 0x0024)
 /* reserved:0x0028-0x0078 */
#define SMU_AUTO_MODE_EN	(IO_ADDRESS(MP200_SMU_BASE) + 0x007C)
#define SMU_CLK_MODE_SEL	(IO_ADDRESS(MP200_SMU_BASE) + 0x0080)
#define SMU_PLL1CTRL0		(IO_ADDRESS(MP200_SMU_BASE) + 0x0084)
#define SMU_PLL1CTRL1		(IO_ADDRESS(MP200_SMU_BASE) + 0x0088)
#define SMU_PLL2CTRL0		(IO_ADDRESS(MP200_SMU_BASE) + 0x008c)
#define SMU_PLL2CTRL1		(IO_ADDRESS(MP200_SMU_BASE) + 0x0090)
#define SMU_PLL3CTRL0		(IO_ADDRESS(MP200_SMU_BASE) + 0x0094)
#define SMU_PLL3CTRL1		(IO_ADDRESS(MP200_SMU_BASE) + 0x0098)
#define SMU_PLLLOCKTIME		(IO_ADDRESS(MP200_SMU_BASE) + 0x009c)
 /* reserved:0x00a0 */
#define SMU_AUTO_PLL_STANDBY (IO_ADDRESS(MP200_SMU_BASE) + 0x00a8)
 /* reserved:0x00ac-0x00b0 */
#define SMU_PLLVDDWAIT		(IO_ADDRESS(MP200_SMU_BASE) + 0x00b4)
 /* reserved:0x00b8-00c0 */
#define SMU_CLKSTOPSIG_ST	(IO_ADDRESS(MP200_SMU_BASE) + 0x00c4)
#define SMU_CLK32_STATUS	(IO_ADDRESS(MP200_SMU_BASE) + 0x00c8)
#define SMU_POWER_RECORD	(IO_ADDRESS(MP200_SMU_BASE) + 0x00cc)
#define SMU_INT_STATUS		(IO_ADDRESS(MP200_SMU_BASE) + 0x00d0)
#define SMU_INT_RAW_STATUS	(IO_ADDRESS(MP200_SMU_BASE) + 0x00d4)
#define SMU_INT_ENSET		(IO_ADDRESS(MP200_SMU_BASE) + 0x00d8)
#define SMU_INT_ENCLR		(IO_ADDRESS(MP200_SMU_BASE) + 0x00dc)
#define SMU_INT_ENMON		(IO_ADDRESS(MP200_SMU_BASE) + 0x00e0)
#define SMU_INT_CLEAR		(IO_ADDRESS(MP200_SMU_BASE) + 0x00e4)
#define SMU_NORMALA_DIV		(IO_ADDRESS(MP200_SMU_BASE) + 0x00f0)
#define SMU_NORMALB_DIV		(IO_ADDRESS(MP200_SMU_BASE) + 0x00f4)
#define SMU_NORMALC_DIV		(IO_ADDRESS(MP200_SMU_BASE) + 0x00f8)
#define SMU_NORMALD_DIV		(IO_ADDRESS(MP200_SMU_BASE) + 0x00fc)
#define SMU_ECONOMY_DIV		(IO_ADDRESS(MP200_SMU_BASE) + 0x0100)
#define SMU_STANDBY_DIV		(IO_ADDRESS(MP200_SMU_BASE) + 0x0104)
#define SMU_POWERON_DIV		(IO_ADDRESS(MP200_SMU_BASE) + 0x0108)
 /* reserved: 0x0110 */
#define SMU_DIVMSPSCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x0114)
#define SMU_DIVSP0SCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x0118)
#define SMU_DIVSP1SCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x011c)
#define SMU_DIVSP2SCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x0120)
 /* reserved: 0x0124 */
#define SMU_DIVMEMCRCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x0128)
 /* reserved: 0x012C */
#define SMU_DIVLCDLCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x0130)
#define SMU_DIVIICSCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x0134)
#define SMU_TI0TIN_SEL		(IO_ADDRESS(MP200_SMU_BASE) + 0x0138)
#define SMU_TI1TIN_SEL		(IO_ADDRESS(MP200_SMU_BASE) + 0x013c)
#define SMU_TI2TIN_SEL		(IO_ADDRESS(MP200_SMU_BASE) + 0x0140)
#define SMU_TI3TIN_SEL		(IO_ADDRESS(MP200_SMU_BASE) + 0x0144)
#define SMU_TGNTIN_SEL		(IO_ADDRESS(MP200_SMU_BASE) + 0x0148)
#define SMU_DIVTIMTIN		(IO_ADDRESS(MP200_SMU_BASE) + 0x014c)
#define SMU_DIVMWISCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x0150)
#define SMU_DIVDMATCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x0154)
#define SMU_DIVU70SCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x0158)
#define SMU_DIVU71SCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x015c)
#define SMU_DIVU72SCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x0160)
 /* reserved: 0x0164-0x0168 */
#define SMU_DIVPM0SCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x016c)
#define SMU_DIVPM1SCLK		(IO_ADDRESS(MP200_SMU_BASE) + 0x0170)

 /* reserved: 0x0174 */
#define SMU_DIVREFCLK			(IO_ADDRESS(MP200_SMU_BASE) + 0x0178)
 /* reserved: 0x017c-0x180 */
#define SMU_DIVPWMPWCLK	(IO_ADDRESS(MP200_SMU_BASE) + 0x0184)
 /* reserved: 0x0188-0x194 */
#define SMU_AHBCLKCTRL0 	(IO_ADDRESS(MP200_SMU_BASE) + 0x01a0)
#define SMU_AHBCLKCTRL1 	(IO_ADDRESS(MP200_SMU_BASE) + 0x01a4)
#define SMU_APBCLKCTRL0		(IO_ADDRESS(MP200_SMU_BASE) + 0x01a8)
#define SMU_APBCLKCTRL1		(IO_ADDRESS(MP200_SMU_BASE) + 0x01ac)
#define SMU_CLKCTRL			(IO_ADDRESS(MP200_SMU_BASE) + 0x01b0)
#define SMU_GCLKCTRL0		(IO_ADDRESS(MP200_SMU_BASE) + 0x01b4)
#define SMU_GCLKCTRL0ENA	(IO_ADDRESS(MP200_SMU_BASE) + 0x01b8)
#define SMU_GCLKCTRL1		(IO_ADDRESS(MP200_SMU_BASE) + 0x01bc)
#define SMU_GCLKCTRL1ENA	(IO_ADDRESS(MP200_SMU_BASE) + 0x01c0)
#define SMU_GCLKCTRL2		(IO_ADDRESS(MP200_SMU_BASE) + 0x01c4)
#define SMU_GCLKCTRL2ENA	(IO_ADDRESS(MP200_SMU_BASE) + 0x01c8)
#define SMU_GCLKCTRL3		(IO_ADDRESS(MP200_SMU_BASE) + 0x01cc)
#define SMU_GCLKCTRL3ENA	(IO_ADDRESS(MP200_SMU_BASE) + 0x01d0)
/* reserved: 0x01d4-0x01d8 */
#define SMU_AUTO_FRQ_CHANGE	(IO_ADDRESS(MP200_SMU_BASE) + 0x01dc)
#define SMU_AUTO_FRQ_MASK0	(IO_ADDRESS(MP200_SMU_BASE) + 0x01e0)
#define SMU_AUTO_FRQ_MASK1	(IO_ADDRESS(MP200_SMU_BASE) + 0x01e4)
#define SMU_DFS_HALFMODE	(IO_ADDRESS(MP200_SMU_BASE) + 0x01e8)
#define SMU_FLA_CLK_DLY		(IO_ADDRESS(MP200_SMU_BASE) + 0x01f0)
/* reserved: 0x01f4-0x01f8 */
#define SMU_MEMCCLK270_SEL	(IO_ADDRESS(MP200_SMU_BASE) + 0x01fc)
/* reserved: 0x0200-0x0204 */
#define SMU_BGCTRL			(IO_ADDRESS(MP200_SMU_BASE) + 0x0208)
/* reserved: 0x020c-21c */
#define SMU_QR_ENA			(IO_ADDRESS(MP200_SMU_BASE) + 0x0220)
#define SMU_QR_CLKDIV		(IO_ADDRESS(MP200_SMU_BASE) + 0x0224)
/* reserved: 0x0228-0x0234 */
#define SMU_FAKE_MODE		(IO_ADDRESS(MP200_SMU_BASE) + 0x0238)
#define SMU_POWERSW_STATUS	(IO_ADDRESS(MP200_SMU_BASE) + 0x023c)
#define SMU_POWERSW_ENA		(IO_ADDRESS(MP200_SMU_BASE) + 0x0240)
#define SMU_L1_POWERSW		(IO_ADDRESS(MP200_SMU_BASE) + 0x0244)
#define SMU_ACPU_POWERSW	(IO_ADDRESS(MP200_SMU_BASE) + 0x0248)
#define SMU_ADSP_POWERSW	(IO_ADDRESS(MP200_SMU_BASE) + 0x024c)
/* reserved: 0x0250 */
#define SMU_ADSP_BUB		(IO_ADDRESS(MP200_SMU_BASE) + 0x0254)
#define SMU_ACPU_BUB		(IO_ADDRESS(MP200_SMU_BASE) + 0x0258)
#define SMU_POWERSW_ACTRL_EN (IO_ADDRESS(MP200_SMU_BASE) + 0x025c)
#define SMU_LOG1SW_ACTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x0260)
#define SMU_ADSPSW_ACTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x0264)
#define SMU_L1_BUZ			(IO_ADDRESS(MP200_SMU_BASE) + 0x0268)
#define SMU_L1_BUZ2			(IO_ADDRESS(MP200_SMU_BASE) + 0x026c)
#define SMU_ACPUBUFTYPE		(IO_ADDRESS(MP200_SMU_BASE) + 0x0288)
#define SMU_ADSPBUFTYPE		(IO_ADDRESS(MP200_SMU_BASE) + 0x028c)
#define SMU_HXBBUFTYPE		(IO_ADDRESS(MP200_SMU_BASE) + 0x0290)

#define SMU_ACPU_INIT		(IO_ADDRESS(MP200_SMU_BASE) + 0x0360)
#define SMU_MSP_SYSC_OPT0	(IO_ADDRESS(MP200_SMU_BASE) + 0x0368)
#define SMU_AB1_U70WAITCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03c0)
#define SMU_AB1_U71WAITCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03c4)
#define SMU_AB1_U72WAITCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03c8)
#define SMU_AB1_IIC2WAITCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03cc)
#define SMU_AB1_IICWAITCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03d0)
#define SMU_AB1_U70READCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03d4)
#define SMU_AB1_U71READCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03d8)
#define SMU_AB1_U72READCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03dc)
#define SMU_AB1_IIC2READCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03e0)
#define SMU_AB1_IICREADCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03e4)
#define SMU_AB1_SDIBWAITCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03e8)
#define SMU_AB1_SDIBREADCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03ec)
#define SMU_AB1_SDICWAITCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03f0)
#define SMU_AB1_SDICREADCTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x03f4)
#define SMU_FLASHCLK_CTRL		(IO_ADDRESS(MP200_SMU_BASE) + 0x0494)
#define SMU_L2_POWERSW_BUZ	(IO_ADDRESS(MP200_SMU_BASE) + 0x0500)
#define SMU_LOG2SW_ACTRLEN	(IO_ADDRESS(MP200_SMU_BASE) + 0x0504)
#define SMU_LOG2SW_ACTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x0508)
#define SMU_L3_POWERSW_BUZ	(IO_ADDRESS(MP200_SMU_BASE) + 0x050c)
#define SMU_LOG3SW_ACTRLEN	(IO_ADDRESS(MP200_SMU_BASE) + 0x0510)
#define SMU_LOG3SW_ACTRL	(IO_ADDRESS(MP200_SMU_BASE) + 0x0514)

#define SMU_PLL_STATUS		(IO_ADDRESS(MP200_SMU_BASE) + 0x0520)
#define SMU_IO_L0_LM_BUZ	(IO_ADDRESS(MP200_SMU_BASE) + 0x0814)
#define SMU_RESETREQ3		(IO_ADDRESS(MP200_SMU_BASE) + 0x083c)
#define SMU_RESETREQ3ENA	(IO_ADDRESS(MP200_SMU_BASE) + 0x0840)
#define SMU_APBCLKCTRL2		(IO_ADDRESS(MP200_SMU_BASE) + 0x0848)
#define SMU_GCLKCTRL4		(IO_ADDRESS(MP200_SMU_BASE) + 0x084c)
#define SMU_GCLKCTRL4ENA	(IO_ADDRESS(MP200_SMU_BASE) + 0x0850)
#define SMU_AUTO_FRQ_MASK3	(IO_ADDRESS(MP200_SMU_BASE) + 0x0860)
#define SMU_DFS_FIFOMODE	(IO_ADDRESS(MP200_SMU_BASE) + 0x0864)
#define SMU_DFS_FIFO_REQMASK	(IO_ADDRESS(MP200_SMU_BASE) + 0x0868)
#define SMU_LCD_FIFOTHRESHOLD	(IO_ADDRESS(MP200_SMU_BASE) + 0x086c)

#define SMU_DTV_SAFE_RESET	(IO_ADDRESS(MP200_SMU_BASE) + 0x0880)
#define SMU_USB_SAFE_RESET	(IO_ADDRESS(MP200_SMU_BASE) + 0x0884)
#define SMU_CLKCTRL1		(IO_ADDRESS(MP200_SMU_BASE) + 0x088c)
#define SMU_AB1_SDIAWAITCTRL		(IO_ADDRESS(MP200_SMU_BASE) + 0x0890)
#define SMU_AB1_SDIAREADCTRL		(IO_ADDRESS(MP200_SMU_BASE) + 0x0894)
#define SMU_MEMC_HAND_SHAKE_FAKE	(IO_ADDRESS(MP200_SMU_BASE) + 0x08a0)

/* DIV register PLL select value */
#define SMU_PLLSEL_PLL2	(0 << 8)
#define SMU_PLLSEL_PLL3	(1 << 8)
#define SMU_PLLSEL_MASK	(1 << 8)

/* DIV register div value */
#define SMU_DIV1	0x00
#define SMU_DIV2	0x10
#define SMU_DIV4	0x30
#define SMU_DIV6	0x50
#define SMU_DIV8	0x70
#define SMU_DIV10	0x90
#define SMU_DIV12	0xb0
#define SMU_DIV14	0xd0
#define SMU_DIV16	0xf0
#define SMU_DIV20	0x91
#define SMU_DIV24	0xb1
#define SMU_DIV28	0xd1
#define SMU_DIV32	0xf1
#define SMU_DIV40	0x92
#define SMU_DIV48	0xb2
#define SMU_DIV56	0xd2
#define SMU_DIV64	0xf2
#define SMU_DIV80	0x93
#define SMU_DIV96	0xb3
#define SMU_DIV112	0xd3
#define SMU_DIV128	0xf3
#define SMU_DIV160	0x94
#define SMU_DIV192	0xb4
#define SMU_DIV224	0xd4
#define SMU_DIV256	0xf4
#define SMU_DIV_MASK	0xf7

/* TIN register PLL select value */
#define TINTIN_SEL_PLL3		0x00000000	/* TIxTIN */
#define TINTIN_SEL_32768	0x00000001
#define TINTIN_SEL_32K		0x00000002
#define MASK_TINTIN_SEL		0x00000003
#define	TWNTIN_SEL_PLL3		0x00000000	/* TWxTIN */
#define	TWNTIN_SEL_32768	0x00010000
#define	TWNTIN_SEL_32K		0x00020000
#define	MASK_TWNTIN_SEL		0x00030000
#define TGNTIN_SEL_PLL3		0x00000000
#define TGNTIN_SEL_32768	0x00111111
#define TGNTIN_SEL_32K		0x00222222

/*
 * CHG registers
 */
#define CHG_BOOT_MODE		(IO_ADDRESS(MP200_CHG_BASE) + 0x0000)
#define CHG_L1_HOLD			(IO_ADDRESS(MP200_CHG_BASE) + 0x0004)
#define CHG_LSI_REVISION	(IO_ADDRESS(MP200_CHG_BASE) + 0x0010)
#define CHG_CTRL_SDINT		(IO_ADDRESS(MP200_CHG_BASE) + 0x0104)
#define CHG_CTRL_AB0_BOOT	(IO_ADDRESS(MP200_CHG_BASE) + 0x0108)
#define CHG_CTRL_OSC		(IO_ADDRESS(MP200_CHG_BASE) + 0x0110)
#define CHG_PINSEL_G00		(IO_ADDRESS(MP200_CHG_BASE) + 0x0200)
#define CHG_PINSEL_G16		(IO_ADDRESS(MP200_CHG_BASE) + 0x0204)
#define CHG_PINSEL_G32		(IO_ADDRESS(MP200_CHG_BASE) + 0x0208)
#define CHG_PINSEL_G48		(IO_ADDRESS(MP200_CHG_BASE) + 0x020C)
#define CHG_PINSEL_G64		(IO_ADDRESS(MP200_CHG_BASE) + 0x0210)
#define CHG_PINSEL_G80		(IO_ADDRESS(MP200_CHG_BASE) + 0x0214)
#define CHG_PINSEL_G96		(IO_ADDRESS(MP200_CHG_BASE) + 0x0218)
#define CHG_PINSEL_G112		(IO_ADDRESS(MP200_CHG_BASE) + 0x021C)
#define CHG_PINSEL_SP0		(IO_ADDRESS(MP200_CHG_BASE) + 0x0280)
#define CHG_PINSEL_DTV		(IO_ADDRESS(MP200_CHG_BASE) + 0x0284)
#define CHG_PINSEL_SD0		(IO_ADDRESS(MP200_CHG_BASE) + 0x0288)
#define CHG_PINSEL_SD1		(IO_ADDRESS(MP200_CHG_BASE) + 0x028C)
#define CHG_PINSEL_IIC2		(IO_ADDRESS(MP200_CHG_BASE) + 0x0290)
#define CHG_PINSEL_REFCLK0	(IO_ADDRESS(MP200_CHG_BASE) + 0x0294)
#define CHG_PULL_G00		(IO_ADDRESS(MP200_CHG_BASE) + 0x0300)
#define CHG_PULL_G08		(IO_ADDRESS(MP200_CHG_BASE) + 0x0304)
#define CHG_PULL_G16		(IO_ADDRESS(MP200_CHG_BASE) + 0x0308)
#define CHG_PULL_G24		(IO_ADDRESS(MP200_CHG_BASE) + 0x030C)
#define CHG_PULL_G32		(IO_ADDRESS(MP200_CHG_BASE) + 0x0310)
#define CHG_PULL_G40		(IO_ADDRESS(MP200_CHG_BASE) + 0x0314)
#define CHG_PULL_G48		(IO_ADDRESS(MP200_CHG_BASE) + 0x0318)
#define CHG_PULL_G56		(IO_ADDRESS(MP200_CHG_BASE) + 0x031C)
#define CHG_PULL_G64		(IO_ADDRESS(MP200_CHG_BASE) + 0x0320)
#define CHG_PULL_G72		(IO_ADDRESS(MP200_CHG_BASE) + 0x0324)
#define CHG_PULL_G80		(IO_ADDRESS(MP200_CHG_BASE) + 0x0328)
#define CHG_PULL_G88		(IO_ADDRESS(MP200_CHG_BASE) + 0x032C)
#define CHG_PULL_G96		(IO_ADDRESS(MP200_CHG_BASE) + 0x0330)
#define CHG_PULL_G104		(IO_ADDRESS(MP200_CHG_BASE) + 0x0334)
#define CHG_PULL_G112		(IO_ADDRESS(MP200_CHG_BASE) + 0x0338)
#define CHG_PULL_G120		(IO_ADDRESS(MP200_CHG_BASE) + 0x033C)
#define CHG_PULL0			(IO_ADDRESS(MP200_CHG_BASE) + 0x0380)
#define CHG_PULL1			(IO_ADDRESS(MP200_CHG_BASE) + 0x0384)
#define CHG_PULL2			(IO_ADDRESS(MP200_CHG_BASE) + 0x0388)
#define CHG_PULL3			(IO_ADDRESS(MP200_CHG_BASE) + 0x038C)
#define CHG_DRIVE0			(IO_ADDRESS(MP200_CHG_BASE) + 0x0400)
#define CHG_DRIVE1			(IO_ADDRESS(MP200_CHG_BASE) + 0x0404)
#define CHG_DRIVE2			(IO_ADDRESS(MP200_CHG_BASE) + 0x0408)


#endif	/* ARCH_ARM_MACH_MP200_SMU_H */
