/* 2009-04-13: File added by Sony Corporation */
/*
 *  Copyright 2009 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __ASM_ARM_ARCH_MP200_UDC_H
#define __ASM_ARM_ARCH_MP200_UDC_H

#define MP200_UDC_ULPI_ACTIVE	1
#define MP200_UDC_ULPI_INACTIVE	0

struct mp200_udc;

struct mp200_udc_platform_data
{
	void (*udc_enable_phy)(struct mp200_udc *udc);
	void (*udc_disable_phy)(struct mp200_udc *udc);

	void (*udc_enable_power_save_mode)(struct mp200_udc *udc);
	void (*udc_disable_power_save_mode)(struct mp200_udc *udc);

	int  (*udc_probe)(struct mp200_udc *udc);
	void (*udc_remove)(struct mp200_udc *udc);

	void (*udc_check_vbus)(struct mp200_udc *udc);

	void (*udc_enable_vbus_int)(struct mp200_udc *udc);
	void (*udc_disable_vbus_int)(struct mp200_udc *udc);

	int  (*udc_is_ulpi_active)(struct mp200_udc *udc);
};

#endif /* __ASM_ARM_ARCH_MP200_UDC_H */
