/* 2010-08-25: File added by Sony Corporation */
/*
 * linux/include/asm-arm/arch-omap/board-omap3evm.h
 *
 * Hardware definitions for TI OMAP3EVM board.
 *
 * Initial creation by Syed Mohammed Khasim
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __ASM_ARCH_OMAP_OMAP3EVM_H
#define __ASM_ARCH_OMAP_OMAP3EVM_H


/* IMPORTANT : MAPPING ON OMAP3EVM
 *
 * NAND always on	0x30000000
 * OneNand Mapped to	0x20000000
 */

#define NAND_BASE		0x0C000000	/* NAND flash    */
#define ONENAND_MAP		0x20000000	/* OneNand flash */

#define PRCM_WAKEUP_T2_KEYPAD	0x1
#define PRCM_WAKEUP_TOUCHSCREEN	0x2
#define PRCM_WAKEUP_UART1	0x4

#define OMAP3_WAKEUP		(PRCM_WAKEUP_T2_KEYPAD | \
					PRCM_WAKEUP_TOUCHSCREEN)

/*
 * Support for TWL4030
 */
#ifdef CONFIG_TWL4030_CORE

#define TWL4030_IRQNUM INT_34XX_SYS_NIRQ

/* TWL4030 Primary Interrupt Handler (PIH) interrupts */
#define	IH_TWL4030_BASE		IH_BOARD_BASE
#define	IH_TWL4030_END		(IH_TWL4030_BASE+8)

#ifdef CONFIG_TWL4030_GPIO
/* TWL4030 GPIO Interrupts */
#define IH_TWL4030_GPIO_BASE	(IH_TWL4030_END)
#define IH_TWL4030_GPIO_END	(IH_TWL4030_BASE+18)
#define NR_IRQS			(IH_TWL4030_GPIO_END)
#else
#define NR_IRQS			(IH_TWL4030_END)
#endif /* CONFIG_TWL4030_GPIO */

#endif /* CONFIG_TWL4030_CORE */

#endif /*  __ASM_ARCH_OMAP_OMAP3EVM_H */
