/* 2010-08-25: File added by Sony Corporation */
/*
 * include/asm-arm/arch-omap/nand.h
 *
 * Copyright (C) 2006 Micron Technology Inc.
 * Author: Shahrom Sharif-Kashani
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include <linux/mtd/partitions.h>

struct omap_nand_platform_data {
	int			cs;
	int			gpio_irq;
	struct mtd_partition	*parts;
	int			nr_parts;
	int			(*nand_setup)(void __iomem *);
	int			dma_channel;
	void __iomem		*gpmc_cs_baseaddr;
	void __iomem		*gpmc_baseaddr;
	unsigned int		(*dev_ready) (struct omap_nand_platform_data *data);
	unsigned int		plat_options;
	unsigned int		options;
	char			device_width;
};

/* Platform specific options definitions */
#define NAND_WAITPOL_LOW        0 << 0
#define NAND_WAITPOL_HIGH       1 << 0
#define NAND_WAITPOL_MASK       1 << 0

