/* 2008-02-27: File added by Sony Corporation */
/*
 *  ARM definitions for tracing system
 *
 *  Copyright 2008 Sony Corporation
 *
 * This program is free software; you can redistribute	it and/or modify it
 * under  the terms of	the GNU General	 Public License as published by the
 * Free Software Foundation;  either version 2 of the  License.
 *
 * THIS	 SOFTWARE  IS PROVIDED	 ``AS  IS'' AND	  ANY  EXPRESS OR IMPLIED
 * WARRANTIES,	 INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.	 IN
 * NO  EVENT  SHALL   THE AUTHOR  BE	LIABLE FOR ANY	 DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED	 TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 * USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN	CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * You should have received a copy of the  GNU General Public License along
 * with this program; if not, write  to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _ASM_ARM_LTT_H
#define _ASM_ARM_LTT_H

#define LTT_HAS_TSC

/* Current arch type */
#define LTT_ARCH_TYPE LTT_ARCH_TYPE_ARM

/* Current variant type */
#define LTT_ARCH_VARIANT LTT_ARCH_VARIANT_NONE

#include <linux/ltt-core.h>
#include <linux/sched.h>
#include <asm/processor.h>

static inline u32 ltt_get_timestamp32(void)
{
        return (u32)sched_clock();
}

static inline u64 ltt_get_timestamp64(void)
{
        return sched_clock();
}

static inline void ltt_add_timestamp(unsigned long ticks)
{ }

static inline unsigned int ltt_frequency(void)
{
	return 1000000000;
}

static inline u32 ltt_freq_scale(void)
{
	return 1;
}

#endif /* _ASM_ARM_LTT_H */
