/* 2009-02-03: File added and changed by Sony Corporation */
/*
 *  Copyright 2009 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _SNSC_BACKTRACE_H_
#define _SNSC_BACKTRACE_H_

#include <linux/compiler.h>

#define BT_IOCTL_ADDRS 1
#define BT_IOCTL_SYMBOL 2

struct bt_ioctl_addrs {
	void ** __user ba_buf;
	int ba_size;
	void * __user ba_skip_addr;
};

struct bt_ioctl_symbol {
	void * __user bs_addr;
	char * __user bs_buf;
	int bs_size;
};

#ifdef __KERNEL__

#include <asm/snsc/snsc_backtrace.h>

extern int bt_orig_backtrace_enabled(void);
extern const char *bt_param_match(const char *param, const char *name);
extern char bt_param[];
extern int bt_ustack_user(struct bt_session *session, struct bt_ioctl_addrs *arg);
extern int bt_find_symbol(unsigned long addr, struct bt_session *session,
			  char *buf, unsigned long buflen,
			  struct bt_arch_callback_arg *cbarg);
extern int bt_ustack_task_buf(char *buf, size_t size,
			      struct task_struct *task,
			      const char *mode, int is_atomic);
#endif /* __KERNEL__ */

#endif /* _SNSC_BACKTRACE_H_ */
