/* 2010-08-25: File added by Sony Corporation */
/*
 *  File Name	    : include/sound/mp200_pcm_ioctl.h
 *  Function	    : audio interface for the MP200
 *  Release Version : Ver 1.00
 *  Release Date    : 2008/05/30
 *
 *  Copyright (C) NEC Electronics Corporation 2007-2008
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __SOUND_MP200_PCM_IOCTL_H
#define __SOUND_MP200_PCM_IOCTL_H

#include <asm/ioctl.h>

/* mode_sel : Operation mode */
#define PCM_MODE_0		0	/* mode 0 */
#define PCM_MODE_1		1	/* mode 1 */
#define PCM_MODE_2		2	/* mode 2 (I2S Format) */
#define PCM_MODE_3		3	/* mode 3 (MSB First)  */
#define PCM_MODE_4		4	/* mode 4 (LSB First)  */
#define PCM_MODE_5		5	/* mode 5 (Multi Channel Mode) */
#define PCM_MODE_6		6	/* mode 6 (Multi Channel Mode) */

/* m_s : Master/Slave */
#define PCM_MASTER_MODE		0	/* Master */
#define PCM_SLAVE_MODE		1	/* Slave  */

/* tx_tim : Transmission timing */
#define PCM_TX_30_WORD		0	/* 30word */
#define PCM_TX_16_WORD		1	/* 16word */
#define PCM_TX_08_WORD		2	/*  8word */
#define PCM_TX_04_WORD		3	/*  4word */

/* rx_pd : Data padding (RX) */
/* tx_pd : Data padding (TX) */
#define PCM_PADDING_OFF		0	/* Data padding non */
#define PCM_PADDING_ON		1	/* Data padding */


typedef struct pcm_ctrl {
	struct func_sel {
		unsigned char mode_sel;	/* Operation mode */
		unsigned char m_s;	/* Master/Slave */
		unsigned char tx_tim;	/* Transmission timing */
	} func;
	struct cycle {
		unsigned char cyc_val;	/* Frame length */
		unsigned char sib;	/* Data bit length (PMx_SI) */
		unsigned char rx_pd;	/* Data padding (RX) */
		unsigned char sob;	/* Data bit length (PMx_SO) */
		unsigned char tx_pd;	/* Data padding (TX) */
	} cyc;
	struct cycle2 {
		unsigned char cyc_val2;	/* Frame length */
		unsigned char sib2;	/* Data bit length (PMx_SI) */
		unsigned char sob2;	/* Data bit length (PMx_SO) */
	} cyc2;
} pcm_ctrl_t;

#define SNDRV_MP200_IOCTL_PCM_SET_CTRL	_IOW('H', 0x11, pcm_ctrl_t)
#define SNDRV_MP200_IOCTL_PCM_GET_CTRL	_IOR('H', 0x12, pcm_ctrl_t)

#endif	/* __SOUND_MP200_PCM_IOCTL_H */

